/*-----------------------------------*/ 
void calc_AZEL() 
{ 
   // konvertiere Alpha/Delta nach Azimut/Elevation 
   /* Formel: 
      d= delta 
      t= Stundenwinkel 
      p= Phi (lokale Breite) 
      h= Elevation 
      a= Azimut 
 
     h = arcsin(sin p * sin d + cos p * cos d * cos t) 
 
		  cos h + cos p * sin d - sin p * cos d * cos t 
     a = 2arctan (---------------------------------------------) 
			      cos d * sin t 
     wenn a<0 : a=a+360 (Grad) 
   */ 
 
   double fld_T_rad; 
   double fld_DE_rad; 
   double fld_PHI_rad; 
   double fld_AZ_rad; 
   double fld_EL_rad; 
   double fld_sinphi; 
   double fld_sinde; 
   double fld_sint; 
   double fld_cosphi; 
   double fld_cosde; 
   double fld_cost; 
   double fld_cosh; 
   double temp1; 
   double temp2; 
 
   /* wenn fld_sw=0 : Rechnerabsturz da Division durch 0 
      deswegen: 
   */ 
   if (fld_SW==0) fld_SW=1./(20.*3600.*15.); 
   fld_T_rad=(fld_SW*15.)/gradradfaktor; 
   fld_DE_rad=fld_DE/gradradfaktor; 
   fld_PHI_rad=HD_Breite/gradradfaktor; 
 
   fld_sinphi=sin(fld_PHI_rad); 
   fld_sinde=sin(fld_DE_rad); 
   fld_sint=sin(fld_T_rad); 
   fld_cosphi=cos(fld_PHI_rad); 
   fld_cosde=cos(fld_DE_rad); 
   fld_cost=cos(fld_T_rad); 
   fld_cosh=cos(fld_T_rad); 
 
   temp1=fld_sinphi*fld_sinde+fld_cosphi*fld_cosde*fld_cost; 
   fld_EL_rad=asin(temp1); 
   fld_EL=gradradfaktor*fld_EL_rad; 
   fld_cosh=cos(fld_EL_rad); 
   temp1=fld_cosh+fld_cosphi*fld_sinde-fld_sinphi*fld_cosde*fld_cost; 
   temp2=fld_cosde*fld_sint; 
   fld_AZ_rad=2*atan(temp1/temp2); 
   fld_AZ=gradradfaktor*fld_AZ_rad; 
   if (fld_AZ<0) fld_AZ=fld_AZ+360.; 
/* 
   gotoxy(1,14); 
   printf("T       [rad] %5.10f\n",fld_T_rad); 
   printf("DE      [rad] %5.10f\n",fld_DE_rad); 
   printf("PHI     [rad] %5.10f\n",fld_PHI_rad); 
   printf("sin(PHI)[rad] %5.10f\n",fld_sinphi); 
   printf("sin(DE) [rad] %5.10f\n",fld_sinde); 
   printf("sin(T)  [rad] %5.10f\n",fld_sint); 
   printf("cos(PHI)[rad] %5.10f\n",fld_cosphi); 
   printf("cos(DE) [rad] %5.10f\n",fld_cosde); 
   printf("cos(T)  [rad] %5.10f\n",fld_cost); 
   printf("EL      [grd] %5.10f\n",fld_EL); 
   printf("AZ      [grd] %5.10f\n",fld_AZ); 
*/ 
   // conv_AZ_ftoint() 
   ui_AZgrd=int(fld_AZ); 
   ui_AZmin=int((fld_AZ-ui_AZgrd)*60); 
   ui_AZsec=int((fld_AZ-ui_AZgrd-ui_AZmin/60.)*3600.); 
   ui_AZzsec=int((fld_AZ-ui_AZgrd-ui_AZmin/60.-ui_AZsec/3600.)*36000.); 
 
   // conv_EL_ftoint() 
   if (fld_EL<0) 
      { 
      ui_ELsgn=1; 
      fld_EL=fld_EL*-1; 
      } 
   else 
      ui_ELsgn=0; 
 
   ui_ELgrd=int(fld_EL); 
   ui_ELmin=int((fld_EL-ui_ELgrd)*60); 
   ui_ELsec=int((fld_EL-ui_ELgrd-ui_ELmin/60.)*3600.); 
   ui_ELzsec=int((fld_EL-ui_ELgrd-ui_ELmin/60.-ui_ELsec/3600.)*36000.); 
} 


