DEFI/PARA P1 ? ? "file name with raw image"
DEFI/PARA P2 ? ? "file name of the extracted spectrum"
DEFI/PARA P3 fors_resp ? "table with response functions"

DEFI/LOCA TIME/R/1/1 {{P1},O_TIME(7)}
DEFI/LOCA AIRM/R/1/1 {{P1},ESO.TEL.AIRM.START}
DEFI/LOCA GRISM/C/1/4 {{P1},ESO.INS.OPTI6.NAME(6:9)}
DEFI/LOCA DLAMB/R/1/1 {{P2},STEP(1)}

DEFI/LOCA AREA/R/1/1 0.0
DEFI/LOCA hc/d/1/1 0.0
DEFI/LOCA GAIN/R/1/1 2.89	!	e-/adu
DEFI/LOCA h/d/1/1 6.62e-27	!	erg*s
DEFI/LOCA c/d/1/1 3.0e+10	!	cm/s

hc = h * c			!	erg*cm
AREA = 3.14 * 405**2		! 	cm**2

IF "{{P1},ESO.INS.OPTI7.NAME}" .NE. "*free*" THEN
	WRITE/OUT "WARNING: filter {{P1},ESO.INS.OPTI7.NAME} has not been considered"
ENDIF

EXTI/SPEC {P2} midde {AIRM} atmoexan 2

!
!			middf in	e-/(A*cm**2*s)
!
COMP/IMAG middf = midde * {GAIN} / ({DLAMB} * {AREA} * {TIME})	


!
!	convert response in photons/e- to response in erg/e-
!	1e- 	has	{hc}/(:lamb{GRISM}*1.0e-8) erg
!
CREA/COLU {P3} :tmp R*8
COMP/TABL {P3} :tmp = :resp{GRISM} * (:lamb{GRISM} * 1.0e-8) / {hc}
CONV/TABL {P3} = {P3} :lamb{GRISM} :tmp middf SPLINE

COMP/IMAG f{P2} = middf / {P3}

!PLOT f{P2}

!DELE/COLU {P3} :tmp





