!	fors_extract_slit.prg	Thomas Szeifert		1998-12-05
!
!	extract spectra from modes MOS or LONG, subtract sky and do a raw
!	wave length calibration from the calculation of the grism parameters
!	and the position of the slitlets and long slits



DEFI/PARA P1 ? ? "input frame"
DEFI/PARA P2 N ? "wave length range to plot"
DEFI/PARA P3 1024 ? "xbin"
DEFI/PARA P4 1,2046 ? "y upper & lower position to extract (LONG mode)"

DEFI/LOCA I/I/1/1 0		
DEFI/LOCA ENDI/I/1/1 0
DEFI/LOCA ISTRG/I/1/1 0
DEFI/LOCA IN_N/C/1/32 " " all
DEFI/LOCA IYPOS/I/1/1 0
DEFI/LOCA LSLITTBL/C/1/80 "long_slit"
DEFI/LOCA IYUPLOW/I/1/2 {P4}

DEFI/LOCA FECCDPAR/C/1/80 	"7,2.9"		! sky, extract
DEFI/LOCA FEREJTHRES/R/1/1 	5
DEFI/LOCA FESKYPAR/I/1/1 	2
DEFI/LOCA FEEXTPAR/c/1/10 	7,4
DEFI/LOCA FETHRESH/R/1/1 	-0.06		! define
DEFI/LOCA FEXBIN/I/1/1 		400
DEFI/LOCA FEWIND/I/1/1 		12
DEFI/LOCA FEINT_LIM/r/1/1 	1.0e-6
DEFI/LOCA FECUTS/C/1/20 	-150,150	! load


IF "{{P1},ESO.INS.OPTI2.TYPE}" .EQ. "MOS" THEN
	@s forsslits.prg {P1} 1
ELSE IF "{{P1},ESO.INS.OPTI2.TYPE}" .EQ. "SLIT" THEN
	SELE/TABL {LSLITTBL} :SLIT_NAME.EQ."*{{P1},ESO.INS.OPTI2.NAME}*"
  	SELE/TABL {LSLITTBL} SELECT.AND.:COLLIMATOR.EQ."*{{P1},ESO.INS.OPTI3.NAME}*"
  	COPY/TABL {LSLITTBL} mos_long
	SET/MOS MOS=mos_long.tbl
	{MOS},:ystart,@1 = {IYUPLOW(1)}
	{MOS},:yend,@1 = {IYUPLOW(2)}
ELSE
	WRITE/OUT "ERROR: {P1} is not taken in spectroscopic mode!"
	RETURN
ENDIF

@s world2pixel 	 {P1}
ASSI/GRAP



SET/MOS INT_LIM={FEINT_LIM}
DEFI/MOS {P1} {MOS} middwind {FETHRESH} {FEWIND} {FEXBIN} {P3} 0

SKYF/MOS {P1} {MOS} middwind middsky1 {FESKYPAR} POLYNOM {FECCDPAR},{FEREJTHRES}
COM/IMAG middsub = {P1} - middsky1
LOAD middsub scale=-3 cuts={FECUTS}
DEFI/SLIT LOAD P5={MOS}
DEFI/MOS middsub {MOS} middwind {FETHRESH} {FEWIND} {FEXBIN}  {P3} 2
SORT/TABL middwind :obj_slit


SKYF/MOS {P1} {MOS} middwind middsky  {FESKYPAR} POLYNOM {FECCDPAR},{FEREJTHRES}
COM/IMAG middsub = {P1} - middsky
load middsub scale=-3 cuts={FECUTS}
EXTR/MOS {P1} middsky middwind middext {FEEXTPAR} {FECCDPAR} {FEREJTHRES}

ENDI = {middext,NPIX(2)} / 2


	

SET/MOS REBSTRT=0 REBEND=0 REBSTP=1e+5
IF "{{P1},ESO.INS.OPTI6.NAME}" .EQ. "GRIS_150I" THEN
   IF {{P1},REFPIX(1)} .EQ. 1 THEN
	@s quickmoscalifors {P1} 3 ? ? 1033 P8=1	!	PATCH CENTER=1
   ELSE
	@s quickmoscalifors {P1} 3 P8=1
   ENDIF
ELSE
   IF {{P1},REFPIX(1)} .EQ. 1 THEN
	@s quickmoscalifors {P1} 7 ? ? 1033 P8=1	!	PATCH CENTER=1
   ELSE
	@s quickmoscalifors {P1} 7 P8=1
   ENDIF
ENDIF

REB1D/MOS  middext.bdf test
ENDI = {middext,NPIX(2)} / 2
DO I = 1 {ENDI}
  WRITE/KEY IN_N test{I}  
  SET/FORM F7.0	I1
  WRITE/OUT "Slit: {middwind.tbl,:Obj_Slit,@{I}} {middwind.tbl,:Obj_Strt,@{I}},{middwind.tbl,:Obj_End,@{I}}"
  IYPOS = ({middwind.tbl,:Obj_Strt,@{I}} + {middwind.tbl,:Obj_End,@{I}})/2 
  ISTRG = M$INDEXB(P1,".fits")
  IF ISTRG .GT. 0 THEN
    RENA/IMAG {IN_N} obj{P1(1:{ISTRG})}{middwind.tbl,:Obj_Slit,@{I}}.{IYPOS}.bdf 
    @s fors_cali_flux {P1} obj{P1(1:{ISTRG})}{middwind.tbl,:Obj_Slit,@{I}}.{IYPOS}.bdf
    WRITE/OUT "in file fobj{P1(1:{ISTRG})}{middwind.tbl,:Obj_Slit,@{I}}.{IYPOS}.bdf"
  ELSE IF M$INDEXB(P1,".bdf") .GT. 0 THEN
    RENA/IMAG {IN_N}  obj{P1(1:{ISTRG})}{middwind.tbl,:Obj_Slit,@{I}}.{IYPOS}.bdf 
    @s fors_cali_flux {P1} obj{P1(1:{ISTRG})}{middwind.tbl,:Obj_Slit,@{I}}.{IYPOS}.bdf
    WRITE/OUT "in file fobj{P1(1:{ISTRG})}{middwind.tbl,:Obj_Slit,@{I}}.{IYPOS}.bdf"
  ENDIF	
  IF "{P2}" .NE. "N" THEN	
    PLOT fobj{P1(1:{ISTRG})}{middwind.tbl,:Obj_Slit,@{I}}.{IYPOS}.bdf ? {P2}
  ELSE
    PLOT fobj{P1(1:{ISTRG})}{middwind.tbl,:Obj_Slit,@{I}}.{IYPOS}.bdf ? {REBSTRT},{REBEND}
  ENDIF
  SET/FORM
  WAIT/SECS 1
ENDDO







RETURN



