#include <stdio.h>
#include <stdlib.h>
#include <midas_def.h>

#define STRLEN 80

#ifdef __STDC__
int outframes (char append[], char catfil[], double start[], double step[], 
	       int npix[], int naxis[], int imnol[], char outima[], 
	       char outerr[], int imno[], int imno_err[])
#else
     int outframes (append, catfil,  start, step, npix, naxis, 
		    imnol, outima, outerr,
		    imno, imno_err)
     char append[], catfil[], outima[], outerr[];
     double start[],  step[]; 
     int npix[], naxis[], imno[], imno_err[], imnol[];
#endif

{
  int unit, fsize, stat;
  char output[2 * STRLEN + 1];
  size_t i;

  i = strlen(catfil);
  strncpy(outima,catfil,i);
  strncpy(outerr,catfil,i);
  outima[i] = append[0];
  outerr[i] = append[0];
  outima[i+1] = '\0';
  outerr[i+1] = 'E';
  outerr[i+2] = '\0';

  sprintf(output,"...Stokes parameter: %c   ...in output frames: %s %s",
	  append[0],outima,outerr);
  stat = SCTPUT(output);

  fsize = (naxis[0] == 1) ? npix[0]: npix[0]*npix[1];
  stat = SCFCRE( outima, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, imno );
  stat = SCFCRE( outerr, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, imno_err );

  stat = SCDCOP( imnol[0], imno[0], 1, NULL ); 
  stat = SCDWRD( imno[0], "START", start, 1, naxis[0], &unit );
  stat = SCDWRD( imno[0], "STEP", step, 1, naxis[0], &unit );
  stat = SCDWRI( imno[0], "NAXIS", naxis, 1, 1, &unit );
  stat = SCDWRI( imno[0], "NPIX", npix, 1, naxis[0], &unit );
  
  stat = SCDCOP( imnol[0], imno_err[0], 1, NULL ); 
  stat = SCDWRD( imno_err[0], "START", start, 1, naxis[0], &unit );
  stat = SCDWRD( imno_err[0], "STEP", step, 1, naxis[0], &unit );
  stat = SCDWRI( imno[0], "NAXIS", naxis, 1, 1, &unit );
  stat = SCDWRI( imno_err[0], "NPIX", npix, 1, naxis[0], &unit );

  return 1;
}
/*---------------------------------------------------------------------------*/
