! @(#)pol2dplot.prg
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.IDENTIFICATION: POL2DPLOT.PRG
!.PURPOSE:        MIDAS procedure to plot imaging polarimetric data
!                 par1 = frame with degree of polarization
!                 par2 = frame with angle  of polarization
!                 par3 = x-axis coordinate string
!                 par4 = y-axis coordinate string
!                 par5 = sc_x,sc_y,off_x,off_y (defaults device filling)
!                 par6 = label along the X-axis
!                 par7 = label along the Y-axis
!                 par8 = scale for degree (units/100%)
!.VERSION:        950612  OS creation
!-------------------------------------------------------------------------

IF MID$PLOT(1:5) .EQ. "IMAGE" THEN                  ! here for display window
   DEFINE/LOCAL NK1/I/1/1 0
   SET/FORMAT I1
   define/param p8 * ima
   copy/keyw p8 in_a
   IF in_a .NE. " " THEN
      define/param p3 [{idimemr(1)},{idimemr(2)}:{idimemr(3)},{idimemr(4)}]
      IF P3(1:1) .EQ. "[" THEN
         DEFINE/PARAM P3 [<,<:>,>]
         DEFINE/PARAM P4 "" C
         DEFINE/PARAM P5 "" C
         DEFINE/LOCAL LABELX/C/1/80 {P4}
         DEFINE/LOCAL LABELY/C/1/40 {P5}
         GOTO FINISH
      ENDIF
   ENDIF
ENDIF
!
DEFINE/PARAM P5 0.,0.,-999,-999 NUM
@ plscoff {P5}                                     ! get the scales and offsets
DEFINE/PARAM   P6 "" C
DEFINE/PARAM   P7 "" C
DEFINE/LOCAL LABELX/C/1/80 {P6}
DEFINE/LOCAL LABELY/C/1/80 {P7}
!
FINISH:
IF MID$CMND(1:1) .EQ. "P" THEN
   IF PLRSTAT(1) .EQ. 0 .AND. PLRSTAT(2) .EQ. 0 THEN     ! x axis manually set?
      DEFINE/PARAM P3 0.0,1.0,0.25,0.05 C
   ELSE
      DEFINE/PARAM P3 {PLRSTAT(1)},{PLRSTAT(2)},{PLRSTAT(3)},{PLRSTAT(4)} C
   ENDIF
   IF PLRSTAT(5) .EQ. 0 .AND. PLRSTAT(6) .EQ. 0 THEN     ! y axis manually set?
      DEFINE/PARAM P4 0.0,1.0,0.25,0.05 C
   ELSE
      DEFINE/PARAM P4 {PLRSTAT(5)},{PLRSTAT(6)},{PLRSTAT(7)},{PLRSTAT(8)} C
   ENDIF
ELSE                                                     ! over plot mode
   DEFINE/PARAM P3 {PLRGRAP(1)},{PLRGRAP(2)},{PLRGRAP(3)},{PLRGRAP(4)} C
   DEFINE/PARAM P4 {PLRGRAP(5)},{PLRGRAP(6)},{PLRGRAP(7)},{PLRGRAP(8)} C
ENDIF
!
! *** all done: now do the job
WRITE/KEY IN_A {P1}
WRITE/KEY IN_B {P2}
WRITE/KEY P8 ?
DEFINE/PARAM P8 10.0 NUM 
WRITE/KEY INPUTR {P8}
!
RUN STD_EXE:IPOL2DPLOT
WRITE/KEYW    PLCDATA/C/1/60   "unknown"
WRITE/KEYW    PLCDATA/C/61/20  "unknown"
@ sendplot
