! @(#)ipolintegrate.prg	2.0 (LSW-HD) 2/9/98





DEFINE/PARAM P1 {INT_MODE} CHAR "integration mode: A(ligned)/O(rigianl):"

IF P1 .eq. "A" THEN

  DEFINE/PARAM P2 {IPOL_TAB}EX TABLE   "Enter IPOL table:"
  DEFINE/PARAM P3 {SC_SKY}     CHAR    "Enter table column for input images:"
  DEFINE/PARAM P4 ? NUMB "integration radius"
  DEFINE/PARAM P5 ? NUMB "read-out-noise (e-), gain (e-/ADU)"
  DEFINE/PARAM P6 ? CHAR "First try or All frames? (def: F)"

ELSE 

  DEFINE/PARAM P2 {IPOL_TAB} TABLE   "Enter IPOL table:"
  DEFINE/PARAM P3 {SC}       CHAR    "Enter table column for input images:"
  DEFINE/PARAM P4 ? NUMB "[Dsiz,Fsiz,Nsiz,Bsiz] -- pixels       "
  DEFINE/PARAM P5 ? NUMB "[RON,gain,Nsigma]
  DEFINE/PARAM P6 ? CHAR "First try or All frames? (def: F)"
  DEFINE/PARAM P7 - ? "Approx. FWHM X,Y" 	
  DEFINE/PARAM P8 1 ? "DEBUG level quiet=-1 nodebug=0 debug=1 more=2"

ENDIF



!
!------------------------------------------------------------------------------
! Local keys ...
!------------------------------------------------------------------------------
! ... for sorting ...
!------------------------------------------------------------------------------
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL II/I/1/1 0.
DEFINE/LOCAL NUMROW/I/1/1 0.
!------------------------------------------------------------------------------
! ... for input frames/tables/angles
!------------------------------------------------------------------------------
DEFINE/LOCAL INIMA/C/1/60 " " ALL
DEFINE/LOCAL REFIMA/C/1/60 " " ALL
DEFINE/LOCAL IMA/C/1/60 " " ALL
DEFINE/LOCAL NOISE/R/1/1 0.
DEFINE/LOCAL TRY/C/1/1 F
DEFINE/LOCAL RET_ANG/I/1/1 0
DEFINE/LOCAL TMPR/R/1/1 0.0
DEFINE/LOCAL OUTTABO/C/1/40 " " ALL
DEFINE/LOCAL OUTTABE/C/1/40 " " ALL
DEFINE/LOCAL INTABO/C/1/40 " " ALL
DEFINE/LOCAL INTABE/C/1/40 " " ALL
DEFINE/LOCAL CCD/R/1/4 {P5},0,0,0,0
WRITE/KEY TMP/C/1/60 " " ALL





!------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!------------------------------------------------------------------------------
IF P6(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P6}
ENDIF
!------------------------------------------------------------------------------
! Initialize columns to hold names of output tables
!------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P2}
WRITE/KEY INPUTC/C/1/17 {FLUXE}
RUN STD_EXE:spolcolini
WRITE/KEY INPUTC/C/1/17 {FLUXO}
RUN STD_EXE:spolcolini
!------------------------------------------------------------------------------
! Get number of rows in ipol_tab
!------------------------------------------------------------------------------
COPY/DK {P2}.tbl TBLCONTR/I/4/4 NUMROW
!------------------------------------------------------------------------------
! Create output table to holde ALL results
!------------------------------------------------------------------------------
CREA/TAB {ipol_tab}FLUX 0 0 null
!------------------------------------------------------------------------------
! Get low and high row numbers for science frames in ipol_tab
!------------------------------------------------------------------------------
COUNT/IPOL {P2}




IF "{P1}" .eq. "A" THEN
!	---------------------------------------------------
!		 Aligned frames - method a
!	---------------------------------------------------
  CCD(1) = CCD(1)**2
  DO II = 1 {NUMROW}
     WRITE/KEY IMA {{P2},{P3},@{II}}
     IF IMA(1:1) .NE. " " THEN
       COMP/KEY OUTPUTI = M$INDEX(IMA,".")-1
       WRITE/KEY INIMA/C/1/60 {IMA(1:{OUTPUTI(1)})}
       WRITE/KEY OUT_A {{P2},{POSO},@{II}}
       COPY/DK {INIMA} REFIMA/C/1/60 REFIMA/C/1/60
       COPY/TT POS{REFIMA} :XCEN POS{REFIMA} :X_COORD
       COPY/TT POS{REFIMA} :YCEN POS{REFIMA} :Y_COORD

       WRITE/OUT "INTEGRATE/APERTURE {INIMA},POS{REFIMA} {OUT_A} {P4}"
       INTEGRATE/APERTURE {INIMA},POS{REFIMA} {OUT_A} {P4}
       COMP/TABL {OUT_A} :FLUXERR = sqrt(:FLUX * {CCD(2)} + {CCD(1)})/{CCD(2)}

       COPY/DK {INIMA} RET_ANG/D/1/1 TMPR
       TMPR = {{INIMA},RET_ANG(1)}
       TMPR = 100*{TMPR}
       WRITE/KEY RET_ANG {TMPR}

       IF INIMA(1:1) .eq. "O" THEN
         COPY/TT {OUT_A} :FLUX {ipol_tab}FLUX :O{RET_ANG}F
         COPY/TT {OUT_A} :FLUXERR {ipol_tab}FLUX :O{RET_ANG}ERR
         WRITE/TAB {P2} {FLUXO} @{II} {OUT_A}
       ELSEIF INIMA(1:1) .eq. "E" THEN
         COPY/TT {OUT_A} :FLUX {ipol_tab}FLUX :E{RET_ANG}F
         COPY/TT {OUT_A} :FLUXERR {ipol_tab}FLUX :E{RET_ANG}ERR
         WRITE/TAB {P2} {FLUXE} @{II} {OUT_A}
       ENDIF
       IF TRY(1:1) .eq. "F" GOTO end
     ENDIF
  ENDDO




ELSE




!	---------------------------------------------------
! 		original frames - method i(pol)
!	---------------------------------------------------

  DEFINE/LOCAL SLIT/C/1/60 {{IPOL_TAB},{SLIT_TAB},@1}
  DO II = 1 {NUMROW}
     WRITE/KEY IMA {{P2},{P3},@{II}}
     IF IMA(1:1) .NE. " " THEN
       COMP/KEY OUTPUTI = M$INDEX(IMA,".")-1
       WRITE/KEY INIMA/C/1/60 {IMA(1:{OUTPUTI(1)})}
       TMPR = {{P2},:RET_ANG,@{II}}
       TMPR = 100*{TMPR}
       WRITE/KEY RET_ANG {TMPR}

!      ordinary ray:
	
       SELE/TABL {SLIT} :ray_typ.eq."O" 	
       WRITE/KEY OUT_A {{P2},{POSO},@{II}}
       MAGNI/IPOL {INIMA} {SLIT} {OUT_A} {P4} {P5} {P7} {P8}
       COPY/TT {OUT_A} :flux {ipol_tab}FLUX :O{RET_ANG}F
       COPY/TT {OUT_A} :fluxerr {ipol_tab}FLUX :O{RET_ANG}ERR	
       WRITE/TAB {P2} {FLUXO} @{II} {OUT_A}

!      extra ordinary ray:	

       SELE/TABL {SLIT} :ray_typ.eq."E" 	
       WRITE/KEY OUT_A {{P2},{POSE},@{II}}
       MAGNI/IPOL {INIMA} {SLIT} {OUT_A} {P4} {P5} {P7} {P8}
       COPY/TT {OUT_A} :flux {ipol_tab}FLUX :E{RET_ANG}F
       COPY/TT {OUT_A} :fluxerr {ipol_tab}FLUX :E{RET_ANG}ERR
       WRITE/TAB {P2} {FLUXE} @{II} {OUT_A}
     ENDIF
  ENDDO




ENDIF


end:









