! @(#)ipolintegrate.prg	1.3 (ESO-IPG) 2/11/94 13:19:59
! +++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! IPOL PROCEDURE : IPOLINTEGRATE.PRG
!
! .PURPOSE
!
! execute the command :
! INTEGRATE/IPOL IPOL_TAB SC FF_OUT SC_INTEGRATE FFLOC TRY
!
! -------------------------------------------------
!
! CROSSREF IPOL_TAB SC FF_OUT SC_INTEGRATE FFLOC TRY
!
DEFINE/PARAM P1 {IPOL_TAB} TABLE   "Enter IPOL table:"
DEFINE/PARAM P2 {SC}       CHAR    "Enter column for input images:"
DEFINE/PARAM P3 {POSO} CHAR "Enter column with *ordinary* position tables:"
DEFINE/PARAM P4 {POSE} CHAR "Enter column with *extra-ordinary* position tables:"
DEFINE/PARAM P5 {INT_MODE} CHAR "integration mode: A(perture)/S(tar):"
DEFINE/PARAM P6 ? NUMB "A:integration radius -- S:radius,step,ref_magnitude"
DEFINE/PARAM P7 ? NUMB "read-out-noise (e-), gain (e-/ADU)"
DEFINE/PARAM P8 ? CHAR    "First try or All frames? (def: F)"
!
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL NOISE/R/1/1 0.
DEFINE/LOCAL TRY/C/1/1 F
DEFINE/LOCAL RET_ANG/I/1/1 0
DEFINE/LOCAL TMPR/R/1/1 0.0
DEFINE/LOCAL OUTTABO/C/1/40 " " ALL
DEFINE/LOCAL OUTTABE/C/1/40 " " ALL
DEFINE/LOCAL INTABO/C/1/40 " " ALL
DEFINE/LOCAL INTABE/C/1/40 " " ALL
DEFINE/LOCAL INBDF/C/1/40 " " ALL
DEFINE/LOCAL P5/C/1/1 X            
WRITE/KEY CCD/R/1/1 {P7}
WRITE/KEY TMP/C/1/60 " " ALL
WRITE/KEY P5/C/1/1 {P5}
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P8(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P8}
ENDIF
!-------------------------------------------------------------------------------
! Initialize columns to hold names of output tables
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/17 {FLUXE}
RUN STD_EXE:spolcolini
WRITE/KEY INPUTC/C/1/17 {FLUXO}
RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
! Get number of rows in ipol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Create output table to holde ALL results
!-------------------------------------------------------------------------------
CREA/TAB {ipol_tab}FLUX 0 0 null
!-------------------------------------------------------------------------------
! Comp read-out-noise
!-------------------------------------------------------------------------------
COMP/KEY NOISE = {CCD(1)}*{CCD(1)}/{CCD(2)}/{CCD(2)}
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in ipol_tab
!-------------------------------------------------------------------------------
@@ ipolcount {P1}
!COUNT/IPOL {P1}
!---------------------------------------------------
! Get all science frames
!---------------------------------------------------
DO J = 1 {N_SC}
  DO I = SC_STRT({J}) SC_END({J})
    COPY/TK {P1} {P2} @{I} TMP/C/1/20
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY INBDF {TMP}
      COMP/KEY OUTPUTI = M$INDEX(INBDF,".")-1
      WRITE/KEY OUTTABO/C/1/40 {PRE_FLUX}{INBDF(1:{OUTPUTI(1)})}O
      WRITE/KEY OUTTABE/C/1/40 {PRE_FLUX}{INBDF(1:{OUTPUTI(1)})}E
      COPY/DK {INBDF} RET_ANG/R/1/1 TMPR
      TMPR = 100*{TMPR}
      WRITE/KEY RET_ANG {TMPR}
    ENDIF
!---------------------------------------------------
! Get table with positions in "ordinary" slitlets
!---------------------------------------------------
    COPY/TK {P1} {P3} @{I} TMP/C/1/20
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY INTABO {TMP}
      COPY/TT {INTABO} :XCEN {INTABO} :X_COORD
      COPY/TT {INTABO} :YCEN {INTABO} :Y_COORD
      IF P5(1:1) .eq. "S" THEN
        WRITE/OUT "INTEGRATE/STAR {INBDF},{INTABO} {OUTTABO} {P6} AUTO"
        INTEGRATE/STAR {INBDF},{INTABO} {OUTTABO} {P6} AUTO
        COMP/TAB {OUTTABO} :FLUXSUB = :FLUX-:BACKGROUND
        COMP/TAB {OUTTABO} :FLUXERR = SQRT({NOISE}++ABS(:FLUX+:BACKGROUND)/{CCD(2)})
        COPY/TT {OUTTABO} :FLUXSUB {ipol_tab}FLUX :O{RET_ANG}NET
        COPY/TT {OUTTABO} :FLUXERR {ipol_tab}FLUX :O{RET_ANG}ERR
      ELSE
        WRITE/OUT "INTEGRATE/APERTURE {INBDF},{INTABO} {OUTTABO} {P6}"
        INTEGRATE/APERTURE {INBDF},{INTABO} {OUTTABO} {P6}
        COPY/TT {OUTTABO} :FLUX {ipol_tab}FLUX :O{RET_ANG}F
      ENDIF
      WRITE/TAB {P1} {FLUXO} @{I} {OUTTABO}
    ENDIF
!---------------------------------------------------
! Get table with positions in "extra-ordinary" slitlets
!---------------------------------------------------
    COPY/TK {P1} {P4} @{I} TMP/C/1/20
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY INTABE {TMP}
      COPY/TT {INTABE} :XCEN {INTABE} :X_COORD
      COPY/TT {INTABE} :YCEN {INTABE} :Y_COORD
      IF P5(1:1) .eq. "S" THEN
        WRITE/OUT "INTEGRATE/STAR {INBDF},{INTABE} {OUTTABE} {P6} AUTO"
        INTEGRATE/STAR {INBDF},{INTABE} {OUTTABE} {P6} AUTO
        COMP/TAB {OUTTABE} :FLUXSUB = :FLUX-:BACKGROUND
        COMP/TAB {OUTTABE} :FLUXERR = SQRT({NOISE}+ABS(:FLUX+:BACKGROUND)/{GAIN})
        COPY/TT {OUTTABE} :FLUXSUB {ipol_tab}FLUX :E{RET_ANG}NET
        COPY/TT {OUTTABE} :FLUXERR {ipol_tab}FLUX :E{RET_ANG}ERR
      ELSE
        WRITE/OUT "INTEGRATE/APERTURE {INBDF},{INTABE} {OUTTABE} {P6}"
        INTEGRATE/APERTURE {INBDF},{INTABE} {OUTTABE} {P6}
        COPY/TT {OUTTABE} :FLUX {ipol_tab}FLUX :E{RET_ANG}F
      ENDIF
      WRITE/TAB {P1} {FLUXE} @{I} {OUTTABE}
    ENDIF
    IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
      GOTO end
    ENDIF
  ENDDO
ENDDO
end:
