! +++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! IPOL PROCEDURE : IPOLLOCATE.PRG
!
! .PURPOSE
!
! execute the command :
! LOCATE/IPOL IPOL_TAB FF_OUT FLATLIM SCAN_POS XBIN FF_LOC
!
! -------------------------------------------------
!
!CROSSREF IPOL_TAB FF_OUT FLATLIM SCAN_POS XBIN FF_LOC
!
DEFINE/PARAM P1 {IPOL_TAB} TABLE   "Enter input table:"
DEFINE/PARAM P2 {FF_OUT}  CHAR "Column with flats to be used"
DEFINE/PARAM P3 {FLATLIM}  NUMBER "Enter threshold, width, low_limit :"
DEFINE/PARAM P4 {SCAN_POS} NUMBER  "x-position:"
DEFINE/PARAM P5 {XBIN} NUMBER  "x-width:"
DEFINE/PARAM P6 {FF_LOC}  CHAR "Same flat for all science frames or Individual flats? (Def.: S)"
!
DEFINE/LOCAL I/I/1/1 0
DEFINE/LOCAL J/I/1/1 0
DEFINE/LOCAL NUMROW/I/1/1 0
DEFINE/LOCAL RET_ANG/I/1/1 0
DEFINE/LOCAL TMPR/R/1/1 0.
DEFINE/LOCAL TMPC/C/1/60 
DEFINE/LOCAL XLIMITS/I/1/2 0 all
DEFINE/LOCAL QUALIF/C/1/4 " " all
DEFINE/LOCAL ORI/C/1/60 " " all
!
DEFINE/MAXPAR 5
!
WRITE/KEY NSLIT/I/1/1 0.
WRITE/KEYW IN_A   {P1}
WRITE/KEYW QUALIF {MID$CMND(11:14)}
!-------------------------------------------------------------------------------
! Count rows for science frames
!-------------------------------------------------------------------------------
COUNT/IPOL {P1}
!-------------------------------------------------------------------------------
! Initialize column to hold names of slitlet tables 
!-------------------------------------------------------------------------------
WRITE/KEY IN_A {P1}
WRITE/KEY INPUTC/C/1/16 {SLIT_TAB}
RUN STD_EXE:SPOLCOLINI
!-------------------------------------------------------------------------------
! Store parameters
!-------------------------------------------------------------------------------
WRITE/KEYW INPUTC/C/1/1  {P6}
WRITE/KEYW INPUTR  {P3}
WRITE/KEYW INPUTD  {P4},{P5}
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW 
WRITE/DESCR {P1}.tbl TBLGETFF/C/1/1 {P6}
IF INPUTD(1) .eq. 0 THEN
  INPUTD(1) = {{in_a},npix(1)}/2*{{in_a},step(1)}+{{in_a},start(1)}
ENDIF
!-------------------------------------------------------------------------------
! Individual flats
!-------------------------------------------------------------------------------
IF P6 .eq. "I" .or. P6 .eq. "i" THEN
  DO J = 1 {N_SC}
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} IN_A/C/1/60
      IF IN_A(1:1) .ne. " " THEN
        WRITE/KEYW ORI {IN_A}
!        COPY/DK {IN_A} RET_ANGLE/R/1/1 RET_ANG            
         COPY/DK {IN_A} RET_ANGLE/R/1/1 TMPR
        TMPR = 100*{TMPR}
        WRITE/KEY RET_ANG {TMPR}
        WRITE/KEYW OUT_A SLITL{RET_ANG}
        WRITE/KEYW IN_C/C/1/60 {P1}
     xlimits(1) = ({inputd(1)}-{{in_a},start(1)})-{inputd(2)}/{{in_a},step(1)}+1
     xlimits(2) = ({inputd(1)}-{{in_a},start(1)})+{inputd(2)}/{{in_a},step(1)}+1
        AVMOS/COL &z = {in_a} @{xlimits(1)},@{xlimits(2)}
        COPY/DD {IN_A} XPOS/R/1/100 &z  XPOS/R/1/100
        WRITE/KEYW IN_A middummz
        RUN STD_EXE:MOSFIND
        IF NSLIT .gt. 0 THEN
          WRITE/TAB {P1} {SLIT_TAB} @{I} {OUT_A}
          WRITE/DESCR {OUT_A}.tbl FLAT/C/1/60 IN_A/C/1/60
        ENDIF
      GOTO endi
      ENDIF
    ENDDO
endi:
  ENDDO
ENDIF
!-------------------------------------------------------------------------------
! Same flat for all
!-------------------------------------------------------------------------------
IF P6 .eq. "S" .or. P6 .eq. "s" THEN
  DO I = 1 {NUMROW}
    COPY/TK {P1} {P2} @{I} IN_A/C/1/60
    IF IN_A(1:1) .ne. " " THEN
      COPY/DK {IN_A} RET_ANGLE/R/1/1 RET_ANG            
      WRITE/KEYW ORI {IN_A}
      WRITE/KEYW OUT_A SLITL{RET_ANG}
     xlimits(1) = ({inputd(1)}-{{in_a},start(1)})-{inputd(2)}/{{in_a},step(1)}+1
     xlimits(2) = ({inputd(1)}-{{in_a},start(1)})+{inputd(2)}/{{in_a},step(1)}+1
      AVMOS/COL &z = {in_a} @{xlimits(1)},@{xlimits(2)}
      COPY/DD {IN_A} XPOS/R/1/100 &z  XPOS/R/1/100
      WRITE/KEYW IN_A middummz
      RUN STD_EXE:MOSFIND
      IF NSLIT .gt. 0 THEN
        WRITE/TAB {P1} {SLIT_TAB} @{I} {OUT_A}
        WRITE/DESCR {OUT_A}.tbl FLAT/C/1/60 IN_A/C/1/60
      ENDIF
    GOTO ends
    ENDIF
  ENDDO
ends:
ENDIF
