! @(#)ipolmark.prg          (LSW)     02/07/94 15:54
! +++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT    (C) 1994 Landessternwarte Heidelberg
!.IDENT        ipolmark.prg
!.AUTHORS      Sabine Moehler (LSW)
!.KEYWORDS     Polarimetry
!  
!.PURPOSE      execute the command MARK/IPOL
!
!.VERSION      1.0 Creation 02/07/94
! 
! MARK/IPOL ex_table column skytable
!
! -------------------------------------------------
!
! CROSSREF EX_TAB SC SKYTAB
!
DEFINE/PARAM P1 {IPOL_TAB}EX TABLE   "Enter input table:"
DEFINE/PARAM P2 {SC_EX}       CHAR    "Column with input images?"
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------------------------------------
! ... for sorting ...
!-------------------------------------------------------------------------------
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL II/I/1/1 0.
DEFINE/LOCAL NUMROW/I/1/1 0.
!-------------------------------------------------------------------------------
! ... for input frames/tables/angles
!-------------------------------------------------------------------------------
DEFINE/LOCAL INIMA/C/1/60 " " ALL
DEFINE/LOCAL OUTTAB/C/1/60 " " ALL
DEFINE/LOCAL ANG/R/1/1 -9999
!-------------------------------------------------------------------------------
! Get number of rows in ipol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Initialize column to hold names of slitlet tables
!-------------------------------------------------------------------------------
WRITE/KEY IN_A {P1}
WRITE/KEY INPUTC/C/1/16 {SKYTAB}
RUN STD_EXE:SPOLCOLINI
!-------------------------------------------------------------------------------
! Search for frames with same angle of retarder plate as reference frame
!-------------------------------------------------------------------------------
DO II = 1 {NUMROW}
   WRITE/KEY ANG {{P1},:RET_ANG,@{II}}
   IF ANG .eq. {REF_RET} THEN
     WRITE/KEY INIMA {{P1},{P2},@{II}}
     IF INIMA(1:1) .eq. "O" THEN
       I = {I}+1
!-------------------------------------------------------------------------------
! Mark sky regions
!-------------------------------------------------------------------------------
       CLEAR/CHAN over
       LOAD {INIMA}
       WRITE/OUT "**** Mark regions for determination of sky background ****"
       WRITE/OUT "You may vary the size of the sky region by varying the size"
       WRITE/OUT "of the cursor rectangle"
       COMP/KEY OUTPUTI = M$INDEX(INIMA,".")-1
       WRITE/KEY OUTTAB/C/1/60 {INIMA(1:{OUTPUTI(1)})}{SUF_SKY}
       GET/CURSOR {OUTTAB} ? ? 9999,2 
!-------------------------------------------------------------------------------
! Store sky table
!-------------------------------------------------------------------------------
       WRITE/TAB {P1} {SKYTAB} @{II} {OUTTAB}
     ENDIF
   ENDIF
ENDDO
