! @(#)ipolpoint.prg          (LSW)     02/07/94 15:54
! +++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT    (C) 1994 Landessternwarte Heidelberg
!.IDENT        ipolpoint.prg
!.AUTHORS      Sabine Moehler (LSW)
!.KEYWORDS     Polarimetry
!  
!.PURPOSE      execute the command POINT/IPOL
!
!.VERSION      1.0 Creation 02/07/94
! 
! POINT/IPOL ipol_table sc slit_tab off obj try
!
! -------------------------------------------------
!
! CROSSREF MODE IPOL_TAB SC TRY SLIT_TAB OFF 
!
DEFINE/PARAM P1 ?          CHAR    "Aligned or Original frames?"
IF P1 .eq. "A" THEN
  DEFINE/PARAM P2 {IPOL_TAB}EX TABLE   "Enter input table:"
  DEFINE/PARAM P3 {SC_EX}     CHAR    "Column with input images?"
  DEFINE/PARAM P4 F CHAR    "First try or All frames?"
ELSE 
  DEFINE/PARAM P2 {IPOL_TAB} TABLE   "Enter input table:"
  DEFINE/PARAM P3 {SC}       CHAR    "Column with input images?"
  DEFINE/PARAM P4 F CHAR    "(F)irst try, (A)ll frames or (G)uess?"
  DEFINE/PARAM P5 {SLIT_TAB} CHAR    "Column with slitlet tables?"
  DEFINE/PARAM P6 {OFF(1)},{OFF(2)} NUMB   "Crude offset between rays (x,y)?"
ENDIF
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------
! 		angle of retarder plate
DEFINE/LOCAL RET_ANG/I/1/1 0
! 		crude offsets between ordinary and extra-ordinary rays
DEFINE/LOCAL OFFSET/R/1/2 0.,0
! 		ray type (O/E)
DEFINE/LOCAL TYP/C/1/1 F
! 		First try or All frames
DEFINE/LOCAL TRY/C/1/1 F
!-------------------------------------------------------------------------------
! ... for sorting ...
!-------------------------------------------------------------------------------
DEFINE/LOCAL I/I/1/1 0
DEFINE/LOCAL II/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0
DEFINE/LOCAL JJ/I/1/1 0.
DEFINE/LOCAL K/I/1/1 0.
DEFINE/LOCAL KK/I/1/1 0.
DEFINE/LOCAL L/I/1/1 1.
DEFINE/LOCAL LL/I/1/1 0.
DEFINE/LOCAL N/I/1/1 0.
DEFINE/LOCAL NUMROW/I/1/1 0.
!-------------------------------------------------------------------------------
! ... for input frames/tables/angles
!-------------------------------------------------------------------------------
DEFINE/LOCAL INIMA/C/1/60 " " ALL
DEFINE/LOCAL INSC/C/1/60 " " ALL
DEFINE/LOCAL INTAB/C/1/60 " " ALL
DEFINE/LOCAL TMP/C/1/60 " " ALL
DEFINE/LOCAL INANG/R/1/1 -9999.9
DEFINE/LOCAL ANG/I/1/1 -9999
DEFINE/LOCAL OUTTAB/C/1/60 " " ALL
DEFINE/LOCAL GETFF/C/1/1 " " ALL
WRITE/KEY TRY/C/1/1 {P4}
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
!UNFUG?	COPY/DK {P2}.tbl TBLGETFF/C/1/1 GETFF/C/1/1
WRITE/KEY	GETFF/C/1/1 {FF_LOC(1:1)} 
WRITE/OUT "WARNING: BUG --- TBLGETFF/C/1/1 in ipol_tab only if flat/ipol"
!-------------------------------------------------------------------------------
! Get number of rows in ipol_tab
!-------------------------------------------------------------------------------
COPY/DK {P2}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in ipol_tab
!-------------------------------------------------------------------------------
COUNT/IPOL {P2}
SET/FORMAT I2
!-------------------------------------------------------------------------------
! Original frames
!-------------------------------------------------------------------------------
IF P1 .ne. "A" THEN
!-------------------------------------------------------------------------------
! Initialize columns to hold names of output tables
!-------------------------------------------------------------------------------
  WRITE/KEYW IN_A   {P2}
  WRITE/KEY INPUTC/C/1/17 {POSE}
  RUN STD_EXE:spolcolini
  WRITE/KEY INPUTC/C/1/17 {POSO}
  RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
! store crude offset estimate
!-------------------------------------------------------------------------------
  WRITE/KEY OFFSET/R/1/2 {P6}
!-------------------------------------------------------------------------------
! Same flat for all frames == one slitlet table for all frames
!---------------------------------------------------
  IF GETFF(1:1) .eq. "S" THEN
!---------------------------------------------------
! Get slitlet tables
!---------------------------------------------------
    DO II = 1 {NUMROW}
       WRITE/KEY TMP {{P2},{P5},@{II}}
       IF TMP(1:1) .ne. " " THEN
         WRITE/KEY INTAB {TMP}
       ENDIF
    ENDDO
  ENDIF
!---------------------------------------------------
! Get science frames
!---------------------------------------------------
  DO J = 1 {N_SC}
!---------------------------------------------------
! Individual flat for each frame == one slitlet table 
! for each frame
!---------------------------------------------------
  IF GETFF(1:1) .eq. "I" THEN
!---------------------------------------------------
! Get slitlet tables
!---------------------------------------------------
    DO II = SC_STRT({J}) SC_END({J})
       WRITE/KEY TMP {{P2},{P5},@{II}}
       IF TMP(1:1) .ne. " " THEN
         WRITE/KEY INTAB {TMP}
       ENDIF
    ENDDO
  ENDIF
!---------------------------------------------------
! Get science frames
!---------------------------------------------------
    DO II = SC_STRT({J}) SC_END({J})
      WRITE/KEY INIMA {{P2},{P3},@{II}}
      WRITE/KEY INSC {{P2},{SC},@{II}}
      WRITE/KEY INANG {{P2},:RET_ANG,@{II}}
!     COPY/TK {P2} {P3} @{II} INIMA/C/1/60
      IF INIMA(1:1) .ne. " " THEN
        JJ = JJ+1
!---------------------------------------------------
! mark objects in first frame
!---------------------------------------------------
        IF JJ .LE. 1 .AND. TRY .NE. "G" THEN
          COMP/KEY OUTPUTI = M$INDEX(INIMA,".")-1
          WRITE/KEY REFPOS/C/1/60 {INIMA(1:{OUTPUTI(1)})}
          WRITE/OUT "*********************************************************"
          WRITE/OUT "Mark sources for determination of polarization parameters"
          WRITE/OUT "*********************************************************"
          WRITE/OUT "Mark only objects in slitlets with ordinary rays "
          WRITE/OUT "(lower one of the pair)"
          WRITE/OUT "*********************************************************"
          CLEAR/CHAN OVER
          LOAD {INIMA}
          DO LL = 1 {NSLIT}
            WRITE/KEY TYP {{INTAB},:RAY_TYP,@{LL}}
!---------------------------------------------------
! mark objects only in ordinary ray slitlets 
!---------------------------------------------------
            IF TYP(1:1) .eq. "O" THEN
              K = {{INTAB},:SLIT,@{LL}}
              WRITE/OUT "**************************"
              WRITE/OUT "Mark objects in slitlet {K}"
              WRITE/OUT "**************************"
              IF N .LE. 0 THEN
                GET/CURSOR POS{REFPOS}O ? ? 9999,2
                N = N+1
              ELSE
                GET/CURSOR POS{REFPOS}O A ? 9999,2
              ENDIF
            ENDIF
          ENDDO
!---------------------------------------------------
! center objects in ordinary ray slitlets  
!---------------------------------------------------
          CENTER/GAUSS {INIMA},POS{REFPOS}O POS{REFPOS}O 
!---------------------------------------------------
! search objects in corresponding extra-ordinary ray 
! slitlets 
!---------------------------------------------------
          COPY/TAB POS{REFPOS}O POS{REFPOS}E
          COMP/TAB POS{REFPOS}E :XSTART = :XSTART+{OFFSET(1)}
          COMP/TAB POS{REFPOS}E :XEND = :XEND+{OFFSET(1)}
          COMP/TAB POS{REFPOS}E :YSTART = :YSTART+{OFFSET(2)}
          COMP/TAB POS{REFPOS}E :YEND = :YEND+{OFFSET(2)}
          CENTER/GAUSS {INIMA},POS{REFPOS}E POS{REFPOS}E 
!---------------------------------------------------
! store names of position tables
!---------------------------------------------------
          WRITE/TAB {P2} {POSE} @{II} POS{REFPOS}E
          WRITE/TAB {P2} {POSO} @{II} POS{REFPOS}O
        ELSE
!---------------------------------------------------
! all other frames
!---------------------------------------------------
!---------------------------------------------------
! "ordinary" slitlets: search objects
!---------------------------------------------------
          COMP/KEY OUTPUTI = M$INDEX(INIMA,".")-1
          WRITE/KEY NEWPOS/C/1/60 {INIMA(1:{OUTPUTI(1)})}
          CENTER/GAUSS {INIMA},POS{REFPOS}O POS{NEWPOS}O
!---------------------------------------------------
! "extra-ordinary" slitlets: search objects
!---------------------------------------------------
          COPY/TAB POS{NEWPOS}O POS{NEWPOS}E
          COMP/TAB POS{NEWPOS}E :XSTART = :XSTART+{OFFSET(1)}
          COMP/TAB POS{NEWPOS}E :XEND = :XEND+{OFFSET(1)}
          COMP/TAB POS{NEWPOS}E :YSTART = :YSTART+{OFFSET(2)}
          COMP/TAB POS{NEWPOS}E :YEND = :YEND+{OFFSET(2)}
          CENTER/GAUSS {INIMA},POS{NEWPOS}E POS{NEWPOS}E
!---------------------------------------------------
! store names of position tables
!---------------------------------------------------
          WRITE/TAB {P2} {POSE} @{II} POS{NEWPOS}E
          WRITE/TAB {P2} {POSO} @{II} POS{NEWPOS}O
        ENDIF
      IF TRY(1:1) .eq. "F" GOTO end
      GOTO next
      ENDIF
    ENDDO
  next:
  ENDDO
!---------------------------------------------------
! Aligned frames
!---------------------------------------------------
ELSE
!-------------------------------------------------------------------------------
! Initialize columns to hold names of output tables
!-------------------------------------------------------------------------------
  WRITE/KEYW IN_A   {P2}
  WRITE/KEY INPUTC/C/1/17 {POSOBJ}
  RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
! Search for frames with same angle of retarder plate as reference frame
!-------------------------------------------------------------------------------
  DO II = 1 {NUMROW}
     WRITE/KEY ANG {{P2},:RET_ANG,@{II}}
     IF ANG .eq. {REF_RET} THEN
       WRITE/KEY INIMA {{P2},{P3},@{II}}
       IF INIMA(1:1) .eq. "O" THEN
         I = {I}+1
!-------------------------------------------------------------------------------
! Mark objects
!-------------------------------------------------------------------------------
         CLEAR/CHAN over
         LOAD {INIMA}
         COMP/KEY OUTPUTI = M$INDEX(INIMA,".")-1
         WRITE/KEY OUTTAB/C/1/60 POS{INIMA(1:{OUTPUTI(1)})}
         WRITE/OUT "*********************************************************"
         WRITE/OUT "Mark sources for determination of polarization parameters "
         WRITE/OUT "*********************************************************"
         CENTER/GAUSS cursor {OUTTAB}
!-------------------------------------------------------------------------------
! Store position table
!-------------------------------------------------------------------------------
         WRITE/TAB {P2} {POSOBJ} @{II} {OUTTAB}
         IF TRY(1:1) .eq. "F" GOTO end
       ENDIF
     ENDIF
  ENDDO
ENDIF
end:
