! @(#)ipolpoint.prg          (LSW)     02/07/94 15:54
! +++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT    (C) 1994 Landessternwarte Heidelberg
!.IDENT        ipolpoint.prg
!.AUTHORS      Sabine Moehler (LSW)
!.KEYWORDS     Polarimetry
!  
!.PURPOSE      execute the command OFFSET/IPOL
!
!.VERSION      1.0 Creation 02/07/94
! 
! POINT/IPOL ipol_table sc slit_tab off obj try
!
! -------------------------------------------------
!
! CROSSREF IPOL_TAB SC SLIT_TAB OFF OBJ TRY
!
DEFINE/PARAM P1 {IPOL_TAB} TABLE   "Enter input table:"
DEFINE/PARAM P2 {SC}       CHAR    "Column with input images?"
DEFINE/PARAM P3 {SLIT_TAB} CHAR    "Column with slitlet tables?"
DEFINE/PARAM P4 {OFF(1)},{OFF(2)} NUMB   "Crude offset between rays (x,y)?"
DEFINE/PARAM P5 O CHAR    "Object or sky?"
DEFINE/PARAM P6 F CHAR    "First try or All frames?"
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------
! angle of retarder plate
DEFINE/LOCAL RET_ANG/I/1/1 0
! crude offsets between ordinary and extra-ordinary rays
DEFINE/LOCAL OFFSET/R/1/2 0.,0
! ray type (O/E)
DEFINE/LOCAL TYP/C/1/1 F
! Object or sky
DEFINE/LOCAL OBJ/C/1/1 O
! First try or All frames
DEFINE/LOCAL TRY/C/1/1 F
!-------------------------------------------------------------------------------
! ... for sorting ...
!-------------------------------------------------------------------------------
DEFINE/LOCAL I/I/1/1 0
DEFINE/LOCAL II/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0
DEFINE/LOCAL JJ/I/1/1 0.
DEFINE/LOCAL K/I/1/1 0.
DEFINE/LOCAL KK/I/1/1 0.
DEFINE/LOCAL L/I/1/1 1.
DEFINE/LOCAL LL/I/1/1 0.
DEFINE/LOCAL N/I/1/1 0.
DEFINE/LOCAL NUMROW/I/1/1 0.
!-------------------------------------------------------------------------------
! ... for input frames/tables/angles
!-------------------------------------------------------------------------------
DEFINE/LOCAL INIMA/C/1/60 " " ALL
DEFINE/LOCAL INSC/C/1/60 " " ALL
DEFINE/LOCAL INTAB/C/1/60 " " ALL
DEFINE/LOCAL TMP/C/1/60 " " ALL
DEFINE/LOCAL INANG/R/1/1 -9999.9
DEFINE/LOCAL ANG/I/1/1 -9999
WRITE/KEY OBJ/C/1/1 {P5}
WRITE/KEY TRY/C/1/1 {P6}
!-------------------------------------------------------------------------------
! Initialize columns to hold names of output tables
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
IF OBJ(1:1) .eq. "O" THEN
  WRITE/KEY INPUTC/C/1/17 {POSE}
  RUN STD_EXE:spolcolini
  WRITE/KEY INPUTC/C/1/17 {POSO}
  RUN STD_EXE:spolcolini
ELSE IF OBJ(1:1) .eq. "S" THEN
  WRITE/KEY INPUTC/C/1/17 {SKYPOSE}
  RUN STD_EXE:spolcolini
  WRITE/KEY INPUTC/C/1/17 {SKYPOSO}
  RUN STD_EXE:spolcolini
ENDIF
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF
!-------------------------------------------------------------------------------
! store crude offset estimate
!-------------------------------------------------------------------------------
WRITE/KEY OFFSET/R/1/2 {P4}
!-------------------------------------------------------------------------------
! Get number of rows in ipol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in ipol_tab
!-------------------------------------------------------------------------------
@@ ipolcount {P1}
!COUNT/IPOL {P1}
SET/FORMAT I2
!-------------------------------------------------------------------------------
! Same flat for all frames == one slitlet table for all frames
!---------------------------------------------------
IF GETFF(1:1) .eq. "S" THEN
!---------------------------------------------------
! Get slitlet tables
!---------------------------------------------------
  DO II = 1 {NUMROW}
     WRITE/KEY TMP {{P1},{P3},@{II}}
     IF TMP(1:1) .ne. " " THEN
       WRITE/KEY INTAB {TMP}
     ENDIF
  ENDDO
ENDIF
!---------------------------------------------------
! Get science frames
!---------------------------------------------------
DO J = 1 {N_SC}
!---------------------------------------------------
! Individual flat for each frame == one slitlet table 
! for each frame
!---------------------------------------------------
IF GETFF(1:1) .eq. "I" THEN
!---------------------------------------------------
! Get slitlet tables
!---------------------------------------------------
  DO II = SC_STRT({J}) SC_END({J})
     WRITE/KEY TMP {{P1},{P3},@{II}}
     IF TMP(1:1) .ne. " " THEN
       WRITE/KEY INTAB {TMP}
     ENDIF
  ENDDO
ENDIF
!---------------------------------------------------
! Get science frames
!---------------------------------------------------
  DO II = SC_STRT({J}) SC_END({J})
    WRITE/KEY INIMA {{P1},{P2},@{II}}
    WRITE/KEY INSC {{P1},{SC},@{II}}
    WRITE/KEY INANG {{P1},:RET_ANG,@{II}}
!   COPY/TK {P1} {P2} @{II} INIMA/C/1/60
    IF INIMA(1:1) .ne. " " THEN
      JJ = JJ+1
!---------------------------------------------------
! mark objects in first frame
!---------------------------------------------------
      IF JJ .LE. 1 THEN
        COMP/KEY OUTPUTI = M$INDEX(INIMA,".")-1
        WRITE/KEY REFPOS/C/1/60 {INIMA(1:{OUTPUTI(1)})}
        WRITE/OUT "Mark only objects/sky in slitlets with ordinary rays "
        WRITE/OUT "(lower one of the pair)"
        CLEAR/CHAN OVER
        LOAD {INIMA}
        DO LL = 1 {NSLIT}
          WRITE/KEY TYP {{INTAB},:RAY_TYP,@{LL}}
!---------------------------------------------------
! mark objects/sky only in ordinary ray slitlets 
!---------------------------------------------------
          IF TYP(1:1) .eq. "O" THEN
            K = {{INTAB},:SLIT,@{LL}}
            IF OBJ(1:1) .eq. "O" THEN
              WRITE/OUT "Mark objects in slitlet {K}"
              IF N .LE. 0 THEN
                GET/CURSOR POS{REFPOS}O ? ? 9999,2
                N = N+1
              ELSE
                GET/CURSOR POS{REFPOS}O A ? 9999,2
              ENDIF
            ELSE IF OBJ(1:1) .eq. "S" THEN
              WRITE/OUT "Mark sky in slitlet {K}"
              WRITE/OUT "You may vary the size of the sky region by varying"
              WRITE/OUT "the size of the cursor rectangle"
              IF N .LE. 0 THEN
                GET/CURSOR SKY{REFPOS}O ? ? 9999,2
                N = N+1
              ELSE
                GET/CURSOR SKY{REFPOS}O A ? 9999,2
              ENDIF
!---------------------------------------------------
! derive sky in corresponding extra-ordinary ray 
! slitlets 
!---------------------------------------------------
              COPY/TAB SKY{REFPOS}O SKY{REFPOS}E
              COMP/TAB SKY{REFPOS}E :XSTART = :XSTART+{OFFSET(1)}
              COMP/TAB SKY{REFPOS}E :XEND = :XEND+{OFFSET(1)}
              COMP/TAB SKY{REFPOS}E :YSTART = :YSTART+{OFFSET(2)}
              COMP/TAB SKY{REFPOS}E :YEND = :YEND+{OFFSET(2)}
            ENDIF
          ENDIF
        ENDDO
        IF OBJ(1:1) .eq. "O" THEN
!---------------------------------------------------
! center objects in ordinary ray slitlets  
!---------------------------------------------------
          CENTER/GAUSS {INIMA},POS{REFPOS}O POS{REFPOS}O 
!---------------------------------------------------
! search objects in corresponding extra-ordinary ray 
! slitlets 
!---------------------------------------------------
          COPY/TAB POS{REFPOS}O POS{REFPOS}E
          COMP/TAB POS{REFPOS}E :XSTART = :XSTART+{OFFSET(1)}
          COMP/TAB POS{REFPOS}E :XEND = :XEND+{OFFSET(1)}
          COMP/TAB POS{REFPOS}E :YSTART = :YSTART+{OFFSET(2)}
          COMP/TAB POS{REFPOS}E :YEND = :YEND+{OFFSET(2)}
          CENTER/GAUSS {INIMA},POS{REFPOS}E POS{REFPOS}E 
!---------------------------------------------------
! store names of position tables
!---------------------------------------------------
          WRITE/TAB {P1} {POSE} @{II} POS{REFPOS}E
          WRITE/TAB {P1} {POSO} @{II} POS{REFPOS}O
        ELSE IF OBJ(1:1) .eq. "S" THEN
          WRITE/TAB {P1} {SKYPOSE} @{II} SKY{REFPOS}E
          WRITE/TAB {P1} {SKYPOSO} @{II} SKY{REFPOS}O
        ENDIF
      ELSE
!---------------------------------------------------
! sky is defined only on first frame
!---------------------------------------------------
        IF OBJ(1:1) .eq. "S" GOTO end
!---------------------------------------------------
! all other frames
!---------------------------------------------------
!---------------------------------------------------
! "ordinary" slitlets: search objects
!---------------------------------------------------
        COMP/KEY OUTPUTI = M$INDEX(INIMA,".")-1
        WRITE/KEY NEWPOS/C/1/60 {INIMA(1:{OUTPUTI(1)})}
        CENTER/GAUSS {INIMA},POS{REFPOS}O POS{NEWPOS}O
!---------------------------------------------------
! "extra-ordinary" slitlets: search objects
!---------------------------------------------------
        COPY/TAB POS{NEWPOS}O POS{NEWPOS}E
        COMP/TAB POS{NEWPOS}E :XSTART = :XSTART+{OFFSET(1)}
        COMP/TAB POS{NEWPOS}E :XEND = :XEND+{OFFSET(1)}
        COMP/TAB POS{NEWPOS}E :YSTART = :YSTART+{OFFSET(2)}
        COMP/TAB POS{NEWPOS}E :YEND = :YEND+{OFFSET(2)}
        CENTER/GAUSS {INIMA},POS{NEWPOS}E POS{NEWPOS}E
!---------------------------------------------------
! store names of position tables
!---------------------------------------------------
        WRITE/TAB {P1} {POSE} @{II} POS{NEWPOS}E
        WRITE/TAB {P1} {POSO} @{II} POS{NEWPOS}O
      ENDIF
    IF TRY(1:1) .eq. "F" GOTO end
    GOTO next
    ENDIF
  ENDDO
next:
ENDDO
end:
