! @(#)ipolsee.prg          (LSW)     02/07/94 15:54
! +++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT    (C) 1994 Landessternwarte Heidelberg
!.IDENT        ipolsee.prg
!.AUTHORS      Sabine Moehler (LSW)
!.KEYWORDS     Polarimetry
!  
!.PURPOSE      execute the command SEE/IPOL
!
!.VERSION      1.0 Creation 02/07/94
! 
! SEE/IPOL ex_table sc
!
! -------------------------------------------------
!
! CROSSREF EX_TAB SC_SKY
!
DEFINE/PARAM P1 {IPOL_TAB}EX TABLE   "Enter input table:"
DEFINE/PARAM P2 {SC_SKY}     CHAR    "Column with input images?"
DISPLAY/LONG
!------------------------------------------------------------------------------
! Local keys ...
!------------------------------------------------------------------------------
! ... for sorting ...
!------------------------------------------------------------------------------
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL II/I/1/1 0.
DEFINE/LOCAL NUMROW/I/1/1 0.
!------------------------------------------------------------------------------
! ... for input frames/tables/angles
!------------------------------------------------------------------------------
DEFINE/LOCAL INIMA/C/1/60 " " ALL
DEFINE/LOCAL OUTTAB/C/1/60 " " ALL
DEFINE/LOCAL ANG/R/1/1 -9999
!------------------------------------------------------------------------------
! ... for gaussian functions
!------------------------------------------------------------------------------
DEFINE/LOCAL MAX_X/R/1/1 0.
DEFINE/LOCAL MAX_Y/R/1/1 0.
DEFINE/LOCAL SIG_X/R/1/1 0.
DEFINE/LOCAL SIG_Y/R/1/1 0.
DEFINE/LOCAL SEE_X/R/1/1 0.
DEFINE/LOCAL SEE_Y/R/1/1 0.
DEFINE/LOCAL STP/D/1/2 0,0
DEFINE/LOCAL START/D/1/2 0,0
DEFINE/LOCAL NPIX/I/1/2 0,0
DEFINE/LOCAL NX/I/1/1 0
DEFINE/LOCAL NY/I/1/1 0
DEFINE/LOCAL OFFX/I/1/1 0
DEFINE/LOCAL OFFY/I/1/1 0
DEFINE/LOCAL TWEN/R/1/2 0.,0.
! Get number of rows in ipol_tab

COPY/DK {P1}.tbl TBLCONTR/I/4/1 NUMROW

! Initialize column to hold names of convolved images:

WRITE/KEY IN_A {P1}
WRITE/KEY INPUTC/C/1/16 {CONIMA}
RUN STD_EXE:SPOLCOLINI

! Get worst seeing values

SET/MIDAS OUTPUT=LOGONLY
STAT/TAB {P1} :SEE_X
MAX_X = outputr(2)
STAT/TAB {P1} :SEE_Y
MAX_Y = outputr(2)
SET/MIDAS OUTPUT=YES
SET/FORMAT f7.4
write/out "   max. sigma_x = {MAX_X}    max. sigma_y = {MAX_Y}"
SET/FORMAT

! Comp parameters for gaussian:

COMP/TAB {P1} :SIG_X = SQRT({MAX_X}*{MAX_X}-:SEE_X*:SEE_X)/2.345
COMP/TAB {P1} :SIG_Y = SQRT({MAX_Y}*{MAX_Y}-:SEE_Y*:SEE_Y)/2.345


TWEN(1) = MAX_X / 20.0	
TWEN(2) = MAX_Y / 20.0
! loop for frames: 
DO II = 1 {NUMROW}
	WRITE/KEY INIMA {{P1},{P2},@{II}}
   	WRITE/KEY SIG_X {{P1},:SIG_X,@{II}}
   	WRITE/KEY SIG_Y {{P1},:SIG_Y,@{II}}
! Get size and step of input frame:

	IF SIG_X .GT. TWEN(1) .OR. SIG_Y .GT. TWEN(2) THEN
    	   IF SIG_Y .le. 0.1 WRITE/KEY SIG_Y 0.1
  	   IF SIG_X .le. 0.1 WRITE/KEY SIG_X 0.1
	   SET/FORMAT f5.2
  	   write/out "   convolve {INIMA}:   sigma_x = {SIG_X}   sigma_y = {SIG_Y}"
	   SET/FORMAT
  	   COPY/DK {INIMA} START/D/1/2 START/D/1/2
  	   COPY/DK {INIMA} STEP/D/1/2 STP/D/1/2
  	   COPY/DK {INIMA} NPIX/I/1/2 NPIX/I/1/2
  	   OFFX = -({DIM_G(1)}-1)/2
  	   OFFY = -({DIM_G(1)}-1)/2
	   SET/MIDAS OUTPUT=LOGONLY
  	   CREA/IMA &g 2,{DIM_G(1)},{DIM_G(1)} {OFFX},{OFFY},{STP(1)},{STP(2)} gauss 0,{SIG_X},0,{SIG_Y}

! Convolve image:
  	   CONVOLVE/IMA {INIMA} &g {INIMA}{SUF_CON}
	   SET/MIDAS OUTPUT=ON
	ELSE
  	   write/out "   copy     {INIMA}:   sigma_x = {SIG_X}   sigma_y = {SIG_Y}"	   
	   COPY/II {INIMA} {INIMA}{SUF_CON}
	ENDIF
  	WRITE/TAB {P1} {CONIMA} @{II} {INIMA}{SUF_CON}
ENDDO
