! @(#)ipolshow.prg	1.2 (ESO-IPG) 2/11/94 13:20:01
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1991 European Southern Observatory
!.IDENT       ipolshow.prg
!.AUTHOR      Pascal Ballester,  ESO - Garching
!.KEYWORDS    Spectropolarimetry
!.PURPOSE     Display IPOL session parameters
!.VERSION     1.0    Creation    21-AUG-1991  PB
!             1.1    Adaption for IPOL 26-JUL-1994 SM
!
!-------------------------------------------------------


DEFINE/PARAM P1 A CHAR "which part?"


SET/FORMAT I1  F12.5  
ECHO/OFF
SESSLINE = 0 ! Initialize the line counter



IF P1(1:1) .EQ. "D"  GOTO DEF 
IF P1(1:1) .EQ. "E"  GOTO EXTR
IF P1(1:1) .EQ. "F"  GOTO FF
IF P1(1:1) .EQ. "G"  GOTO GEN
IF P1(1:1) .EQ. "P"  GOTO POL
IF P1(1:1) .EQ. "S"  GOTO SKY


GEN:

SHOW/SESS "___________________________________________________________________"
SHOW/SESS " "
SHOW/SESS "General parameters:                   ... IPOL 12/96 LSW-Heidelberg"
SHOW/SESS " "
SHOW/SESS "CCD RON,gain,nsigma (CCDPAR):            {CCDPAR(1)},{CCDPAR(2)},{CCDPAR(3)} "
SHOW/SESS "Table with all frames (IPOL_TAB):        {IPOL_TAB}"
SHOW/SESS "Total number of science frames (N_SC):   {N_SC}"
SHOW/SESS "Column with raw science frames (SC):     {SC}"
!SHOW/SESS "       ...  INFO:    columns are columns of (IPOL_TAB) = {IPOL_TAB}"
IF P1(1:1) .EQ. "G" THEN
   READ/TABL {IPOL_TAB} {SC}
ENDIF
IF P1(1:1) .NE. "A"  RETURN


FF:

SHOW/SESS "___________________________________________________________________"
SHOW/SESS " "
SHOW/SESS "Flat field related:                              ... LOCATE/  FLAT/"
SHOW/SESS " "
SHOW/SESS "Column with individual flat fields (FF):              {FF}" 
SHOW/SESS "Column with averaged flat-fields (FF_OUT):            {FF_OUT}"
SHOW/SESS "Center for scan for slitlet search (SCAN_POS):        {SCAN_POS}"
SHOW/SESS "Binning in X for slitlet search (XBIN):               {XBIN}"
SHOW/SESS "Detec. thres. (FLATLIM):                              {FLATLIM}"
SHOW/SESS "Same/Individual flats for slitlet location (FF_LOC):  {FF_LOC}"
SHOW/SESS "Column with slitlet tables (SLIT_TAB):                {SLIT_TAB}"
SHOW/SESS "Column with flat-fielded science frames (SC_FLAT):    {SC_FLAT}"
SHOW/SESS "Prefix for flat-fielded frames (PRE_FFSC):            {PRE_FFSC}"
IF P1(1:1) .NE. "A"  RETURN


EXTR:

SHOW/SESS "___________________________________________________________________"
SHOW/SESS " "
SHOW/SESS "Extraction and alignment related:                       ... OFFSET/"
SHOW/SESS " "
SHOW/SESS "Column with extracted science frames (SC_EX):         {SC_EX}"
SHOW/SESS "Offset between rays (x,y) (OFF):                      {OFF(1)},{OFF(2)}"
SHOW/SESS "Retarder plate angle of reference frame (REF_RET):    {REF_RET}"
SHOW/SESS "Dimensions of convolution gaussian (DIM_G):           {DIM_G}"
IF P1(1:1) .NE. "A"  RETURN


DEF:

SHOW/SESS "___________________________________________________________________"
SHOW/SESS " "
SHOW/SESS "Object definition and integration related:   ... POINT/  INTEGRATE/"
SHOW/SESS "                            "
SHOW/SESS "Pointing mode (Aligned/Original/Guess) (INT_MODE):    {INT_MODE}"
SHOW/SESS "Columns for position table: "
SHOW/SESS "    Original frames/extra. rays:    (POSE)            {POSE}"
SHOW/SESS "    Original frames/ordin. rays:    (POSO)            {POSO}"
SHOW/SESS "    Aligned subframes:              (POSOBJ)          {POSOBJ}"
SHOW/SESS "Integration mode (Aperture/Star/Ipol) (INT_MODE):     {INT_MODE}"
SHOW/SESS "   | Apertures:|     deny fit within: [pixels]        {APER(1)},"
SHOW/SESS "   |    for    |          fit within:                 {APER(2)},"
SHOW/SESS "   |method IPOL|    inner sky radius:                 {APER(3)},"
SHOW/SESS "   |  (APER)   |    outer sky radius:                 {APER(4)}"
SHOW/SESS "   |           |  type number  1,2,3: (PSF)           {PSF}"
SHOW/SESS "Column with extra-ordinary flux tables (FLUXE):       {FLUXE}"
SHOW/SESS "Column with ordinary flux tables (FLUXO):             {FLUXO}"
SHOW/SESS "Prefix for tables created by INTEG/IPOL (PRE_FLUX):   {PRE_FLUX}"
IF P1(1:1) .NE. "A"  RETURN


SKY:

SHOW/SESS "___________________________________________________________________"
SHOW/SESS " "
SHOW/SESS "Sky-definition, -fit and -subtraction related:      ... MARK/  SKY/"
SHOW/SESS "                            "
SHOW/SESS "Column for sky position tables (SKYTAB):              {SKYTAB}"
SHOW/SESS "Column for sky frames (SKY):                          {SKY}"
SHOW/SESS "Suffix for sky frames (SUF_SKY):                      {SUF_SKY}"
SHOW/SESS "Parameters (SKYPAR):                                  {SKYPAR}"
SHOW/SESS "Column for sky-subtracted frames (SC_SKY):            {SC_SKY}"
SHOW/SESS "Prefix for sky-subtracted frames (PRE_SUB):           {PRE_SUB}"
IF P1(1:1) .NE. "A"  RETURN


POL:

SHOW/SESS "___________________________________________________________________"
SHOW/SESS " "
SHOW/SESS "Polarimetry related:                                ... ISTOKES/"
SHOW/SESS "                            "
SHOW/SESS "Column for convolved frames (CON_IMA):                  {CONIMA}"
SHOW/SESS "Zero-angle of retarder plate (ZERO_ANG):              {ZERO_ANG}"
SHOW/SESS "___________________________________________________________________"
SHOW/SESS " "

SET/FORMAT
RETURN

