! @(#)ipolsky.prg          (LSW)     02/07/94 15:54
! +++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT    (C) 1994 Landessternwarte Heidelberg
!.IDENT        ipolsky.prg
!.AUTHORS      Sabine Moehler (LSW)
!.KEYWORDS     Polarimetry
!  
!.PURPOSE      execute the command SKY/IPOL
!
!.VERSION      1.0 Creation 02/07/94
! 
! MARK/IPOL ex_table sc_column skyfit
!
! -------------------------------------------------
!
! CROSSREF EX_TAB SC SC_SKY SKYPAR
!
DEFINE/PARAM P1 {IPOL_TAB}EX TABLE   "Enter input table:"
DEFINE/PARAM P2 {SC_EX}       CHAR    "Column with input images?"
DEFINE/PARAM P3 {SC_SKY}      CHAR    "Column with sky subtracted images?"
DEFINE/PARAM P4 {SKYPAR(1)},{SKYPAR(2)} NUM    "order of sky fit?"
DEFINE/PARAM P5 ?             NUM    "read-out-noise (e-), gain (e-/ADU)"
DEFINE/PARAM P6 F             CHAR   "First try/All frames?"
!------------------------------------------------------------------------------
! Local keys ...
!------------------------------------------------------------------------------
! ... for sorting ...
!------------------------------------------------------------------------------
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL II/I/1/1 0.
DEFINE/LOCAL NUMROW/I/1/1 0.
!------------------------------------------------------------------------------
! ... for input frames/tables/angles
!------------------------------------------------------------------------------
DEFINE/LOCAL INIMA/C/1/60 " " ALL
DEFINE/LOCAL REFIMA/C/1/60 " " ALL
DEFINE/LOCAL IMA/C/1/60 " " ALL
DEFINE/LOCAL TRY/C/1/1 F
DEFINE/LOCAl NOISE/R/1/1 0.
WRITE/KEY CCD/R/1/2 {P5}
WRITE/KEY TRY/C/1/1 {P6}
!------------------------------------------------------------------------------
! Get read-out-noise
!------------------------------------------------------------------------------
!COMP/KEY NOISE = {RON}*{RON}/{GAIN}/{GAIN}
COMP/KEY NOISE = CCD(1)**2
!------------------------------------------------------------------------------
! Get number of rows in ipol_tab
!------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!------------------------------------------------------------------------------
! Initialize column to hold names of sky subtracted frames
!------------------------------------------------------------------------------
WRITE/KEY IN_A {P1}
WRITE/KEY INPUTC/C/1/16 {P3}
RUN STD_EXE:SPOLCOLINI
WRITE/KEY INPUTC/C/1/16 {P3}ERR
RUN STD_EXE:SPOLCOLINI
!------------------------------------------------------------------------------
! Get science frames
!------------------------------------------------------------------------------
DO II = 1 {NUMROW}
   WRITE/KEY IMA {{P1},{P2},@{II}}
   IF IMA(1:1) .NE. " " THEN
     COMP/KEY OUTPUTI = M$INDEX(IMA,".")-1
     WRITE/KEY INIMA/C/1/60 {IMA(1:{OUTPUTI(1)})}
     WRITE/KEY OUT_A {INIMA}{SUF_SUB}
     COPY/DK {INIMA} REFIMA/C/1/60 REFIMA/C/1/60
!     WRITE/OUT "FIT/FLAT {OUT_A} = {INIMA} {REFIMA}{SUF_SKY} {P4} {INIMA}{SUF_SKY}"
     SET/MIDAS OUTPUT=LOGONLY
     FIT/FLAT {OUT_A} = {INIMA} {REFIMA}{SUF_SKY} {P4} {INIMA}{SUF_SKY}
     SET/MIDAS OUTPUT=YES
     WRITE/TAB {P1} {P3} @{II} {OUT_A}
!    COMP/IMA {OUT_A}ERR = SQRT({NOISE}+ABS({INIMA}+{INIMA}{SUF_SKY})/{CCD(2)})
     COMP/IMA {OUT_A}ERR = SQRT({NOISE}+ABS({INIMA})/{CCD(2)})
     WRITE/TAB {P1} {P3}ERR @{II} {OUT_A}
     IF TRY(1:1) .eq. "F" GOTO end
   ENDIF
ENDDO
end:

