/*                                            */
/* ipollinp2d.c                                 */
/* Otmar Stahl, 21-JUN-1995                   */
/*                                            */

#include <math.h>
#include <stdio.h>
#include <string.h>

#include <midas_def.h>
#include <proto_nrutil.h>
#include <mutil.h>

#include <proto_polarutils.h>
#include <proto_polarimetry.h>

#define myabs(A) ((A)  >  0 ? (A) : (-A))
#define MAXIMS 8
#ifndef PI
#define PI (acos(-1.0))
#endif
#define RAD1 (180.0/PI)




main ()
     
{
  double start[2*MAXIMS],step[2*MAXIMS], ostep, ostart, eps;
  int  stat, iav, uni, nulo, onpix, n, i;
  int  nrow, offset;
  int imno[MAXIMS], npix[2*MAXIMS], naxis[MAXIMS];
  int nstep,itmp;
  char cQ[61], cU[61], cQerr[61], cUerr[61], cunit[64];
  char text[80],append[1],catfil[61];
  char cpol[61], ctheta[61],cpolerr[61],cthetaerr[61];
  register float *Q, *U, *Qerr, *Uerr, *pol, *polerr, *theta, *thetaerr,tmp; 

  static char  error1[] = "operands do not match in step size... ";
  static char  error2[] = "operands do not match in start value... ";
  static char  error3[] = "operands do not match in pixel number... ";

/*         get into Midas and get parameters             */

  stat = SCSPRO ("linpol");

  stat = SCKGETC("P1",1,60,&iav,cQ);  
  stat = SCKGETC("P2",1,60,&iav,cU);  
  /*  stat = SCKGETC("P3",1,60,&iav,cpol);  
      stat = SCKGETC("P4",1,60,&iav,ctheta);  
  */
/* open input frames */

  stat = SCFOPN(cQ,D_R4_FORMAT,0,F_IMA_TYPE,&imno[0]);
  stat = SCFOPN(cU,D_R4_FORMAT,0,F_IMA_TYPE,&imno[1]);

  i = strlen(cQ);
  /*  strncpy(cQerr,cQ,i);*/
  strcpy(cQerr,cQ);
  cQerr[i]= 'E';
  cQerr[i+1]='\0'; 
  stat = SCFOPN(cQerr,D_R4_FORMAT,0,F_IMA_TYPE,&imno[2]); 
 
  i = strlen(cU);
  /*strncpy(cUerr,cU,i);*/
  strcpy(cUerr,cU);
  cUerr[i]= 'E';
  cUerr[i+1]='\0'; 
  stat = SCFOPN(cUerr,D_R4_FORMAT,0,F_IMA_TYPE,&imno[3]);  

  strncpy(catfil,cU,(i-1));
  catfil[i]='\0';

  /* read descriptors of first frame */

  stat = SCDRDI(imno[0],"NAXIS",1,1,&iav,&naxis[0],&uni,&nulo);
  stat = SCDRDI(imno[0],"NPIX",1,naxis[0],&iav,&npix[0],&uni,&nulo);
  stat = SCDRDD(imno[0],"START",1,naxis[0],&iav,&start[0],&uni,&nulo);
  stat = SCDRDD(imno[0],"STEP",1,naxis[0],&iav,&step[0],&uni,&nulo);
  stat = SCDGETC(imno[0],"CUNIT",1,64,&iav,cunit);

  ostart = start[0];
  ostep = step[0];
  eps = 0.0001*step[0];
  onpix = npix[0];

  /* compare other input frames with first frame */ 

for (n=1; n < 4; n++)
   {
      start[2*n] = 0.0;
      step[2*n] = 1.0;
      npix[2*n] = 1;
  
      stat = SCDRDI(imno[n],"NAXIS",1,1,&iav,&naxis[n],&uni,&nulo);
      stat = SCDRDI(imno[n],"NPIX",1,naxis[0],&iav,&npix[2*n],&uni,&nulo);
      stat = SCDRDD(imno[n],"START",1,naxis[0],&iav,&start[2*n],&uni,&nulo);
      stat = SCDRDD(imno[n],"STEP",1,naxis[0],&iav,&step[2*n],&uni,&nulo);
      
      /*  check step size, start values and pixel numbers ...  */

        if (myabs(step[2*n]-ostep) > eps) SCETER(5,error1);
        if (myabs(start[2*n]-ostart) > eps) SCETER(5,error2);
        if (npix[2*n] != onpix) SCETER(5,error3);
    }
  
  /* all o.k. now allocate space for arrays */

  Q = fvector(0, npix[0] - 1);
  Qerr = fvector(0, npix[0] - 1);
  U = fvector(0, npix[0] - 1);
  Uerr = fvector(0, npix[0] - 1);
  pol = fvector(0, npix[0] - 1);
  polerr = fvector(0, npix[0] - 1);
  theta = fvector(0, npix[0] - 1);
  thetaerr = fvector(0, npix[0] - 1);

  if (npix[1] <= 0 )  npix[1] = 1;

  /* open output frames */
  /* 
  stat = outframes1 (cpol, ctheta, start, step, npix, naxis, imno);
  */

  append[0] = 'p';
  stat = outframes (append, catfil, start, step, npix, naxis, imno, 
                        cpol,  cpolerr, &imno[4], &imno[6]);
  append[0] = 't';
  stat = outframes (append, catfil, start, step, npix, naxis, imno, 
                        ctheta,  cthetaerr, &imno[5], &imno[7]);



  /* loop over all rows */
  printf("...loop the ccd rows \n");
  tmp = 0;
  itmp = 0;

  for (nrow = 0; nrow < npix[1]; nrow++)
    {

      offset = nrow*npix[0]+1;


  /* read next row of input frames */

      stat = SCFGET(imno[0],offset,npix[0],&nulo, (char *)Q);
      stat = SCFGET(imno[1],offset,npix[0],&nulo, (char *)U);
      stat = SCFGET(imno[2],offset,npix[0],&nulo, (char *)Qerr);
      stat = SCFGET(imno[3],offset,npix[0],&nulo, (char *)Uerr);
      

      nstep = 4;
      stat = linpol(Q,Qerr,U,Uerr,pol,polerr,theta,thetaerr,npix[0],nstep,1); 
      
      tmp = tmp + 100.0 / ((float) npix[1]);
      if ( tmp > 1.0){
	itmp+=1;
	sprintf (text,"   ...progress %3d percent",itmp+1);
	SCTDIS (text,26);
	tmp -= 1.0;
      }


  /* write next row of output frames */

      stat = SCFPUT(imno[4], offset, npix[0], (char*)pol);
      stat = SCFPUT(imno[5], offset, npix[0], (char*)theta);  
      stat = SCFPUT(imno[6], offset, npix[0], (char*)polerr);
      stat = SCFPUT(imno[7], offset, npix[0], (char*)thetaerr);  

    }
  printf("\n");

/* close all open files */
  
  for (i = 0 ; i < 8; i++)
    {
      stat = SCFCLO(imno[i]);
    }

  /*          epilogue ...                 */

  free_fvector(Q, 0, npix[0] - 1);  
  free_fvector(U, 0, npix[0] - 1);  
  free_fvector(Qerr, 0, npix[0] - 1);  
  free_fvector(Uerr, 0, npix[0] - 1);  
  free_fvector(pol, 0, npix[0] - 1);  
  free_fvector(theta, 0, npix[0] - 1);  
  free_fvector(polerr, 0, npix[0] - 1);  
  free_fvector(thetaerr, 0, npix[0] - 1);  
  
  return SCSEPI();
}

/*---------------------------------------------------------------------------*/

