#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <midas_def.h>
#include <proto_fors.h>

#ifndef PI
#define PI (acos((double) -1))
#endif
#define RAD (((double) 180) / PI)
#define HRAD (((double) 12) / PI)
#define TORAD (PI/((double) 90))

#define NNSTEP 100
#define SLENGTH 80

#define TTTABLE 1


#ifdef __STDC__
int interpol(float x1[], float y1[], int n1, float x2[], float y2[], int n2);
#else
int interpol();
#endif

#ifdef __STDC__
float     
integral(float x1[], float y1[], float dlambda, int n1);
#else
float     
integral();
#endif




main()
{

  char qout[SLENGTH+1],uout[SLENGTH+1],qin[SLENGTH+1],uin[SLENGTH+1],
    e1in[SLENGTH+1],e2in[SLENGTH+1],e3in[SLENGTH+1],e4in[SLENGTH+1],
    cbuff[SLENGTH+1];

  int i,j;
  int imin1,imin2,imout1,imout2,imine1,imine2,imoute1,imoute2,
    tide1,tide2,tide3,tide4;
  int imp,imt,impe,imte,impc,istrlen;
  int nrow,kact,kun,knul,stat;
  int naxis,npix[2],fsize;
  int ilog[4],col[3];

  int debug,inmode;

  float *depstheta,*ddepol,*dqinspol,*duinspol,*dlambda;
  float *debuff,*dlbuff,*debuff1,*dlbuff1;
  float *dqinbuff,*duinbuff,*dqoutbuff,*duoutbuff;
  float *dqinebuff,*duinebuff,*dqoutebuff,*duoutebuff;
  float *dpbuff,*dpebuff,*dtbuff,*dtebuff;
  float *filtlbuff,*filtebuff,*dfilter,*eins;

  float filtnorm, epstheta, depol, qinspol, uinspol;

  double start[2],step[2],dparam[3];


  int ocol[12],tidin;




  SCSPRO ("ipolpolcor2");



  SCKRDI ("INPUTI", 1, 1, &kact, &debug, &kun, &knul);






  if (debug > 1)
    printf("read keys\n");

  SCKGETC ("OUT_A", 1, SLENGTH, &kact, qout);
  SCKGETC ("OUT_B", 1, SLENGTH, &kact, uout);
  
  SCKGETC ("IN_A", 1, SLENGTH, &kact, qin);
  if (file_exists(qin,".tbl")) inmode = TTTABLE;
  if (inmode != TTTABLE)
    SCKGETC ("IN_B", 1, SLENGTH, &kact, uin);

  SCKGETC ("IN_1", 1, SLENGTH, &kact, e1in);
  SCKGETC ("IN_2", 1, SLENGTH, &kact, e2in);
  SCKGETC ("IN_3", 1, SLENGTH, &kact, e3in);
  SCKGETC ("IN_4", 1, SLENGTH, &kact, e4in);

  if (inmode != TTTABLE){
    if (!file_exists(qin,".bdf")) return -1;
    if (!file_exists(uin,".bdf")) return -1;
  }
  else{
    if (!file_exists(qin,".tbl")) return -1;
  }

  ilog[0] = file_exists(e1in,".tbl");
  ilog[1] = file_exists(e2in,".tbl");
  ilog[2] = file_exists(e3in,".tbl");
  ilog[3] = file_exists(e4in,".tbl");

  if (!ilog[3]) return -1;









  if (debug > 1)
    printf("allocate buffers for input tables\n");


  depstheta =  fvector(0,NNSTEP-1);
  ddepol    =  fvector(0,NNSTEP-1);
  dqinspol  =  fvector(0,NNSTEP-1);
  duinspol  =  fvector(0,NNSTEP-1);

  dlambda   =  fvector(0,NNSTEP-1);
  dfilter   =  fvector(0,NNSTEP-1);

  eins = fvector(0,NNSTEP-1);


  if (debug > 1)
    printf("open table filter\n");


  stat = TCTOPN(e4in, F_I_MODE, &tide4);

  SCDRDI( tide4, "TBLCONTR", 4, 1, &kact, &nrow, &kun, &knul );
  TCCSER (tide4, ":LAMBDA", &col[0]);
  TCCSER (tide4, ":RESPONSE", &col[1]);
  
  filtlbuff = fvector(1,nrow);
  filtebuff = fvector(1,nrow);



  for (i = 0 ; i < nrow ; i++)
    {
      TCERDR (tide4, i+1, col[0], &filtlbuff[i+1], &knul);
      TCERDR (tide4, i+1, col[1], &filtebuff[i+1], &knul);
      if (debug > 2)
	printf("read filter: %d %6.1f %6.3f \n",i,filtlbuff[i+1],filtebuff[i+1]);
    }


  for (i = 0 ; i < NNSTEP ; i++){
    dlambda[i] = (float) (filtlbuff[1] + i * 
			  (filtlbuff[nrow] - filtlbuff[1]) / (NNSTEP-1));
    eins[i] = (float) 1;
    
    if (debug > 5)
      printf("read filter: %d %6.1f %6.3f \n",i,dlambda[i],eins[i]);
    
  }
  
  interpol(filtlbuff,filtebuff,nrow,dlambda,dfilter,NNSTEP);
  
  
  if (debug > 1)
    for ( i = 0 ; i < NNSTEP ; i++)
      printf("%f %f \n",dlambda[i],dfilter[i]);
  

  
  free_fvector(filtebuff,1,nrow);
  free_fvector(filtlbuff,1,nrow);

  
  TCTCLO(tide4);




  if (debug > 2)
    printf("integrate  filter norm:\n");

  filtnorm = integral(dfilter,eins,(dlambda[1]-dlambda[0]),NNSTEP);
  

  printf("integral over filter %8.3f\n",filtnorm);






  if (ilog[0]){

    if (debug > 1)
      printf("open table eps_theta = %s \n",e1in);

    TCTOPN(e1in, F_I_MODE, &tide1);

    if (debug > 1)
      printf("open table eps_theta = %s \n",e1in);

    SCDRDI( tide1, "TBLCONTR", 4, 1, &kact, &nrow, &kun, &knul );

    if (debug > 1)
      printf("length of table eps_theta = %d\n",nrow);

    TCCSER (tide1, ":LAMBDA", &col[0]);
    TCCSER (tide1, ":EPSTHETA", &col[1]);
    

    if (debug > 1)
      printf("open buffers and read table content \n");

    debuff1 = fvector(1,nrow);
    dlbuff1 = fvector(1,nrow);
    

    for (i = 0 ; i < nrow ; i++)
      {
	TCERDR (tide1, i+1, col[0], &dlbuff1[i+1], &knul);
	TCERDR (tide1, i+1, col[1], &debuff1[i+1], &knul);
      }
    
    if (debug > 1)
      for ( i = 1 ; i <= nrow ; i++)
	printf("%d %f %f \n",i,dlbuff1[i],debuff1[i]);

    interpol(dlbuff1,debuff1,nrow,dlambda,depstheta,NNSTEP);
    
    if (debug > 1)
      for ( i = 0 ; i < NNSTEP ; i++)
	printf("%d %f %f %f \n",i,dlambda[i],dfilter[i],depstheta[i]);

    free_fvector(debuff1,1,nrow);
    free_fvector(dlbuff1,1,nrow);
    
    TCTCLO(tide1);
  }
  else{
    for (i = 0 ; i < NNSTEP ; i++)
      depstheta[i] = (double) 0.0;
  }


  epstheta = integral(dfilter,depstheta,(dlambda[1]-dlambda[0]),NNSTEP) / 
    filtnorm;


  printf("eps_theta = %8.2f\n",epstheta);







  if (ilog[1]){

    if (debug > 1)
      printf("open table depol\n");

    stat = TCTOPN(e2in, F_I_MODE, &tide2);

    SCDRDI( tide2, "TBLCONTR", 4, 1, &kact, &nrow, &kun, &knul );
    TCCSER (tide2, ":LAMBDA", &col[0]);
    TCCSER (tide2, ":DEPOL", &col[1]);
  
    debuff = fvector(1,nrow);
    dlbuff = fvector(1,nrow);

    for (i = 0 ; i < nrow ; i++)
      {
	TCERDR (tide2, i+1, col[0], &dlbuff[i+1], &knul);
	TCERDR (tide2, i+1, col[1], &debuff[i+1], &knul);
      }


    interpol(dlbuff,debuff,nrow,dlambda,ddepol,NNSTEP);

    if (debug > 1)
      for ( i = 0 ; i < NNSTEP ; i++)
	printf("%d %f %f \n",i,dlambda[i],ddepol[i]);

    free_fvector(debuff,1,nrow);
    free_fvector(dlbuff,1,nrow);
    
    TCTCLO(tide2);

    depol = integral(dfilter,ddepol,(dlambda[2]-dlambda[1]),NNSTEP) / 
      filtnorm;
  }
  else{
    for (i = 0 ; i < NNSTEP ; i++)
      ddepol[i] = (double) 1.0;
    depol = 1.0;
  }




  /* contribute for the depolarization due to the finit filter width
     in connection to the cromatism of the have wave plate zero angle */

  if (ilog[0]){
    for (i = 0 ; i < NNSTEP ; i++)
      depstheta[i] = cos(4*(depstheta[i] - epstheta)/RAD);
    
    depol *= integral(dfilter,depstheta,(dlambda[2]-dlambda[1]),NNSTEP) / 
      filtnorm;
  }


  printf("depol     = %8.4f\n",depol);







  if (ilog[2]){

    if (debug > 1)
      printf("open tables for inspol Q,U\n");

    SCKRDD ("OUTPUTD", 1, 3, &kact, dparam, &kun, &knul);

    stat = TCTOPN(e3in, F_I_MODE, &tide3);

    SCDRDI( tide3, "TBLCONTR", 4, 1, &kact, &nrow, &kun, &knul );
    TCCSER (tide3, ":LAMBDA", &col[0]);
    TCCSER (tide3, ":QINSPOL", &col[1]);
    TCCSER (tide3, ":UINSPOL", &col[2]);
  
    debuff = fvector(1,nrow);
    dlbuff = fvector(1,nrow);

    for (i = 0 ; i < nrow ; i++)
      {
	TCERDR (tide3, i+1, col[0], &dlbuff[i+1], &knul);
	TCERDR (tide3, i+1, col[1], &debuff[i+1], &knul);
      }

    interpol(dlbuff,debuff,nrow,dlambda,dqinspol,NNSTEP);

    if (debug > 2){
    printf("\n");
    for ( i = 0 ; i <= 20 ; i++)
      printf("%f %f %f %f \n",dlbuff[i+1],debuff[i+1],dlambda[i],dqinspol[i]);
    }


    for (i = 0 ; i < nrow ; i++)
      {
	TCERDR (tide3, i+1, col[2], &debuff[i+1], &knul);
      }

    interpol(dlbuff,debuff,nrow,dlambda,duinspol,NNSTEP);

    if (debug > 2){
    printf("\n");
    for ( i = 0 ; i <= NNSTEP ; i++)
      printf("%8.4f %8.4f \n",dlambda[i],duinspol[i]);
    }

    free_fvector(debuff,1,nrow);
    free_fvector(dlbuff,1,nrow);
    
    TCTCLO(tide3);


    qinspol = integral(dfilter,dqinspol,(dlambda[1]-dlambda[0]),NNSTEP) / 
      filtnorm;
    uinspol = integral(dfilter,duinspol,(dlambda[1]-dlambda[0]),NNSTEP) / 
      filtnorm;

  }
  else{
    for (i = 0 ; i < NNSTEP ; i++)
      dqinspol[i] = duinspol[i] = (double) 0.0;
    qinspol = uinspol = 0;
  }



  printf("qinspol   = %8.4f   uinspol = %8.4f  at paralactic angle %8.2f\n",qinspol,uinspol,dparam[2]);



  if (inmode != TTTABLE)
    {

      stat = SCFOPN(qin, D_R4_FORMAT, 0, F_IMA_TYPE, &imin1);
      stat = SCFOPN(uin, D_R4_FORMAT, 0, F_IMA_TYPE, &imin2);

      SCDRDI( imin1, "NAXIS", 1, 1, &kact, &naxis, &kun, &knul );
      SCDRDI( imin1, "NPIX",  1, naxis, &kact, &npix[0],  &kun, &knul );
      SCDRDD( imin1, "START", 1, naxis, &kact, &start[0], &kun, &knul );
      SCDRDD( imin1, "STEP",  1, naxis, &kact, &step[0],  &kun, &knul );



      if (debug > 1)
	printf("create output\n");
      
      dqinbuff =  fvector(0,npix[0]);  
      duinbuff =  fvector(0,npix[0]);  
      dqoutbuff =  fvector(0,npix[0]);  
      duoutbuff =  fvector(0,npix[0]);  
      dqinebuff =  fvector(0,npix[0]);  
      duinebuff =  fvector(0,npix[0]);  
      dqoutebuff =  fvector(0,npix[0]);  
      duoutebuff =  fvector(0,npix[0]);  
  
      fsize = npix[0] * npix[1];
      SCFCRE( qout, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, &imout1 );
      SCFCRE( uout, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, &imout2 );
      SCDCOP( imin1, imout1, 1, "");
      SCDCOP( imin2, imout2, 1, "");
  

      if (debug > 1)
	printf("open frames with/for standard deviation\n");

      strcat(qin,"E\0");
      strcat(uin,"E\0");
      strcat(qout,"E\0");
      strcat(uout,"E\0");
      
      stat = SCFOPN(qin, D_R4_FORMAT, 0, F_IMA_TYPE, &imine1);
      stat = SCFOPN(uin, D_R4_FORMAT, 0, F_IMA_TYPE, &imine2);
      
      
      SCFCRE( qout, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, &imoute1 );
      SCFCRE( uout, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, &imoute2 );
      SCDCOP( imine1, imoute1, 1, "");
      SCDCOP( imine2, imoute2, 1, "");
      
      
      if (debug > 1)
	printf("open frames for p and theta\n");
      
      istrlen = strlen(qout) - 2;
      strncpy(cbuff,qout,istrlen);
      strcpy(&cbuff[istrlen],"\0");
      strcat(cbuff,"p\0");
      SCFCRE( cbuff, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, &imp );
      strcat(cbuff,"E\0");
      SCFCRE( cbuff, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, &impe );
      
      istrlen = strlen(qout) - 2;
      strncpy(cbuff,qout,istrlen);
      strcpy(&cbuff[istrlen],"\0");
      strcat(cbuff,"c\0");
      SCFCRE( cbuff, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, &impc );
      
      strncpy(cbuff,qout,istrlen);
      strcpy(&cbuff[istrlen],"\0");
      strcat(cbuff,"t\0");
      SCFCRE( cbuff, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, &imt );
      strcat(cbuff,"E\0");
      SCFCRE( cbuff, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE, fsize, &imte );
      
      SCDCOP( imin1, imp, 1, "");
      SCDCOP( imin1, impe, 1, "");
      SCDCOP( imin1, imt, 1, "");
      SCDCOP( imin1, imte, 1, "");
      SCDCOP( imin1, impc, 1, "");

      dpbuff =  fvector(0,npix[0]);  
      dpebuff =  fvector(0,npix[0]);  
      dtbuff =  fvector(0,npix[0]);  
      dtebuff =  fvector(0,npix[0]);  

      
      if (debug > 1)
	printf("loop columns\n");


      for (j = 0 ; j < npix[1] ; j++){

	/*
	  calculate corrected Stokes parameters Q,U
	  */

	SCFGET(imin1,j*npix[0]+1,npix[0],&kact, (char *) dqinbuff);
	SCFGET(imin2,j*npix[0]+1,npix[0],&kact, (char *) duinbuff);

	for (i = 0; i < npix[0] ; i++)
	  {
	    dqoutbuff[i] = (float) (dqinbuff[i] * cos(epstheta*TORAD) + 
				    duinbuff[i] * sin(epstheta*TORAD) ) / 
	      depol;
	    duoutbuff[i] = (float) (duinbuff[i] * cos(epstheta*TORAD) - 
				    dqinbuff[i] * sin(epstheta*TORAD) ) / 
	      depol;


	    dqoutbuff[i] += ((float) qinspol * cos(dparam[2]*TORAD) + 
			     (float) uinspol * sin(dparam[2]*TORAD));
	    duoutbuff[i] += ((float) uinspol * cos(dparam[2]*TORAD) - 
			     (float) qinspol * sin(dparam[2]*TORAD));

	  }
    
	SCFPUT(imout1, j*npix[0]+1, npix[0], (char *) dqoutbuff);
	SCFPUT(imout2, j*npix[0]+1, npix[0], (char *) duoutbuff);


	/*
	  calculate standard deviation of the corrected Stokes parameters Q,U
	  */

	SCFGET(imine1,j*npix[0]+1,npix[0],&kact, (char *) dqinebuff);
	SCFGET(imine2,j*npix[0]+1,npix[0],&kact, (char *) duinebuff);

	for (i = 0; i < npix[0] ; i++)
	  {
	    dqoutebuff[i] = 
	      sqrt( SQR(dqinebuff[i] * cos(epstheta*TORAD)) + 
		    SQR(duinebuff[i] * sin(epstheta*TORAD) )) / depol;
	    duoutebuff[i] = 
	      sqrt( SQR(duinebuff[i] * cos(epstheta*TORAD)) + 
		    SQR(dqinebuff[i] * sin(epstheta*TORAD) )) / depol;
	  }
	
	SCFPUT(imoute1, j*npix[0]+1, npix[0], (char *) dqoutebuff);
	SCFPUT(imoute2, j*npix[0]+1, npix[0], (char *) duoutebuff);


	
	/*
	  calculate p and theta and the standard deviation
	  */

	linpol(dqoutbuff, dqoutebuff, duoutbuff, duoutebuff, dpbuff, dpebuff,
	       dtbuff, dtebuff, npix[0], 10, 1);

	SCFPUT(impc, j*npix[0]+1, npix[0], (char *) dpbuff);
	SCFPUT(impe, j*npix[0]+1, npix[0], (char *) dpebuff);
	SCFPUT(imt, j*npix[0]+1, npix[0], (char *) dtbuff);
	SCFPUT(imte, j*npix[0]+1, npix[0], (char *) dtebuff);
	
	linpol(dqoutbuff, dqoutebuff, duoutbuff, duoutebuff, dpbuff, dpebuff,
	       dtbuff, dtebuff, npix[0], 10, 0);
	
	SCFPUT(imp, j*npix[0]+1, npix[0], (char *) dpbuff);
	
      }


      SCFCLO(imout1);
      SCFCLO(imout2);
      SCFCLO(imin1);
      SCFCLO(imin2);

  
      SCFCLO(imoute1);
      SCFCLO(imoute2);
      SCFCLO(imine1);
      SCFCLO(imine2);

      SCFCLO(imp);
      SCFCLO(impe);
      SCFCLO(imt);
      SCFCLO(imte);
      SCFCLO(impc);


      free_fvector(dpbuff,0,npix[0]);  
      free_fvector(dpebuff,0,npix[0]);  
      free_fvector(dtbuff,0,npix[0]);  
      free_fvector(dtebuff,0,npix[0]);  


      free_fvector(dqinbuff,0,npix[0]);  
      free_fvector(duinbuff,0,npix[0]);  
      free_fvector(dqoutbuff,0,npix[0]);  
      free_fvector(duoutbuff,0,npix[0]);  
      free_fvector(dqinebuff,0,npix[0]);  
      free_fvector(duinebuff,0,npix[0]);  
      free_fvector(dqoutebuff,0,npix[0]);  
      free_fvector(duoutebuff,0,npix[0]);  

    }
  else
    {
      printf ("open table with polarimetry %s\n",qin);

      stat = TCTOPN(qin, F_IO_MODE, &tidin);
      
      SCDRDI( tidin, "TBLCONTR", 4, 1, &kact, &nrow, &kun, &knul );

      printf ("search input columns\n");

      TCCSER (tidin, ":Q", &ocol[0]);
      TCCSER (tidin, ":Qerr", &ocol[1]);
      TCCSER (tidin, ":U", &ocol[2]);
      TCCSER (tidin, ":Uerr", &ocol[3]);

      if (debug > 2)
      printf ("search output columns\n");

      TCCSER (tidin, ":cQ", &ocol[4]);
      TCCSER (tidin, ":cQerr", &ocol[5]);
      TCCSER (tidin, ":cU", &ocol[6]);
      TCCSER (tidin, ":cUerr", &ocol[7]);
      if (ocol[4] == -1) 
	TCCINI(tidin, D_R4_FORMAT, 1, "F9.6", " ", "cQ", &ocol[4]);
      if (ocol[5] == -1) 
	TCCINI(tidin, D_R4_FORMAT, 1, "F9.6", " ", "cQerr", &ocol[5]);
      if (ocol[6] == -1) 
	TCCINI(tidin, D_R4_FORMAT, 1, "F9.6", " ", "cU", &ocol[6]);
      if (ocol[7] == -1) 
	TCCINI(tidin, D_R4_FORMAT, 1, "F9.6", " ", "cUerr", &ocol[7]);


      TCCSER (tidin, ":cpol", &ocol[8]);
      TCCSER (tidin, ":cpolerr", &ocol[9]);
      TCCSER (tidin, ":ctheta", &ocol[10]);
      TCCSER (tidin, ":cthetaerr", &ocol[11]);
      if (ocol[8] == -1) 
	TCCINI(tidin, D_R4_FORMAT, 1, "F9.6", " ", "cpol", &ocol[8]);
      if (ocol[9] == -1) 
	TCCINI(tidin, D_R4_FORMAT, 1, "F9.6", " ", "cpolerr", &ocol[9]);
      if (ocol[10] == -1) 
	TCCINI(tidin, D_R4_FORMAT, 1, "F9.6", " ", "ctheta", &ocol[10]);
      if (ocol[11] == -1) 
	TCCINI(tidin, D_R4_FORMAT, 1, "F9.6", " ", "cthetaerr", &ocol[11]);

  


      if (debug > 2)
	printf ("open buffers\n");

      dqinbuff = fvector(0,nrow);
      dqinebuff = fvector(0,nrow);
      duinbuff = fvector(0,nrow);
      duinebuff = fvector(0,nrow);

      dqoutbuff =  fvector(0,nrow);  
      dqoutebuff =  fvector(0,nrow);  
      duoutbuff =  fvector(0,nrow);  
      duoutebuff =  fvector(0,nrow);  


      if (debug > 2)
	printf ("compute results\n");

      for (i = 0 ; i < nrow ; i++)
	{
	  TCERDR (tidin, i+1, ocol[0], &dqinbuff[i], &knul);
	  TCERDR (tidin, i+1, ocol[1], &dqinebuff[i], &knul);
	  TCERDR (tidin, i+1, ocol[2], &duinbuff[i], &knul);
	  TCERDR (tidin, i+1, ocol[3], &duinebuff[i], &knul);


	  dqoutbuff[i] = (float) (dqinbuff[i] * cos(epstheta*TORAD) + 
				  duinbuff[i] * sin(epstheta*TORAD) ) / 
	    depol;
	  duoutbuff[i] = (float) (duinbuff[i] * cos(epstheta*TORAD) - 
				  dqinbuff[i] * sin(epstheta*TORAD) ) / 
	    depol;


	  dqoutbuff[i] += ((float) qinspol * cos(dparam[2]*TORAD) + 
			   (float) uinspol * sin(dparam[2]*TORAD));
	  duoutbuff[i] += ((float) uinspol * cos(dparam[2]*TORAD) - 
			   (float) qinspol * sin(dparam[2]*TORAD));
	  
	  dqoutebuff[i] = 
	    sqrt( SQR(dqinebuff[i] * cos(epstheta*TORAD)) + 
		  SQR(duinebuff[i] * sin(epstheta*TORAD) )) / depol;
	  duoutebuff[i] = 
	    sqrt( SQR(duinebuff[i] * cos(epstheta*TORAD)) + 
		  SQR(dqinebuff[i] * sin(epstheta*TORAD) )) / depol;

	  
	  TCEWRR (tidin, i+1, ocol[4], &dqoutbuff[i]);
	  TCEWRR (tidin, i+1, ocol[5], &dqoutebuff[i]);
	  TCEWRR (tidin, i+1, ocol[6], &duoutbuff[i]);
	  TCEWRR (tidin, i+1, ocol[7], &duoutebuff[i]);

	}


      if (debug > 2)
	printf ("open buffers for p,theta\n");


      dpbuff =  fvector(0,nrow);  
      dpebuff =  fvector(0,nrow);  
      dtbuff =  fvector(0,nrow);  
      dtebuff =  fvector(0,nrow);  


      if (debug > 2)
	printf ("compute p,theta\n");

      linpol(dqoutbuff, dqoutebuff, duoutbuff, duoutebuff, dpbuff, dpebuff,
	     dtbuff, dtebuff, nrow, 20, 1);


      if (debug > 2)
	printf ("write result to table\n");

      for (i = 0 ; i < nrow ; i++)
	{
	  TCEWRR (tidin, i+1, ocol[8], &dpbuff[i]);
	  TCEWRR (tidin, i+1, ocol[9], &dpebuff[i]);
	  TCEWRR (tidin, i+1, ocol[10], &dtbuff[i]);
	  TCEWRR (tidin, i+1, ocol[11], &dtebuff[i]);
	}


      TCTCLO(tidin);

    }





  if (debug > 1)
    printf("dealocate memory\n");
  

  free_fvector(depstheta,0,npix[0]);
  free_fvector(ddepol ,0,npix[0]);
  free_fvector(dqinspol,0,npix[0]);
  free_fvector(duinspol,0,npix[0]);
  free_fvector(dlambda,0,npix[0]);



  SCSEPI ();
  exit(0);
  return;

}



#ifdef __STDC__
int     
interpol(float x1[], float y1[], int n1, float x2[], float y2[], int n2)
#else
int     
interpol(x1, y1, n1, x2, y2, n2)
int n1,n2;
float x1[],y1[],x2[],y2[];
#endif
{
  int i,istart=0;


  float *buff;

  buff = fvector(1,n1);

  spline(x1, y1, n1, 1.0e30, 1.0e30, buff);

  for (i = 0 ; i < n2 ; i++)
    splint(x1, y1, buff, n1, x2[i], &y2[i]);

  free_fvector(buff,1,n1);


  return 0;
}



#ifdef __STDC__
float     
integral(float x1[], float y1[], float dlambda, int n1)
#else
float
integral(x1, y1, dlambda, n1)
int n1;
float x1[],y1[], dlambda;
#endif
{
  
  int i;
  float sum=0;

  for (i = 0 ; i < n1 ; i++)
    sum += x1[i] * y1[i] * dlambda;

  return sum;
}








