! +++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT    (C) 1997 Landessternwarte Heidelberg
!.IDENT        mosdefine.prg
!.AUTHORS      Sabine Moehler (LSW)
!              Otmar Stahl (LSW)
!	       Thomas Szeifert
!.KEYWORDS     Spectroscopy, MOS
!  
!.PURPOSE      execute the command DEFINE/MOS
!
!.VERSION      1.0 Creation 02/07/94
!	       2.0 Clear the Midas shell 25/04/97 (TS0497)
!
! DEFINE/MOS image mos_table windows_table threshold window binning plot_option
!
! -------------------------------------------------
!
CROSSREF OBJECT MOS WINDOWS THRESH WIND XBIN CENTMET
!
DEFINE/PARAM P1 {OBJ}      IMAGE   "Enter input image:"
DEFINE/PARAM P2 {MOS}      TABLE   "Enter MOS table:"
DEFINE/PARAM P3 {WINDOWS}  TABLE   "Enter output table:"
DEFINE/PARAM P4 {THRESH}   NUMBER  "Threshold:"
DEFINE/PARAM P5 {WIND}     NUMBER  "Search Window in X:"
DEFINE/PARAM P6 {XBIN}     NUMBER  "Number of Pixels in X for Average:"
DEFINE/PARAM P7 {SCAN_POS} NUMBER  "center for scan (world coordinates)"
DEFINE/PARAM P8 1          NUMBER  "Plot option"


DEFINE/LOCAL IOSTRNG/C/1/80 "{P1} {P2} {P3} {P4} {P5} {P6} "
DEFINE/LOCAL QUALIF/C/1/60 {MID$CMND(11:14)}
DEFINE/LOCAL SCAN/D/1/1 {P7}
DEFINE/LOCAL FLAG/I/1/1 {P8}

WRITE/KEYW IN_A  {P1}
WRITE/KEYW IN_B  {P2}
WRITE/KEYW OUT_A {P3}

WRITE/KEYW INPUTI {P5},{P6},{P8}
WRITE/KEYW INPUTR {P4}


IF M$ABS(SCAN) .LT. 1.0e-18 THEN
  SCAN = {{in_a},npix(1)} / 2.0 * {{in_a},step(1)} + {{in_a},start(1)}	
ENDIF

IF {FLAG} .LT. 2 THEN
  RUN STD_EXE:MOSDEFINE
ENDIF

IF {FLAG} .GT. 0 THEN
  DEFI/WIND LOAD P5={P2} P6={P3}
ENDIF


IF {FLAG} .GT. 1 THEN
  SCAN = ({SCAN} - {{P1},start(1)})/{{P1},step(1)}	
  @s mosdefman {IOSTRNG} {SCAN} -1
ENDIF


IF {FLAG} .GT. 1 THEN
  SET/MIDAS OUTPUT=NO	
  DEFI/WIND LOAD P5={P2} P6={P3}
  SET/MIDAS OUTPUT=YES	
ENDIF


IF {FLAG} .LT. 2 THEN
  WRITE/OUT "   To Improve the results interactively (P8=2) type: " 
  WRITE/OUT "   DEFI/MOS {IOSTRNG} {SCAN} 2"	
  WRITE/OUT	
ENDIF









