/* mosdefman.c  - in construction!!! 


mosdefman does the work of the interactive part of mosdefine.prg


        by Thomas Szeifert               LSW Heidelberg 0497 
*/

#include <math.h> 
#include <midas_def.h>
#include <plot_def.h>
#include <proto_fors.h>

#define FARR_SIZE 99
#define STRGLEN 80
#define inull 0
#define KEY_EXIT        32        /* AGL key code for middle mouse buton */
#define NOT_OK -9999

#ifdef __STDC__
void overmos(float *, float *, int *, int, float [], int);
#else
void overmos();
#endif


int debug = 0;
float fnull = 0.0;

int
main()
{
  int iav,kun,knul;
  int min_dist,min_sky,nsky,nobj,param[4];
  int Naxis,Npix[2];
  int tidslit,ncol,nrow,nsort,acol,arow,icol[3];
  int tidwind,wcol,wrow,wsort,jcol[7];
  int ipxl;
  int actval,plmode;

  int imno,i,j,k,select;
  int itmp,istrt;
  int key = KEY_EXIT - 1, bothkey = KEY_EXIT - 1;
  int iselmos = -1,*idobj,*idsky,nsobj=0,nssky=0;
  int success = 0;
  int *ilower, *iupper,iobjstrt,iobjend,iskystrt,iskyend;


  char output[STRGLEN];
  char obj_image[60], slit_table[60], window_table[60], method[3], qualif[4];
  char plcmeta[STRGLEN],devnam[STRGLEN];

  float rpar;
  float *slit,*lower,*upper;
  float *objslit,*objstrt,*objend,*netintens,*skyslit,*skystrt,*skyend;
  float *buff,med;
  float xmnmx[4],ymnmx[4];
  float *xscan,*yscan,xcurs[2],ycurs[2];

  float fbuff,xbuff,ybuff, fdef, ssize=2.0;


  double Start[2], Step[2];

  fdef = 65636.0;

  SCSPRO("mosdefman");
   
  if (debug > 0) printf ("read keywords \n");

  SCKGETC("IN_A",1,60,&iav,obj_image);
  SCKGETC("IN_B",1,60,&iav,slit_table);
  SCKGETC("OUT_A",1,60,&iav,window_table);
  SCKGETC("INPUTC",1,3,&iav,method);
  SCKRDI("INPUTI",1,4,&iav,param,&kun,&knul);
  SCKRDR("INPUTR",1,1,&iav,&rpar,&kun,&knul);

  SCKGETC ("QUALIF",  1, 4, &iav, qualif);
  
  SCKRDI("MIN_DIST",1,1,&iav,&min_dist,&kun,&knul);
  SCKRDI("MIN_SKY",1,1,&iav,&min_sky,&kun,&knul);

  if (debug > 0) printf ("open frame and read descriptors \n");

  if ( SCFOPN(obj_image , D_R4_FORMAT, 0, F_IMA_TYPE, &imno ) != 0 ) {
    sprintf( output, "Frame %s invalid...", obj_image );
    SCTPUT( output );
    return;
  }

  SCDRDI( imno, "NAXIS", 1, 1, &iav, &Naxis, &kun, &knul );
  SCDRDI( imno, "NPIX", 1, 2, &iav, Npix, &kun, &knul );
  if ( Naxis == 1 )
    Npix[1] = 1;
  SCDRDD( imno, "START", 1, 2, &iav, Start, &kun, &knul );
  SCDRDD( imno, "STEP", 1, 2, &iav, Step, &kun, &knul );




  /* 
     Read table MOS to get limits of slitlets  
  */


  if (debug > 0) printf ("read mos table \n");

  TCTOPN(slit_table,F_I_MODE,&tidslit);
  TCIGET(tidslit,&ncol,&nrow,&nsort,&acol,&arow);
  
  if (debug > 1) printf ("malloc \n");
  slit = fvector(0,nrow+1);
  lower = fvector(0,nrow+1);
  upper = fvector(0,nrow+1);
  ilower = ivector(0,nrow+1);
  iupper = ivector(0,nrow+1);

  if (debug > 1) printf ("tclser \n");
  TCLSER(tidslit, "slit", &icol[0]);
  TCLSER(tidslit, "ystart", &icol[1]);
  TCLSER(tidslit, "yend", &icol[2]);

  if (debug > 1) printf ("read selected \n");
  for (i=1;i<=nrow;i++) 
    {
      if (debug > 2) printf ("read row %d of %d\n",i,nrow);
      TCSGET(tidslit, i, &select);
      if (select)
	{
	  TCERDR(tidslit, i, icol[0], &slit[i-1] , &knul);
	  if (slit[i-1] == param[3]) iselmos = i-1;
	  TCERDR(tidslit, i, icol[1], &lower[i-1], &knul);
	  ilower[i-1] = NINT((lower[i-1]-Start[1])/Step[1]);
	  TCERDR(tidslit, i, icol[2], &upper[i-1], &knul);
	  iupper[i-1] = NINT((upper[i-1]-Start[1])/Step[1]);
	  if (debug > 1)
	    printf ("ilower %d - iupper %d\n",ilower[i-1],iupper[i-1]);
	}
    }
  
  if (iselmos < 0){
    sprintf (output,"slitlet %4d isn't selected or does't extist",param[3]);
    SCTPUT (output);
    SCSEPI(); 
    exit(0);
  }




  /* 
     Read table WINDOWS:
  */

  if (debug > 0) printf ("read window table \n");

  TCTOPN(window_table,F_IO_MODE,&tidwind);
  TCIGET(tidwind,&wcol,&wrow,&wsort,&acol,&arow);


  SCDRDI(tidwind,"NOBJ",1,1,&iav,&nobj,&kun,&knul);
  SCDRDI(tidwind,"NSKY",1,1,&iav,&nsky,&kun,&knul);

 
  objslit = (float *) osmmget((FARR_SIZE)*sizeof(float));
  objstrt = (float *) osmmget((FARR_SIZE)*sizeof(float));
  objend = (float *) osmmget((FARR_SIZE)*sizeof(float));
  netintens = (float *) osmmget((FARR_SIZE)*sizeof(float));
  skyslit = (float *) osmmget((FARR_SIZE)*sizeof(float));
  skystrt = (float *) osmmget((FARR_SIZE)*sizeof(float));
  skyend = (float *) osmmget((FARR_SIZE)*sizeof(float));
  idobj = (int *) osmmget((FARR_SIZE)*sizeof(int));
  idsky = (int *) osmmget((FARR_SIZE)*sizeof(int));
  
  TCLSER(tidwind, "Obj_Slit", &jcol[0]);
  TCLSER(tidwind, "Obj_Strt", &jcol[1]);
  TCLSER(tidwind, "Obj_End", &jcol[2]);
  TCLSER(tidwind, "Net_Intens", &jcol[3]);
  TCLSER(tidwind, "Sky_Slit", &jcol[4]);
  TCLSER(tidwind, "Sky_Strt", &jcol[5]);
  TCLSER(tidwind, "Sky_End", &jcol[6]);
  
  
  for (i=1;i<=nobj;i++) 
    {
      TCERDR(tidwind, i, jcol[0], &objslit[i-1] , &knul);
      if (knul) objslit[i-1] = inull;
      TCERDR(tidwind, i, jcol[1], &objstrt[i-1] , &knul);
      if (knul) objstrt[i-1] = inull;
      TCERDR(tidwind, i, jcol[2], &objend[i-1] , &knul);
      if (knul) objend[i-1] = inull;
      TCERDR(tidwind, i, jcol[3], &netintens[i-1] , &knul);
      if (knul) netintens[i-1] = inull;

      if (objslit[i-1] == param[3]){/*pik out objects in a given slitlets*/
	idobj[nsobj] = i-1;
	nsobj++;
      }
    }
  for (i=1;i<=nsky;i++) 
    {
      TCERDR(tidwind, i, jcol[4], &skyslit[i-1] , &knul);
      if (knul) skyslit[i-1] = inull;
      TCERDR(tidwind, i, jcol[5], &skystrt[i-1] , &knul);
      if (knul) skystrt[i-1] = inull;
      TCERDR(tidwind, i, jcol[6], &skyend[i-1] , &knul);
      if (knul) skyend[i-1] = inull;

      if (skyslit[i-1] == param[3]){/*pik out skies in a given slitlets*/
	idsky[nssky] = i-1;
	nssky++;
      }
    }
  
  
   


  /*
    Compute median along YAXIS:
  */

  buff = fvector(0,param[1]+1);
  xscan = fvector(0,Npix[1]+1);
  yscan = fvector(0,Npix[1]+1);

  if (debug > 0) printf ("read row by row \n");

  for (i = 0 ; i < Npix[1] ; i++) 
    {
      ipxl = param[2] - (int) (param[1]/2.0);

      SCFGET(imno, (i*Npix[0]+ipxl), param[1], &knul, (char*) buff );
      yscan[i] = (float) heap_median(param[1], buff); 
      xscan[i] = (float) Start[1] + i * (float) Step[1];
      if (debug > 3)
	printf ("%d %8.2f %8.2f \n",i,xscan[i],yscan[i]);
    }
  

  if (debug > 0) printf ("open plot interface and read plot keywords \n");

  PCKRDC ("PLNAME", STRGLEN, &actval, plcmeta);
  PCKRDC ("DNAME", 60, &actval, devnam);





  itmp = (int) iupper[iselmos]- ilower[iselmos];
  istrt = (int) ilower[iselmos];

  for (i = istrt ; i <= istrt+itmp ; i++) 
    {
      if (i == istrt){    /* minmax for plot */
	ymnmx[0] = 65636.0;
	ymnmx[1] = 0.0;
      }
      if (yscan[i] > ymnmx[1]) 
	ymnmx[1] = yscan[i];
      else if (yscan[i] < ymnmx[0] && yscan[i] != fnull)
	ymnmx[0] = yscan[i];
    }


  /*
    Get frame's axis and tickmark's specifications:
  */

  fbuff = ymnmx[1]/10.0;
  ymnmx[0] = ymnmx[0] - fbuff/2.0;
  ymnmx[1] = ymnmx[1] + fbuff;


  if (debug > 1)
    printf ("%8.2f %8.2f \n",ymnmx[0],ymnmx[1]);

  if (debug > 1)
    printf ("%8.2f %8.2f %8.2f \n",ymnmx[0],ymnmx[1], rpar * (-1000.0) );


  for (i=0;i<5;i++)
    {
      if ( (ymnmx[1] - ymnmx[0]) > 2.0 * (float) pow(10.0, (double) i))
	{
	  ymnmx[2] = (float) pow(10.0 , (float) i);
	  ymnmx[3] = ymnmx[2] / 5.0;
	}
      else if ( 2.0*(ymnmx[1] - ymnmx[0]) > (float) pow(10.0, (double) i))
	{
	  ymnmx[2] = (float) (pow(10.0, (double) i) / 4.0);
	  ymnmx[3] = ymnmx[2] / 5.0;
	}
    }


  xmnmx[0] = lower[iselmos] - 3.0 * (float) Step[1];
  xmnmx[1] = upper[iselmos] + 3.0 * (float) Step[1];

  for (i = 0;i<4;i++)
    {
      if ( (xmnmx[1] - xmnmx[0]) > 2.0 * (float) pow(10.0, (double) i))
	{
	  xmnmx[2] = (float) pow(10.0 , (double) i);
	  xmnmx[3] = xmnmx[2] / 5.0;
	}
      else if ( 2.0*(xmnmx[1] - xmnmx[0]) > (float) pow(10.0, (double) i))
	{
	  xmnmx[2] = (float) pow(10.0, (double) i) / 4.0;
	  xmnmx[3] = xmnmx[2] / 5.0;
	}
    }




  /*
    Plot axis and resulting median profile along YAXIS:
  */

  PCKWRR ("SSIZE", 1, &ssize); 
  PCKWRR ("XWNDL", 4, xmnmx);
  PCKWRR ("YWNDL", 4, ymnmx);

  if (debug > 1)    printf("PCOPEN\n");
  PCOPEN (" "," ", 0, &plmode);

  if (debug > 1)    printf("PCFRAM\n");
  PCFRAM(xmnmx,ymnmx,"Y_Coord","Median of Intensity along Y-Axes");
  
  itmp = (int) iupper[iselmos]- ilower[iselmos];
  istrt = (int) ilower[iselmos];

  if (debug > 1)    printf("PCDATA\n");


  PCDATA(0,1,1,&xscan[istrt],&yscan[istrt],0.0,itmp);


  overmos(objstrt,objend,idobj,nsobj,ymnmx,0);
  overmos(skystrt,skyend,idsky,nssky,ymnmx,1);


  /*
    Get cursors to identify boundaries for integration of star flux:
  */

  while ( !(key == KEY_EXIT && xcurs[0] == NOT_OK && xcurs[1] == NOT_OK) ) {  

    for (i = 0 ; i < 2 ; i++)
      xcurs[i] = ycurs[i] = NOT_OK;


    SCTPUT("\n... press left mouse button:  (middle button to exit) \n");

    while ( key != KEY_EXIT ) {
      sprintf (output,"    left  boundary   X_COORD = %8.2f   Y_COORD = %8.2f ",xcurs[0],ycurs[0]);
      SCTDIS(output,80);

      PCGCUR(&xbuff,&ybuff,&key);   
      if ( key != KEY_EXIT ){
	xcurs[0] = xbuff;
	ycurs[0] = ybuff;
	PCDATA(5,0,0,&xcurs[0],&ycurs[0],0.0,1);
	sprintf (output,"    left  boundary   X_COORD = %8.2f   Y_COORD = %8.2f ",xcurs[0],ycurs[0]);
	SCTDIS(output,80);
      }
    }
    if (xcurs[0] != NOT_OK)
      SCTPUT("");
    key--;
    

    while ( key != KEY_EXIT ) {
      sprintf (output,"    right boundary   X_COORD = %8.2f   Y_COORD = %8.2f ",xcurs[1],ycurs[1]);
      SCTDIS(output,80);
      PCGCUR(&xbuff,&ybuff,&key);
      if ( key != KEY_EXIT ){
	xcurs[1] = xbuff;
	ycurs[1] = ybuff;
	PCDATA(5,0,0,&xcurs[1],&ycurs[1],0.0,1);
	sprintf (output,"    right boundary   X_COORD = %8.2f   Y_COORD = %8.2f ",xcurs[1],ycurs[1]);
	SCTDIS(output,80);
      }
      else if (xcurs[1] == NOT_OK){
	sprintf (output,"                                                             ",xcurs[1],ycurs[1]);
	SCTDIS(output,80);
      }
    }

    SCTPUT("");

      
    /*
      store the results in the array for objects
    */

    if (xcurs[0] != NOT_OK && xcurs[1] != NOT_OK){
      success++;
      key--;
      if (success > nsobj)
	{
	  nsobj++;
	  nobj++;
	  if (nobj > wrow) wrow++;
	  idobj[success-1] = nobj-1;
	  objslit[idobj[success-1]] = param[3];
	}


      iobjstrt = NINT((xcurs[0] - Start[1])/Step[1]);
      iobjend = NINT((xcurs[1] - Start[1])/Step[1]);
      objstrt[idobj[success-1]] = xscan[iobjstrt];
      objend[idobj[success-1]] = xscan[iobjend];


      netintens[idobj[success-1]] = 0.0;
      fbuff = 65636.0;
      for (i = iobjstrt ; i <=  iobjend ; i++)
	if (netintens[idobj[success-1]] < yscan[i])
	  netintens[idobj[success-1]] = yscan[i];
	else if (fbuff > yscan[i])
	  fbuff = yscan[i];

      netintens[idobj[success-1]] = netintens[idobj[success-1]] - fbuff;

      if (debug > 2)
	printf ("%4d %4d %8.2f %8.2f %4.0f \n",(success-1),idobj[success-1],objstrt[idobj[success-1]], objend[idobj[success-1]], objslit[idobj[success-1]] );
      
      

    }
    /* overplot all new results */
    overmos(objstrt,objend,idobj,success,ymnmx,2);
      
  }

  /*
    write zero values to deleted objects
  */
  for (i = success; i < nsobj; i++)
    {
      objstrt[idobj[i]] = fnull;
      objend[idobj[i]] = fnull;
      netintens[idobj[i]] = fnull;
      objslit[idobj[i]] = fnull;
    }

  nsobj = success;
  j=0;
  k=0;

  /*
    store results in window table
  */

  for (i = 0; i < wrow; i++)
    {
      if (objslit[i] > 0){
	objstrt[j] = objstrt[i];
	objend[j] = objend[i];
	netintens[j] = netintens[i];
	objslit[j] = objslit[i];

	TCEWRR(tidwind,j+1, jcol[0], &objslit[j]);
	TCEWRR(tidwind,j+1, jcol[1], &objstrt[j]);
	TCEWRR(tidwind,j+1, jcol[2], &objend[j]);
	TCEWRR(tidwind,j+1, jcol[3], &netintens[j]);

	j++;
      }
      else{
	/* delete object's old table entries if necessary*/
	TCEDEL(tidwind,wrow-k, jcol[0]);
	TCEDEL(tidwind,wrow-k, jcol[1]);
	TCEDEL(tidwind,wrow-k, jcol[2]);
	TCEDEL(tidwind,wrow-k, jcol[3]);
	k++;
      }
    }

  SCKWRI ("NOBJ",&j,1,1,&kun);
  SCDWRI (tidwind,"NOBJ",&j,1,1,&kun);


  if (debug > 2)
    for (i = 0 ; i < nssky; i++)
      {
	printf("vorher  %4d %4d %8.2f %8.2f \n",i, idsky[i], skystrt[idsky[i]], skyend[idsky[i]]);
      }


  success = 0;

  /*
    prepare array with median values along y-axis for sky window determination
  */

  for ( i = 0 ; i < nsobj ; i++)
    {
      iobjstrt = NINT((objstrt[idobj[i]] - Start[1])/Step[1]);
      iobjend = NINT((objend[idobj[i]] - Start[1])/Step[1]);
      
      for ( j = iobjstrt-min_dist+1 ;j <= iobjend+min_dist-1;j++)
	  yscan[j] = NOT_OK;
    }

  k=0;

  iskystrt = ilower[iselmos];  /*initialize it for the first time*/
  iskyend = ilower[iselmos];

  for (i = ilower[iselmos]; i <= iupper[iselmos]; i++)
    {
      if ( yscan[i-1] == NOT_OK && yscan[i] > NOT_OK){
	/* initialize for the next sky window's boundaries*/
	iskystrt = i;
	iskyend = i;
      }
      if (yscan[i] > NOT_OK){
	k++;
	iskyend++;
	if (k >= min_sky && ( yscan[i+1] == NOT_OK || i == iupper[iselmos])) {
	  success++;

	  if (success > nssky){
	    /* more sky windows then before: */
	    nssky++;
	    nsky++;
	    if (nsky > wrow) wrow++;
	    idsky[success-1] = nsky-1;
	    skyslit[idsky[success-1]] = param[3];
	  }

	  skystrt[idsky[success-1]] = xscan[iskystrt];
	  skyend[idsky[success-1]]  = xscan[iskyend-2];

	  if (debug > 1)
	    printf("nachher %4d %4d %8.2f %8.2f %8.2f %d %d\n", success-1, idsky[success-1],skystrt[idsky[success-1]],skyend[idsky[success-1]],skyslit[idsky[success-1]],iskystrt,iskyend);
	  k=0;
	}
      }
    }

  /*
    overplot the new results
  */

  overmos(skystrt,skyend,idsky,success,ymnmx,3);

  /* 
     clear the deleted entries of the sky arrays 
  */
  if (debug > 2)
    printf ("%d %d",success, nssky);

  for (i = success; i < nssky; i++)
    {
      skystrt[idsky[i]] = fnull;
      skyend[idsky[i]] = fnull;
      skyslit[idsky[i]] = fnull;
    }

  
  j=0;
  k=0;

  /*
    write the new results into window table
  */

  for (i = 0; i < wrow; i++)
    {
      if (skyslit[i] > 0.1){
	skystrt[j] = skystrt[i];
	skyend[j] = skyend[i];
	skyslit[j] = skyslit[i];

	TCEWRR(tidwind,j+1, jcol[4], &skyslit[j]);
	TCEWRR(tidwind,j+1, jcol[5], &skystrt[j]);
	TCEWRR(tidwind,j+1, jcol[6], &skyend[j]);

	j++;
      }
      else{
	/* delete old table entries if we have less windows now*/
	TCEDEL(tidwind,wrow-k, jcol[4]);
	TCEDEL(tidwind,wrow-k, jcol[5]);
	TCEDEL(tidwind,wrow-k, jcol[6]);
	k++;
      }
    }

  SCKWRI ("NSKY",&j,1,1,&kun);
  SCDWRI (tidwind,"NSKY",&j,1,1,&kun);



  /*
    dealloc memory
  */
  osmmfree((char *) objslit);
  osmmfree((char *) objstrt);
  osmmfree((char *) objend);
  osmmfree((char *) netintens);
  osmmfree((char *) skyslit);
  osmmfree((char *) skystrt);
  osmmfree((char *) skyend);
  osmmfree((char *) idobj);
  osmmfree((char *) idsky);


  /*
    Finish the games:
  */
  PCCLOS();
  TCTCLO(tidslit);
  TCTCLO(tidwind);
  return SCSEPI();
}


/*---------------------------------------------------------------------------*/
#ifdef __STDC__
void overmos(float *xstrt, float *xend, int *id, int insel, float yscl[], int imod)
#else
void overmos(xstrt, xend, id, insel, yscl, imod)
int *id, insel, imod;
float *xstrt,*xend,yscl[];
#endif
{
  int i,icolour;
  float ybuff[2],xbuff[2];

  if (imod == 0)
    icolour = 4;
  else if (imod == 1)
    icolour = 3;
  else if (imod == 2)
    icolour = 2;
  if (imod == 3)
    icolour = 6;

  PCKWRI("COLOUR",1,&icolour);
  

  for (i = 0 ; i < insel ; i++)
    {
      xbuff[0] = xstrt[id[i]];
      xbuff[1] = xend[id[i]];

      ybuff[0] = (yscl[1] + yscl[0])/2.0 - yscl[3] * 2.0 * (float) imod; 
      ybuff[1] = ybuff[0];

      PCDATA (0,1,0,xbuff,ybuff,0.0,2);
      if (imod == 0 || imod == 2)
	PCDATA (17,0,0,xbuff,ybuff,0.0,2);
      else if (imod == 1 || imod == 3 )
	PCDATA (15,0,0,xbuff,ybuff,0.0,2);
    }

  icolour = 1;
  PCKWRI("COLOUR",1,&icolour);

}







