/* @(#)mosext.c	10.1 (ESO-IPG) 8/7/95 17:34:23 */

#include <math.h>
#include <midas_def.h>
#include <proto_fors.h>

#define mymax(A,B) ((A)  > (B) ? (A) : (B))
#define mymin(A,B) ((A)  < (B) ? (A) : (B))
#define myabs(A) ((A)  >  (float) 0.0 ? (A) : (-A))


extern void 
extract_objects (
#ifdef __STDC__
		 float[], float[], float[], float[], float[],
		 float[], float[], float[], int[], int[], int, float [],
		 int Npix[], int iparm[], float rparm[]
#endif
);




main ()

{
  int iparm[8];
  int i, iav;
  int nax, kun, knul, tid, imno1, imno2, imno3, imno4;
  int ncol, nobjects, nrow, acol, arow, nsort, select;
  int npix2[2], null[3], maxslit;
  int slitlen[100], slit[100], lower[100], object[100]; /*, upper[100]*/
  int icol[4], inull;
  int dunit;

  char inframe[60], table[60], outframe[60], skyframe[60], rawframe[60];
  float *inimage, *outimage, *skyimage;
  char unit[64], inst[72], line[80];

  float moscol[4], rparm[5], rnull;
  float *y, *z, *raw;
  /* float *x; */
  float *mask, *profile, *variance;

  double start[2], step[2], start2[2], step2[2], dnull;


  /* previously in the header as automatic variables:*/
  int Order, N_iter, Npix[2],debug;
  float Ron, Gain, Thres, V0;




/*         get into Midas and get parameters             */

  SCSPRO ("mosext");

  strcpy(inst,""), strcpy(unit,"");

  SCKGETC ("IN_A", 1, 60, &iav, inframe);
  SCKGETC ("IN_B", 1, 60, &iav, skyframe);
  SCKGETC ("INPUTC", 1, 60, &iav, table);
  SCKGETC ("OUT_A", 1, 60, &iav, outframe);
  SCKRDI ("INPUTI", 1, 8, &iav, iparm, &kun, &knul);
  SCKRDR ("INPUTR", 1, 8, &iav, rparm, &kun, &knul);

  Order  = iparm[0];
  N_iter = iparm[1];
  debug  = iparm[2];

  Ron = rparm[0];
  Gain = rparm[1];
  Thres = rparm[2];


  if (debug >= -1){
    SCTPUT ("\n ----------------------- ");
    sprintf (line, "Input image:           %s", inframe);
    SCTPUT (line);
    sprintf (line, "sky image:             %s", skyframe);
    SCTPUT (line);
    sprintf (line, "Input table:           %s", table);
    SCTPUT (line);
    sprintf (line, "Output image:          %s\n", outframe);
    SCTPUT (line);
    SCTPUT ("Input parameters: ");
    sprintf (line, "Order of fit:          %i", Order);
    SCTPUT (line);
    sprintf (line, "Number of iterations:  %i", N_iter);
    SCTPUT (line);
    sprintf (line, "Read-out-noise:    %8.2f", Ron);
    SCTPUT (line);
    sprintf (line, "Gain (e/ADU):      %8.2f", Gain);
    SCTPUT (line);
    sprintf (line, "Threshold (sigma): %8.2f", Thres);
    SCTPUT (line);
  }

  /*
  V0 = (Ron * Ron) / (Gain * Gain);
  Thres = SQR(rparm[2]);
  */

/*          map input files                             */

  SCIGET (inframe, D_R4_FORMAT, F_I_MODE, F_IMA_TYPE,
	  2, &nax, Npix, start, step, inst, unit, (char **)&inimage, &imno1);

  SCIGET (skyframe, D_R4_FORMAT, F_I_MODE, F_IMA_TYPE,
	  2, &nax, Npix, start, step, inst, unit, (char **)&skyimage, &imno3);

/*           read table MOS                            */

  TCMNUL (&inull, &rnull, &dnull);
  TCTOPN (table, F_I_MODE, &tid);
  TCIGET (tid, &ncol, &nrow, &nsort, &acol, &arow);
  TCCSER (tid, ":Obj_Slit", &icol[0]);
  TCCSER (tid, ":Obj_Strt", &icol[1]);
  TCCSER (tid, ":Obj_End", &icol[2]);
  nobjects = 0;
  maxslit = 0;
  for (i = 1; i <= nrow; i++)
    {
      TCSGET (tid, i, &select);
      if (select)
	{
	  TCRRDR (tid, i, 3, icol, moscol, null);
	  if (!null[0] && !null[1] && !null[2])
	    {
	      slit[nobjects] = (int) moscol[0];
	      lower[nobjects] =  (int) ((moscol[1]-start[1])/step[1]) + 1;
	      object[nobjects] =  (int) ((moscol[2]-start[1])/step[1]) + 1;
	      slitlen[nobjects] = (object[nobjects] - lower[nobjects]) + 1;
	      maxslit = mymax (slitlen[nobjects], maxslit);
	      nobjects++;
	    }
	}
    }

  npix2[0] = Npix[0];
  npix2[1] = nobjects*2;
  step2[0] = step[0];
  step2[1] = 1.0;
  start2[0] = start[0];
  start2[1] = 1.0;

  TCTCLO (tid);

/*      open output file                                */

  SCIPUT (outframe, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE,
	  nax, npix2, start2, step2, inst, unit, (char **)&outimage, &imno2);

  SCDWRI (imno2, "YPOS", object, 1, nobjects, &dunit);
  SCDWRI (imno2, "SLIT", slit,   1, nobjects, &dunit);


  sprintf(rawframe,"middummd");
  SCIPUT (rawframe, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE,
	  nax, npix2, start2, step2, inst, unit, (char **)&raw, &imno4);

  SCDWRI (imno4, "YPOS", object, 1, nobjects, &dunit);
  SCDWRI (imno4, "SLIT", slit,   1, nobjects, &dunit);

  if (debug > -1)
    printf("equal weight spectrum: %s",rawframe);


/*      reserve storage for various arrays              */

  y = (float *) osmmget ((Npix[0]) * sizeof (float));
  z = (float *) osmmget ((Npix[0]) * sizeof (float));

  mask     = (float *) osmmget ((Npix[0]) * (maxslit) * sizeof (float));
  profile  = (float *) osmmget ((Npix[0]) * (maxslit) * sizeof (float));
  variance = (float *) osmmget ((Npix[0]) * (maxslit) * sizeof (float));

/*      do the extraction                               */


  extract_objects (inimage, outimage, skyimage,
		   mask, profile, variance, y, z,
		   lower, slitlen, nobjects,raw,
		   Npix, iparm, rparm);

/*          epilogue ...                 */

  osmmfree((char *) y), osmmfree((char *) z);
  osmmfree((char *) mask);
  osmmfree((char *) profile), osmmfree((char *) variance);

  SCSEPI ();

  return 1;
}


#ifdef __STDC__
void 
extract_objects (float inframe[], float outframe[], float skyframe[],
		 float mask[], float profile[], float variance[], 
		 float y[], float z[], int lower[],
		 int slitlen[], int nobjects, float raw[],
		 int Npix[], int iparm[], float rparm[])
#else
void 
extract_objects ( inframe, outframe, skyframe, mask, profile, variance, 
                  y, z, lower, slitlen, nobjects,raw, Npix,iparm,rparm)
  float inframe[],outframe[],skyframe[],mask[],profile[],raw[];
  float variance[],y[],z[],rparm[];
  int   lower[],slitlen[],nobjects,Npix[],iparm[];
#endif
{

  int nobject, k, jj, jj2, jj3,debug;
  char line[80];

  debug = iparm[2];

  if (debug > -1){
    SCTPUT ("\n ----------------------- ");
    SCTPUT (" object from to   ");
  }
/*          loop over all objects                         */

  for (nobject = 0; nobject < nobjects; nobject++)
    {
      for (k = 0; k < Npix[0]; k++)
	{
	  jj2 = nobject * Npix[0] + k;
	  outframe[jj2] = 0.0;
	}
      if (debug > -1){
	sprintf (line, " %4i   %4i %4i", nobject + 1, lower[nobject],
		 lower[nobject]+slitlen[nobject]-1);
	SCTPUT (line);
      }

      jj3 = (nobject+nobjects) * Npix[0];
      jj2 = nobject * Npix[0];
      jj = lower[nobject] * Npix[0];

/*      optimum extraction for one object               */

      modified_horne (&inframe[jj], &skyframe[jj], &outframe[jj2], 
		      &outframe[jj3],mask, profile, variance, y, z, 
		      slitlen[nobject],&raw[jj2],Npix, iparm, rparm); 

    }
  SCTPUT (" ----------------------- ");

  return;
}


#undef mymax
#undef mymin
#undef myabs











