! @(#)initquick.prg	
! 
!	Thomas Szeifert 	LSW Heidelberg		10.4.97
!
! 
DEFI/LOCA I/I/1/1 0
SET/MIDAS KEY=500,400

IF "{P1(1:1)}" .EQ. "?" THEN
   WRITE/OUT " "
   WRITE/OUT "Initializing key words"
   WRITE/OUT " "
   REGISTER/SESSION QUICK STD_PROC initquick.prg quicktab.tbl
!
!Begin Session List
!
   WRITE/KEY DLIST/C/1/60    "quick"     ! Descriptor table
   WRITE/KEY OSTABLE/C/1/60  "ost"       ! observation summary table 
   WRITE/KEY PREFIX/C/1/60   "*.fits"    ! prefix of data frames 
   WRITE/KEY OBSTYPE/C/1/60  "direct"    ! type of the observation
   WRITE/KEY OBSTYPE/C/1/60  "{P2}"      ! type of the observation
   WRITE/KEY OVERSCAN/C/1/60 "N"         ! overscan area
   WRITE/KEY USEAREA/C/1/60  "[<,<:>,>]" ! usefull area on detector
   WRITE/KEY OBJECT/C/1/60   "N"         ! target name 


   WRITE/KEY OBJQUIC/C/1/80  "target"    ! file with target spectrum 
   WRITE/KEY FLATQUIC/C/1/80 "flat"      ! file with flat field spectrum 
   WRITE/KEY WLCQUIC/C/1/80  "wlc"       ! file with calibration spectrum 


!
!
   WRITE/KEY NSET/I/1/1  5       ! number of setups
   WRITE/KEY CRBIAS/C/1/256 ":_EDE_TYPE.EQ."*Dark*".AND.:EXPTIME.lt.0.1" ! classification rules of bias 
   WRITE/KEY BIAS/C/1/60  bias    ! bias frame
!
   WRITE/KEY CROBJ1/C/1/256 :_EDE_TYPE.EQ."*Norm*".AND.:IDENT.NE."*Flat*".AND.:_EIO2_NAME.EQ."*U*" ! classif
   WRITE/KEY OBJ1/C/1/60        "OBJ1" ! target file name of 1st setup    
   WRITE/KEY CRFF1/C/1/256  :IDENT.EQ."*Flat*".AND.:_EIO2_NAME.EQ."*U*" ! classification of 1st flat field 
   WRITE/KEY FF1/C/1/60 "FF1" ! 1st flat field  
!
   WRITE/KEY CROBJ2/C/1/256  :_EDE_TYPE.EQ."*Norm*".AND.:IDENT.NE."*Flat*".AND.:_EIO2_NAME.EQ."*B*"         ! classif
   WRITE/KEY OBJ2/C/1/60 "OBJ2" ! target file name of 2nd setup 
   WRITE/KEY CRFF2/C/1/256  :IDENT.EQ."*Flat*".AND.:_EIO2_NAME.EQ."*B*" ! classification of 2nd flat field 
   WRITE/KEY FF2/C/1/60 "FF2" ! 2nd flat field  
!
   WRITE/KEY CROBJ3/C/1/256  :_EDE_TYPE.EQ."*Norm*".AND.:IDENT.NE."*Flat*".AND.:_EIO2_NAME.EQ."*V*" ! classif
   WRITE/KEY OBJ3/C/1/60 "OBJ3" ! target file name of 3rd setup 
   WRITE/KEY CRFF3/C/1/256  :IDENT.EQ."*Flat*".AND.:_EIO2_NAME.EQ."*V*" ! classification of 3rd flat field 
   WRITE/KEY FF3/C/1/60 "FF3" ! 3rd flat field 
!
   WRITE/KEY CROBJ4/C/1/256  :_EDE_TYPE.EQ."*Norm*".AND.:IDENT.NE."*Flat*".AND.:_EIO2_NAME.EQ."*R*" ! classif
   WRITE/KEY OBJ4/C/1/60 "OBJ4" ! target file name of 4th setup 
   WRITE/KEY CRFF4/C/1/256  :IDENT.EQ."*Flat*".AND.:_EIO2_NAME.EQ."*R*" ! classification of 3rd flat field 
   WRITE/KEY FF4/C/1/60 "FF4" ! 4th flat field 
!
   WRITE/KEY CROBJ5/C/1/256  :_EDE_TYPE.EQ."*Norm*".AND.:IDENT.NE."*Flat*".AND.:_EIO2_NAME.EQ."*I*" ! classif
   WRITE/KEY OBJ5/C/1/60 "OBJ5" ! target file name of 5th setup 
   WRITE/KEY CRFF5/C/1/256  :IDENT.EQ."*Flat*".AND.:_EIO2_NAME.EQ."*I*" ! classification of 3rd flat field 
   WRITE/KEY FF5/C/1/60 "FF5" ! 5th flat field 
!

ELSE

   COPY/TABLE {P1}DIRECT {OSTABLE}

   COPY/DD {P1}KEYW *,3 {P1}DIRECT.tbl
!   SAVINIT/QUICK {OSTABLE}.tbl READ
   SAVINIT/QUICK {P1}KEYW.bdf READ

   SET/FORMAT I1

   IF 	NSET .GT. 5 THEN
     DO I = 6 {{P1}DIRECT.tbl,NSET} 1
!      COPY/DK {P1}DIRECT.tbl CROBJ{I}/C/1/256 CROBJ{I}/C/1/256
!      COPY/DK {P1}DIRECT.tbl OBJ{I}/C/1/60 OBJ{I}/C/1/60
!      COPY/DK {P1}DIRECT.tbl CRFF{I}/C/1/256 CRFF{I}/C/1/256
!      COPY/DK {P1}DIRECT.tbl FF{I}/C/1/60 FF{I}/C/1/60
       COPY/DK {P1}KEYW.bdf CROBJ{I}/C/1/256 CROBJ{I}/C/1/256
       COPY/DK {P1}KEYW.bdf OBJ{I}/C/1/60 OBJ{I}/C/1/60
       COPY/DK {P1}KEYW.bdf CRFF{I}/C/1/256 CRFF{I}/C/1/256
       COPY/DK {P1}KEYW.bdf FF{I}/C/1/60 FF{I}/C/1/60
     ENDDO
   ENDIF	

   COPY/TABLE {P1}DESCR {DLIST} 

ENDIF





