!
!______________pre-reduction of mos frame_____________
!
!
DEFI/PARA P1 {OBJQUIC} ?  "ccd direct image:   		"
DEFI/PARA P2 {FLATQUIC} ? "flatfield image:   		"
DEFI/PARA P3 {WLCQUIC} ?  "wavelength calibration image: (or N: no WLC)  "
DEFI/PARA P4 {BIAS} ? "mean reduced bias frame:   	 (or N: no BIAS) "
DEFI/PARA P5 N ? "overscan area [@xst,@yst:@xend,@yend] (or type N)"
DEFI/PARA P6 {USEAREA} ?  "usefull area or slitlet number"
DEFI/PARA P7 ? ? "MOS session name:  (or N: only prereduction)"
!
DEFI/LOCA RBIAS/r/1/2 0.,0.
DEFI/LOCA EXIS/i/1/3 0 ALL
DEFI/LOCA ERR/i/1/1 0
DEFI/LOCA IN_1/c/1/60 {P1} !.bdf
DEFI/LOCA IN_2/c/1/60 {P2} !.bdf
DEFI/LOCA IN_3/c/1/60 {P3} !.bdf

DEFI/LOCA STRLEN/I/1/1 60

@s world2pixel {IN_1}
@s world2pixel {IN_2}
@s world2pixel {IN_3}

!
! check input parameters
!
EXIS(1) = m$exist(IN_1)
IF  EXIS(1) .eq. 0 ERR = 1
EXIS(2) = m$exist(IN_2)
IF  EXIS(2) .eq. 0 ERR = ERR + 2
EXIS(3) = m$exist(IN_3)
IF "{P3(1:2)}" .ne. "N " .OR. "{P3(1:2)}" .ne. "n " THEN
	IF EXIS(3) .ne. 1 ERR = ERR + 4
ELSE
	WRITE/OUT "... wavelength calibration from descriptors"
ENDIF
IF "{p4(1:2)}" .eq. "N " .OR. "{P4(1:2)}" .eq. "n " THEN 
	IF "{P5(1:2)}" .eq. "N " .or. "{P5(1:2)}" .eq. "n " ERR = ERR + 8
ENDIF
IF ERR .gt. 0 goto BADEND



!
! keyword stuff
!
IF "{P6(1:1)}" .ne. "[" then
      WRITE/KEY EXTR/C/1/{STRLEN} "[<,{{mos},:ystart,@{P6}}:>,{{mos},:yend,@{P6}}]"
ELSE
      WRITE/KEY EXTR/C/1/{STRLEN} "{P6}"
ENDIF


!
!!!!!!!!!!!!!!!!!!! PRE-REDUCTION	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! BIAS	
!
IF "{P4(1:2)} " .ne. "N " .or. "{P4(1:2)} " .ne. "n " then
	WRITE/OUT "... extract bias frame"
	EXTR/IMAG &b = {P4}{EXTR(1:{STRLEN})}
	SET/QUICK BIAS=&b 
ELSE
	WRITE/OUT "... bias correction in overscan area"
ENDIF
!
!	overscan area
!
IF "{P5(1:2)}" .ne. "N " .or. "{P5(1:2)}" .ne. "n " then
!
! TARGET	
!
	WRITE/OUT "... extract target; subtract bias"
	STAT/IMAG {P1} {P5} #512
	RBIAS(1)	= OUTPUTR(8)
	RBIAS(2)	= OUTPUTR(4)
	EXTR/IMAG &s = {P1}{EXTR(1:{STRLEN})}
	IF "{P4(1:1)}" .ne. "N" .or. "{P4(1:1)}" .ne. "n" then
		COMP/IMAG &t = &s - (&b + {OUTPUTR(8)})
	ELSE
		COMP/IMAG &t = &s - {OUTPUTR(8)}
	ENDIF
	SET/MOS OBJ=&t
!
! FLAT	
!
	WRITE/OUT "... extract flat field; subtract bias"
	STAT/IMAG {P2} {P5} #512
	RBIAS(1)	= OUTPUTR(8)
	RBIAS(2)	= OUTPUTR(4)
	EXTR/IMAG &s = {P2}{EXTR(1:{STRLEN})}
	IF "{P4(1:1)}" .ne. "N" .or. "{P4(1:1)}" .ne. "n" then
		COMP/IMAG &f = &s - (&b + {OUTPUTR(8)})
	ELSE
		COMP/IMAG &f = &s - {OUTPUTR(8)}
	ENDIF
	SET/MOS FLAT=&f
ELSE
!
!	no overscan area
!
! TARGET	
!
	WRITE/OUT "... extract target; subtract bias"
	EXTR/IMAG &s = {P1}{EXTR(1:{STRLEN})}
	COMP/IMAG &t = &s - &b
	SET/MOS OBJ=&t
!
! FLAT	
!
	WRITE/OUT "... extract flat field; subtract bias"
	EXTR/IMAG &s = {P2}{EXTR(1:{STRLEN})}
	COMP/IMAG &f = &s - &b
	SET/MOS FLAT=&f
ENDIF
!
! WLC
!
IF "{P3(1:1)}" .ne. "N" .or. "{P3(1:1)}" .ne. "n" then
	WRITE/OUT "... extract wlc field"
	EXTR/IMAG &w = {P3}{EXTR(1:{STRLEN})}	  
	SET/MOS WLC=&w
ELSE
	WRITE/OUT "... no wavelength calibration frame"
	SET/MOS WLC=N
ENDIF

!
! STANDARD MOS REDUCTION !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
IF "{P7}" .NE. "n " .OR. "{P7}" .NE. "N " THEN
	LONG/QUICK &t &f &w {P7} {P6} P8={P8}
ELSE
!	WRITE/OUT "extracted files: BIAS={BIAS} FLAT={FLAT} OBJECT={OBJ}"
!	WRITE/OUT "continue execution with LONG/QUICK"
	LONG/QUICK &t &f &w {P7} {P6} P8={P8}
ENDIF
goto end
!
!
!
BADEND:
WRITE/OUT "invalid input detected in longquick module:  ERR = {ERR}"
IF ERR .gt. 7 THEN
	WRITE/OUT "problem with bias input {P4} or overscan"	
	ERR = ERR - 8
ENDIF
IF ERR .gt. 3 then
	WRITE/OUT "problem with wlc input {P3}"	
	ERR = ERR - 4
ENDIF
IF ERR .gt. 1 then
	WRITE/OUT "problem with flat input {P2}"	
	ERR = ERR - 2
ENDIF
IF ERR .eq. 1 then
	WRITE/OUT "problem with target input {P1}"	
ENDIF	
!
!
!
end:

