!
!
!Reduce LongSlitSpektroskopy mostly automatically
!
!	
DEFI/PARA P1 {OBJ} ? "OBJECT NAME"
DEFI/PARA P2 {FLAT} ? "FLATFIELD NAME"
DEFI/PARA P3 {WLC} ? "WLC NAME"
DEFI/PARA P4 N ? "SESSION NAME"
DEFI/PARA P5 {USEAREA} ? "SLITLET"
DEFI/PARA P6 long_slit ? "table with long slit parameters"
DEFI/PARA P7 fors_grism ? "table with grism parameters"
DEFI/PARA P8 A	? "flag:"


DEFI/LOCA SAV/C/1/1 n
DEFI/LOCA LAM/R/1/2 0.,0.
DEFI/LOCA TMP/d/1/2 0.,0.
DEFI/LOCA SLNR/I/1/1 0
DEFI/LOCA SCA/C/1/12 "-3,1"




GRAPH/SPEC ? 520,30
create/display 0 1040,350
clear/disp
!load/lut idl4




!------------------------------------------------------------------------------
! initialize parameters
!------------------------------------------------------------------------------
init:
IF "{P4(1:2)}" .NE. "N " THEN
	init/mos {P4}
ELSE

  SET/MOS NORMMET=MEDIAN FFORD=20					!NORM
  SET/MOS SEAPAR=200,10,180 YBIN=5,5 CENTMET=GAUSS		!SEARCH

  IF "{LINECAT}" .EQ. "HgCd.tbl" SET/MOS SEAPAR=100,10

  IF "{{WLC},ESO.INS.OPTI3.NAME}" .EQ. "COLL_HR" THEN 
    SET/MOS   SEAPAR=50,10
  endif

  SELE/TABL {P6} :SLIT_NAME.EQ."*{{WLC},ESO.INS.OPTI2.NAME}*"
  SELE/TABL {P6} SELECT.AND.:COLLIMATOR.EQ."*{{WLC},ESO.INS.OPTI3.NAME}*"
  COPY/TABL {P6} &s
  COMP/TABL {MOS} :xoffset = {middumms.tbl,:xoffset,@1}

  SET/MOS MAXDEV=20 POLTYP=LEGENDRE				!CALIBR
  SET/MOS WLCORD=5,4,3 TOL=5					!
  SET/MOS LINFIT=coerbr 					!
  SET/MOS INT_LIM=0.05 MIN_DIST=1 MIN_SKY=2 THRESH=-3 WIND=10 	!DEFINE
  SET/MOS XBIN=150 SCAN_POS=1250				!
  SET/MOS SKYMET=POLYNOM SKYPAR=2 CCDPAR=10,1.3 REJTHRES=8	!SKYFIT
  SET/MOS SKYFRAME=sky						!
  SET/MOS EXTOBJ=extobj EXTPAR=3,3 				!EXTRACT
  SET/MOS CALOBJEC=ext						!APPLY

ENDIF




if "{p5(1:1)}" .ne. "[" then
  sele/tabl mos :slit.eq.{p5}
  SLNR = {P5}
else
  TMP(1) = {{p1}.bdf,START(2)}
  TMP(2) = {{p1}.bdf,START(2)} + {{p1}.bdf,STEP(2)} * ({{p1}.bdf,NPIX(2)} - 1)
  mos.tbl,:ystart,@1 = {TMP(1)}
  mos.tbl,:yend,@1 = {TMP(2)}
endif




display:
!
!------------------------------------------------------------------------------
! display data
!------------------------------------------------------------------------------
IF "{p8(1:1)}" .ne. "A" then

  write/out "*** object frame..."
  write/out "LOAD {obj}"
  load  {obj} scale={SCA(1:12)}

  write/out "*** wavelength calibration frame..."
  write/out "LOAD {wlc}"
  load  {wlc} scale={SCA(1:12)}

  write/out "*** flat frame..."
  write/out "LOAD {flat}" 
  load {flat} scale={SCA(1:12)}

  @s redlongquick,pause {p8}
ENDIF




search:
!------------------------------------------------------------------------------
! search arc lines
!------------------------------------------------------------------------------
write/out "*** search lines..."
!
write/out "SEAR/MOS 	{wlc} {SEAPAR} {YBIN} {CENTMET}"
sear/MOS 		{wlc} {SEAPAR} {YBIN} {CENTMET}
!
IF "{p8(1:1)}" .ne. "A" then
  write/out "LOAD {wlc}"
  load {wlc} scale={SCA(1:12)}
  load/tabl {LINPOS} :X :Y p7=5
  write/out "LINPLOT/MOS "
  linplot/mos 
  @s redlongquick,pause {p8}

  if {SLNR} .gt. 0 then
    write/out "LINPLOT/MOS 1D {SLNR}"
    linplot/mos 1D {SLNR}
    @s redlongquick,pause {p8}
  endif	
ENDIF




!
calibr:
!------------------------------------------------------------------------------
! calibrate lines automatically
!------------------------------------------------------------------------------

WRITE/OUT "@s moscalifors {TOL} {WLCORD},4,3 {{WLC},ESO.INS.GRIS1.ID} ? 1029 {P7}"
@s moscalifors {TOL} {WLCORD},4,3 {{WLC},ESO.INS.GRIS1.ID} ? 1029 {P7}




norm:
!------------------------------------------------------------------------------
! normalize flats
!------------------------------------------------------------------------------
write/out "*** normalize flat..."
write/out "NORMA/MOS 	{flat} {mos} {normflat} {FFORD} {NORMMET}"
norma/MOS 		{flat} {mos} {normflat} {FFORD} {NORMMET}
IF "{p8(1:1)}" .ne. "A" then
  write/out "LOAD {normflat} cuts=0.8,1.2"
  load {normflat} cuts=0.8,1.2 scale={SCA(1:12)}
  @s redlongquick,pause {p8}
ENDIF




flat:
!------------------------------------------------------------------------------
! Flat-field object frame
!------------------------------------------------------------------------------
write/out "*** Flat-field object frame..."
write/out "COMP/IMA 	middumm3 = ({obj}/{normflat})"
comp/ima 		middumm3 = ({obj}/{normflat})




rebin:
!------------------------------------------------------------------------------
! Flat-field object frame
!------------------------------------------------------------------------------
write/out "*** rebin object frame..."
WRITE/OUT "REBIN/MOS middumm3 middumm4 {REBSTRT},{REBEND},{REBSTP} LINEAR"
REBIn/MOS middumm3 middumm4 {REBSTRT},{REBEND},{REBSTP} LINEAR



sky:
!------------------------------------------------------------------------------
! Fit and subtract sky 
!------------------------------------------------------------------------------

clear/chan overlay
write/out "LOAD middumm3 scale={SCA(1:12)}"
load middumm3 scale={SCA(1:12)} 

SCAN_POS = (REBSTRT + REBEND) / 2.0


write/out "*** Search objects and sky..."
write/out "DEFIN/MOS middumm4 {MOS} {WINDOWS} {THRESH} {WIND} {XBIN} {SCAN_POS}"
IF "{p8(1:1)}" .ne. "A" THEN
  DEFINE/MOS middumm4 {MOS} {WINDOWS} {THRESH} {WIND} {XBIN} {SCAN_POS} 3
ELSE
  DEFINE/MOS middumm4 {MOS} {WINDOWS} {THRESH} {WIND} {XBIN} {SCAN_POS} 1
ENDIF

IF {NOBJ} .lt. 1 then
  WRITE/OUT "WARNING! no object found - extraction will fail probably"
  DEFINE/MOS middumm4 {MOS} {WINDOWS} {THRESH} {WIND} {XBIN} {SCAN_POS} 2
ENDIF


write/out "*** Fit sky ( non-rebinned object!)..."
write/out "SKYFIT/MOS middumm4 ? ? {SKYFRAME} {SKYPAR} {SKYMET} {CCDPAR},{REJTHRES}"
SKYFIT/MOS middumm4 ? ? {SKYFRAME} {SKYPAR} {SKYMET} {CCDPAR},{REJTHRES}
!
IF "{p8(1:1)}" .ne. "A" THEN
  write/out "LOAD {SKYFRAME} scale={SCA(1:12)}"
  load {SKYFRAME} scale={SCA(1:12)} 
ENDIF


write/out "*** Subtract sky..."
write/out "COMP/IMA 	middumm5 = middumm4 - {SKYFRAME}"
comp/ima 		middumm5 = middumm4 - {SKYFRAME}
write/out "LOAD middumm5 scale={SCA(1:12)} cuts=-150,150"
load middumm5 scale={SCA(1:12)}  cuts=-150,150




extract:
!------------------------------------------------------------------------------
! Extract objects
!------------------------------------------------------------------------------
write/out "*** Extract non-rebinned objects..."
write/out "EXTRA/MOS middumm4 {SKYFRAME} ? {EXTOBJEC} {EXTPAR} {CCDPAR} {REJTHRES}"
EXTRA/MOS middumm4 {SKYFRAME} ? {EXTOBJEC} {EXTPAR} {CCDPAR} {REJTHRES}"
write/out "PLO/ROW extobj @1"
plo/row extobj @1



goto end



!------------------------------------------------------------------------------
! Extract rows to tables 
!------------------------------------------------------------------------------
apply:
write/out "*** Extract rows to tables ..."
write/out "APPLY/MOS 	{EXTOBJEC} {LINFIT} {CALOBJEC} "
APPLY/MOS 		{EXTOBJEC} {LINFIT} {CALOBJEC} 
set/grap ya stype=0
write/out "PLO/TABLE ext0001 :lambda :flux"
plo/table ext0001 :lambda :flux




rebin1d:
!------------------------------------------------------------------------------
! Extract rows to images 
!------------------------------------------------------------------------------
!
write/out "*** Extract rows to images ..."
write/out "REB1D/MOS {EXTOBJEC} {CALOBJEC} {REBSTRT},{REBEND},{REBSTP} {REBMET}"
REB1D/MOS {EXTOBJEC} {CALOBJEC} {REBSTRT},{REBEND},{REBSTP} {REBMET} {LINFIT}
write/out "PLO/ROW 	ext0001 "
plot/row 		ext0001




end:
!------------------------------------------------------------------------------
! The end
!------------------------------------------------------------------------------
IF "{p8(1:1)}" .ne. "A" THEN
  inquire/key SAV "save all session-tables created/used by quick look ?"
  IF SAV(1:1) .EQ. "y" .OR. SAV(1:1) .EQ. "Y" THEN
    SAVE/MOS {P4}	
  ENDIF
ENDIF

RETURN
!
!	This is the end
!







ENTRY PAUSE
define/param P1 ? ? "Mode:"
define/local nix/i/1/1 1
if "{P1(1:2)}" .ne. "AA" then
        inquire/keyw nix "Press return to continue; -1 to stop "
        if nix .lt. 0 @s redlongquick,finito
ENDIF
RETURN





ENTRY FINITO
define/local del/c/1/1 n
set/gra
write/out "*** End of Quick Look ***"
if tuto(1:1) .ne. "Y" .and. tuto(1:1) .ne. "y" then
  inquire/key del "delete all frames/tables created/used by quick look?"
  if del(1:1) .eq. "y" then
    -DELETE moscat.cat
    dele test3 no
    dele object3 no
    dele object4 no
    dele object5 no
    dele rebobj no
    dele extobj no
    dele extreb no
    dele normflat no
    dele sky no
    -DELETE ext00*.bdf
    -DELETE ext00*.tbl
!    -DELETE mos.tbl
    -DELETE mostab.tbl
    -DELETE linpos.tbl
    -DELETE coerbr.tbl
    -DELETE window.tbl
    -DELETE windows.tbl
    -DELETE middumm*
    -DELETE dirfile.dat
    -DELETE *.plt
  endif
endif
write/key tuto/c/1/1 n
return/exit
