DEFI/PARA P1 {OBJ} 	? "OBJECT NAME"
DEFI/PARA P2 {FLAT} 	? "FLATFIELD NAME"
DEFI/PARA P3 {WLC} 	? "WLC NAME"
DEFI/PARA P4 N 		? "SESSION NAME"
DEFI/PARA P5 {USEAREA} 	? "Useful area or SLITLET"
!DEFI/PARA P8 I		? "flag:  A = Automatic  -- I = Interactively"


DEFI/LOCA LAM/R/1/2 0.,0.
DEFI/LOCA TMP/d/1/2 0.,0.
DEFI/LOCA SCA/C/1/12 "-2,1"
DEFI/LOCA SLNR/I/1/1 0




GRAPH/SPEC ? 520,30
create/display 0 1050,300
clear/disp
!load/lut idl4




!------------------------------------------------------------------------------
! initialize parameters
!------------------------------------------------------------------------------
init:
IF "{P4(1:2)}" .NE. "n " .OR. "{P4(1:2)}" .NE. "N " THEN
	init/mos {P4}	
ELSE
!
!  SET/MOS  	
!		critical parameters exist for SEARCH,CALIBR,DEFINE
!		keywords should be taken from fits-keywords (later)  
!		eg: WCENTER,AVDISP,... 
!
!		... to be implemented during FORS integration
!
!
   SET/MOS WLC={P3} OBJ={P1} FLAT={P2}
   SET/MOS NORMMET=MEDIAN FFORD=10				!NORM
   SET/MOS LINFIT=coerbr 					!
   SET/MOS INT_LIM=0.05 MIN_DIST=1 MIN_SKY=2 THRESH=-0.10 WIND=8 !DEFINE
   SET/MOS XBIN=150 SCAN_POS=1250				!
   SET/MOS SKYMET=POLYNOM SKYPAR=2 CCDPAR=10,1.3 REJTHRES=8	!SKYFIT
   SET/MOS SKYFRAME=sky						!
   SET/MOS EXTOBJ=extobj EXTPAR=3,3 				!EXTRACT
   SET/MOS CALOBJEC=ext						!APPLY
ENDIF
!
if "{p5(1:1)}" .ne. "[" then
   sele/tabl {mos} :slit.eq.{p5}
   SLNR = {P5}
else
   TMP(1) = {{p1}.bdf,START(2)}
   TMP(2) = {{p1}.bdf,START(2)} + {{p1}.bdf,STEP(2)} * {{p1}.bdf,NPIX(2)}
   sele/tabl {mos} :ystart.gt.{TMP(1)}.and.:yend.lt.{TMP(2)}	
   if {{mos}.tbl,TBLCONTR(10)} .eq. 0 then
	write/out "WARNING: ... no slitlets selected"
   endif
endif



!------------------------------------------------------------------------------
! display data
!------------------------------------------------------------------------------
IF "{p8(1:1)}" .ne. "A" then
   write/out "   object frame..."
   write/out "LOAD {obj}"
   load  {obj} scale={SCA(1:12)}
!
   write/out "   wavelength calibration frame..."
   write/out "LOAD {wlc}"
   load  {wlc} scale={SCA(1:12)}
!
   write/out "   flat frame..."
   write/out "LOAD {flat}" 
   load {flat} scale={SCA(1:12)}
ENDIF



!------------------------------------------------------------------------------
! search arc lines
!------------------------------------------------------------------------------

!@@ red_mos {FLAT}.bdf {WLC}.bdf {P5}






!------------------------------------------------------------------------------
! normalize flats
!------------------------------------------------------------------------------
norm:
write/out "*** normalize flat..."
!
write/out "NORMA/MOS 	{flat} {mos} {normflat} {FFORD} {NORMMET}"
norma/MOS 		{flat} {mos} {normflat} {FFORD} {NORMMET}
!
!
!
IF "{p8(1:1)}" .ne. "A" then
   write/out "LOAD {normflat}
   load {normflat} scale={SCA(1:12)}
ENDIF


!------------------------------------------------------------------------------
! Flat-field object frame
!------------------------------------------------------------------------------
!
write/out "*** Flat-field object frame..."
write/out "COMP/IMA 	middumm3 = ({obj}/{normflat})"
comp/ima 		middumm3 = ({obj}/{normflat})

WRITE/DESC middumm3 CUNIT/C/1/48 " " all

rebin:
!------------------------------------------------------------------------------
! rebin object frame
!------------------------------------------------------------------------------
write/out "*** rebin object frame..."
WRITE/OUT "REBIN/MOS middumm3 middumm4 {REBSTRT},{REBEND},{REBSTP} LINEAR"
REBIN/MOS middumm3 middumm4 {REBSTRT},{REBEND},{REBSTP} LINEAR



!------------------------------------------------------------------------------
! Search for stars on the slitlets
!------------------------------------------------------------------------------
define:
!
clear/chan overlay
write/out "LOAD middumm3 scale={SCA(1:12)}"
load middumm3 scale={SCA(1:12)}
!
write/out "*** Search objects and sky..."
write/out "DEFIN/MOS middumm3 {MOS} {WINDOWS} {THRESH} {WIND} {XBIN} {SCAN_POS}"
DEFINE/MOS middumm3 {MOS} {WINDOWS} {THRESH} {WIND} {XBIN} {SCAN_POS} 1

IF {NOBJ} .lt. 1 then
   WRITE/OUT "WARNING! no object found - select you own targets"
   DEFINE/MOS middumm3 {MOS} {WINDOWS} {THRESH} {WIND} {XBIN} {SCAN_POS} 2
ELSE
   WRITE/OUT "{NOBJ} object found - select more targets"
   DEFINE/MOS middumm3 {MOS} {WINDOWS} {THRESH} {WIND} {XBIN} {SCAN_POS} 2
ENDIF




!------------------------------------------------------------------------------
! Fit and subtract sky
!------------------------------------------------------------------------------
sky:
write/out "*** Fit sky ( non-rebinned object!)..."
write/out "SKYFIT/MOS middumm4 ? ? {SKYFRAME} {SKYPAR} {SKYMET} {CCDPAR},{REJTHRES}"
SKYFIT/MOS middumm4 ? ? {SKYFRAME} {SKYPAR} {SKYMET} {CCDPAR},{REJTHRES}
!
IF "{p8(1:1)}" .ne. "A" THEN
   write/out "LOAD {SKYFRAME} scale={SCA(1:12)}"
   load {SKYFRAME} scale={SCA(1:12)}
ENDIF
!
write/out "*** Subtract sky..."
write/out "COMP/IMA 	middumm5 = middumm4 - {SKYFRAME}"
comp/ima 		middumm5 = middumm4 - {SKYFRAME}
!
write/out "LOAD middumm5 scale={SCA(1:12)}"
load middumm5 scale={SCA(1:12)}



!------------------------------------------------------------------------------
! Extract objects
!------------------------------------------------------------------------------
extract:
!
write/out "*** Extract non-rebinned objects..."
write/out "EXTRA/MOS middumm4 {SKYFRAME} ? {EXTOBJEC} {EXTPAR} {CCDPAR} {REJTHRES}"
EXTRA/MOS middumm4 {SKYFRAME} ? {EXTOBJEC} {EXTPAR} {CCDPAR} {REJTHRES}"
!
write/out "PLO/ROW extobj @1"
plo/row extobj @1




mosend:
!
!	This is the end
!











