!	PRERED.PRG	quicklook pre-reduction module for the VLT-FORS group 
!			by Thomas Szeifert, LSW-Heidelberg, Jan. 12, 1996
!
!
!
write/out "this is the prered module..."
exit
!
!
!
ENTRY INIT
!
!_____________initialize observation summary_________
!
DEFI/PARA P1 ? ? "prefix for file-specifications"
DEFI/PARA P2 ? {DLIST} "input table with OST table columns specifications"
DEFI/PARA P3 ? {OSTABLE} "output OST-table"
DEFI/PARA P4 ? ? "context: DIRECT, MOS"
!
SET/CONTEXT DO
CREATE/OST {P1}* ? {P2} {P3} MC 
!
!!!	provisorische Klassifikation	!!!
!
!IF "{P4(1:1)}" .eq. "D" .or. "{P4(1:1)}" .eq. "d" then
!  WRITE/DESC {P3}.tbl BIAS/C/1/80 :_EGE_TYPE.EQ."DK".AND.:EXPTIME.eq.0.
!  WRITE/DESC {P3}.tbl FLATU/C/1/80 :IDENT.EQ."*Flat*".AND.:_EGE_TYPE.EQ."*SCI*".AND.:_EIO2_NAME.EQ."*U*"
!  WRITE/DESC {P3}.tbl FLATB/C/1/80 :IDENT.EQ."*Flat*".AND.:_EGE_TYPE.EQ."*SCI*".AND.:_EIO2_NAME.EQ."*B*"
!  WRITE/DESC {P3}.tbl FLATV/C/1/80 :IDENT.EQ."*Flat*".AND.:_EGE_TYPE.EQ."*SCI*".AND.:_EIO2_NAME.EQ."*V*"
!ENDIF
RETURN
EXIT
!
!
ENTRY BIAS
!
!______________median of the bias frames_____________
!
DEFI/PARA P1 {OSTABLE} ? "observation summary table"
DEFI/PARA P2 {BIAS} ? "output frame"
DEFI/PARA P3 {OVERSCAN} ? "overscan area"
DEFI/PARA P4 {CRBIAS} ? "CRULE-descriptor to classify setup		:"
!
!
DEFINE/LOCAL 	I/I/1/1 0
DEFINE/LOCAL 	OVER/c/1/60 {P3} 	
DEFINE/LOCAL	NBIAS/I/1/1 0
WRITE/DESC 	{P1}.tbl CRBIAS/c/1/80 {P4}
!
!
CREATE/ICAT 	biascat NULL
CLAS/IMAG {P1} CRBIAS :CRBIAS yes
SET/MIDAS output=LOGONLY
DISPLAY/LONG
!
DO I = 1 {{P1}.tbl,TBLCONTR(4)}
   IF "{{P1}.tbl,:CRBIAS,@{I}}" .eq. "yes" then	
	NBIAS = NBIAS + 1
        WRITE/KEYW 	IN_A {{P1},:FILENAME,@{I}}
	SET/MIDAS output=yes
   	WRITE/OUT	"processing bias frame {IN_A}" 
	SET/MIDAS output=LOGONLY
	STATIST/IMAGE 	{IN_A} {OVER} #512
      	COMPUTE/IMAGE 	midd{IN_A} = {IN_A} - {OUTPUTR(8)}
      	ADD/ICAT 	biascat midd{IN_A}
   ENDIF
ENDDO
!
IF NBIAS .GT. 0 then
	AVERAGE/WINDOW {P2} = biascat.cat MEDIAN
	SET/MIDAS output=yes
	WRITE/OUT "median of {P1}.cat has been precessed to... {p2}.bdf"
ELSE
	WRITE/OUT "none of the frame passed classification rule"
ENDIF
!
DELE/IMAG midd* NO
!
RETURN
EXIT







ENTRY FLAT
!
!______________median of the flat field frames_____________
!
DEFI/PARA P1 {OSTABLE} ? "observation summary table	:"
DEFI/PARA P2 ? ? "setup number:"
DEFI/PARA P3 {BIAS} ? "bias frame			:"
DEFI/PARA P4 {OVERSCAN} ? "overscan area [@xst,@yst:@xend,@yend]"
DEFI/PARA P5 {USEAREA} ? "usefull area on CCD	[@xst,@yst:@xend,@yend] :"
set/format I1
DEFI/PARA P6 {CRFF{P2}} ? "CRULE-descriptor to classify setup		:"
DEFI/PARA P7 {FF{P2}} ? "output image  (no ext.)	:"
!
!
DEFINE/LOCAL CRDESC/C/1/5 "CRFF{P2}"
DEFINE/LOCAL NFLAT/I/1/1 0
WRITE/DESC {P1}.tbl {CRDESC(1:5)}/c/1/80 {P6}	!
SET/FORMAT
!
DEFINE/LOCAL IN_I/C/1/60 " " all
DEFINE/LOCAL I/i/1/1 1
!
!
CREA/ICAT flatout NULL
CLAS/IMAG {P1} {CRDESC} :{CRDESC} yes
DISP/LONG
SET/MIDAS output=LOGONLY
!
DO I = 1 {{P1}.tbl,TBLCONTR(4)}
   IF "{{P1}.tbl,:{CRDESC},@{I}}" .eq. "yes" then
	NFLAT = NFLAT + 1
      	WRITE/KEYW IN_I {{P1},:FILENAME,@{I}}
	SET/MIDAS output=yes
	WRITE/OUT "processing file {IN_I}"	
	SET/MIDAS output=LOGONLY
	STAT/IMAGE {IN_I} {P4} #512
	COMP/IMAGE &b = {IN_I} - ( {P3} + {OUTPUTR(8)} )
	EXTR/IMAGE &e = &b{P5}
	STAT/IMAGE &e  	
	COMP/IMAGE midd{IN_I} = &e / {OUTPUTR(8)}
	ADD/ICAT flatout midd{IN_I}
   ENDIF
ENDDO
SET/MIDAS output=yes
!
IF NFLAT .GT. 0 then
	AVER/WIND {P7} = flatout.cat MEDIAN
	WRITE/OUT "resulting mean flatfield has been stored in file {P7}.bdf"
ELSE
	WRITE/OUT "none of the frame passed classification rule"
ENDIF
!
DELE/IMAG midd* NO
!
RETURN







ENTRY DIRECT
!
!______________pre-reduction of direct imaging frame_____________
!
!
set/format i1
DEFI/PARA P1 ? N	  "setup number "
DEFI/PARA P2 {OBJ{P1}} ?  "ccd direct image:   "
DEFI/PARA P3 {FF{P1}} ?	  "mean flatfield image:   "
set/format
DEFI/PARA P4 {BIAS}   ?	  "mean bias frame:   "
DEFI/PARA P5 {OVERSCAN} ? "overscan area [@xst,@yst:@xend,@yend]:"
DEFI/PARA P6 {USEAREA}  ? "usefull area on CCD	[@xst,@yst:@xend,@yend]:"
!
DEFI/LOCA CUT1/r/1/2 0.,0.
DEFI/LOCA BIAS/r/1/2 0.,0.
DEFI/LOCA IN_I/C/1/60 {P2}
DEFI/LOCA FILTYP/I/1/1 0
DEFI/LOCA I/I/1/1 0
!
FILTYP = M$INDEX(IN_I,".tbl")
!
!______________one file only__________________________
!
IF FILTYP .lt. 2 then
  SET/MIDAS output=LOGONLY
!
!	bias
!
  STAT/IMAG {P2} {P5} #512
  BIAS(1)	= OUTPUTR(8)
  BIAS(2)	= OUTPUTR(4)
  COMP/IMAG &b = {P2} - ({P4} + {OUTPUTR(8)})
!
!	extract & flatfield
!
  EXTR/IMAG &c = &b{P6}
  COMP/IMAG D{p2} = (&c / {P3})
!
!	cut & sky
!
  STAT/IMAG D{p2} [@51,@51:@100,@100] 
  CUT1(2)   =  OUTPUTR(8) + (OUTPUTR(4) * 10.)
  CUT1(1)   =  OUTPUTR(8) - (OUTPUTR(4) * 2.)
  WRITE/DESC D{p2} SKY/r/1/2 {OUTPUTR(8)},{OUTPUTR(4)}
  LOAD 	D{p2} CUTS={CUT1(1)},{CUT1(2)}
  SET/MIDAS output=yes
  WRITE/OUT "D{p2} : flatfielded CCD direct image"
!
  DELE/DESC D{p2} HISTOGRAM
  DELE/DESC D{p2} HIST_BINS
  DELE/DESC D{p2} STATISTIC
ELSE
!
!_________________all files in {OSTABLE}______________
!
  WRITE/DESC {P2} CROBJ{P1}/C/1/80 {CROBJ{P1}}
  CLAS/IMAG {P2} CROBJ{P1} :CROBJ{P1} yes
  DO I = 1 {{P2},TBLCONTR(4)} 
    SET/MIDAS output=LOGONLY
    IF "{{P2},:CROBJ{P1},@{I}}" .eq. "yes" then
      WRITE/KEYW IN_I {{P2},:FILENAME,@{I}}
!      WRITE/KEY OBJECT(1:60) = {{IN_I},IDENT(1:60)}
!
!	bias
!
      STAT/IMAG {IN_I} {P5} #512
      BIAS(1)	= OUTPUTR(8)
      BIAS(2)	= OUTPUTR(4)
      COMP/IMAG &b = {IN_I} - ({P4} + {OUTPUTR(8)})
!
!	extract & flatfield
!
      EXTR/IMAG &c = &b{P6}
      COMP/IMAG D{IN_I} = (&c / {P3})
!
!	cut & sky
!
      STAT/IMAG D{IN_I} [@51,@51:@100,@100] 
      CUT1(2)   =  OUTPUTR(8) + (OUTPUTR(4) * 10.)
      CUT1(1)   =  OUTPUTR(8) - (OUTPUTR(4) * 2.)
      WRITE/DESC D{IN_I} SKY/r/1/2 {OUTPUTR(8)},{OUTPUTR(4)}
      LOAD 	D{IN_I} CUTS={CUT1(1)},{CUT1(2)}
      SET/MIDAS output=yes
      WRITE/OUT "D{IN_I} : reduced CCD direct image:  {{IN_I},IDENT(1:12)}"
!
      DELE/DESC D{IN_I} HISTOGRAM
      DELE/DESC D{IN_I} HIST_BINS
      DELE/DESC D{IN_I} STATISTIC
    ENDIF
  ENDDO
ENDIF	
!
RETURN 







ENTRY MOS
!
!______________pre-reduction of mos frame_____________
!
!
DEFI/PARA P1 ? {OBJECT}   "ccd direct image:   		"
DEFI/PARA P2 ? {FLAT} 	  "flatfield image:   		"
DEFI/PARA P3 ? {WLC}	  "wavelength calibration image	"
DEFI/PARA P4 ? {BIAS} 	  "mean bias frame:   		"
DEFI/PARA P5 ? {OVERSCAN} "overscan area [@xst,@yst:@xend,@yend]:"

!
DEFI/LOCA BIAS/r/1/2 0.,0.
!
!	bias
!
STAT/IMAG {P1} {P5} #512
BIAS(1)	= OUTPUTR(8)
BIAS(2)	= OUTPUTR(4)
COMP/IMAG &b = {P1} - ({P4} + {OUTPUTR(8)})
!

DELE/DESC c{p1} HISTOGRAM
DELE/DESC c{p1} HIST_BINS
DELE/DESC c{p1} STATISTIC

RETURN



