/*

  convert red, green, blue images (BDF) in RGB image (raw)

  OS, 1.9.1998
  
 */

#include <stdio.h>
#include <stdlib.h>

#include <midas_def.h>

int main()
{
  int actvals, imr, img, imb, knul, naxis, unit, npix[2], rgbval;
  int i, j, offset, off;
  char red[61], green[61], blue[61], rgb[61];
  double start[2], step[2];
  float *datar, *datag, *datab;
  unsigned char *datargb;

  int nchar;
  char text[20];

  FILE *fd;
  size_t no_bytes;

  SCSPRO( "BDF2RGB" );                  
  SCKGETC( "P1", 1, 60, &actvals, red );
  SCKGETC( "P2", 1, 60, &actvals, green );
  SCKGETC( "P3", 1, 60, &actvals, blue );
  SCKGETC( "P4", 1, 60, &actvals, rgb );
  
  SCFOPN( red, D_R4_FORMAT, 0, F_IMA_TYPE, &imr );
  SCDRDI( imr, "NPIX" , 1, 2, &actvals, npix , &unit, &knul );
  SCDRDI( imr, "NAXIS", 1, 1, &actvals, &naxis, &unit, &knul );
  SCDRDD( imr, "START", 1, 2, &actvals, start, &unit, &knul );
  SCDRDD( imr, "STEP" , 1, 2, &actvals, step , &unit, &knul );

  SCFOPN( green, D_R4_FORMAT, 0, F_IMA_TYPE, &img );
  SCFOPN( blue, D_R4_FORMAT, 0, F_IMA_TYPE, &imb );

  rgbval = npix[0] * 3;

  datar = (float *) osmmget( npix[0] * sizeof(float));
  datag = (float *) osmmget( npix[0] * sizeof(float));
  datab = (float *) osmmget( npix[0] * sizeof(float));

  datargb = (unsigned char *) osmmget( rgbval + 1);

  fd = fopen(rgb,"w+");

  /* write ppm header */
  nchar = sprintf(text,"P6\n%i %i\n255\n",npix[0],npix[1]);
  no_bytes = fwrite (text,1,nchar,fd);

  /*  offset = 1;*/
  offset = npix[0] * (npix[1] - 1) + 1 ;
  for (i=0; i<npix[1]; i++)
    {

      /* read one line */

      SCFGET(imr, offset, npix[0], &actvals, (char*)datar);
      SCFGET(img, offset, npix[0], &actvals, (char*)datag);
      SCFGET(imb, offset, npix[0], &actvals, (char*)datab);
      
      for (j=0; j<npix[0]; j++)
	{
	  
	  /* compute rgb value */
	  
	  if (datar[j] < 0) datar[j] = 0;
	  if (datar[j] > 255) datar[j] = 255;

	  if (datag[j] < 0) datag[j] = 0;
	  if (datag[j] > 255) datag[j] = 255;

	  if (datab[j] < 0) datab[j] = 0;
	  if (datab[j] > 255) datab[j] = 255;
	  
	  off = 3*j;

	  datargb[off]   = (unsigned char) datar[j];
	  datargb[off+1] = (unsigned char) datag[j];
	  datargb[off+2] = (unsigned char) datab[j];
	}
      
      /* write one line */

      no_bytes = fwrite (datargb,1,rgbval,fd); 
      /*      offset = offset + npix[0];*/
      offset -=  npix[0];
    }
  
  return SCSEPI();

}







