! @(#)spoldefine.prg          (LSW)     02/07/94 15:54
! +++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT    (C) 1994 Landessternwarte Heidelberg
!.IDENT        spoldefine.prg
!.AUTHORS      Sabine Moehler (LSW)
!              Otmar Stahl (LSW)
!.KEYWORDS     Spectropolarimetry
!  
!.PURPOSE      execute the command DEFINE/SPOL
!
!.VERSION      1.0 Creation 02/07/94
! 
! DEFINE/SPOL spol_table columns threshold window binning scanposition 
!             plot_option try
!
! -------------------------------------------------
!
! CROSSREF SPOL_TAB SC_REB THRESH WIND XBIN SCAN_POS plot try
!
DEFINE/PARAM P1 {SPOL_TAB} TABLE   "Enter input table:"
DEFINE/PARAM P2 {SC_REB}   CHAR    "Column with input images?"
DEFINE/PARAM P3 {THRESH}   NUMBER  "Threshold:"
DEFINE/PARAM P4 {WIND}     NUMBER  "Window:"
DEFINE/PARAM P5 {XBIN}     NUMBER  "Binning in X:"
DEFINE/PARAM P6 {SCAN_POS} NUMBER  "Center for scan (world coordinates)"
DEFINE/PARAM P7 0.         NUMBER  "Plot option"
DEFINE/PARAM P8 ?      CHAR    "First try or All frames?"
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------
! Continue flag
DEFINE/LOCAL cont/c/1/1 y
! Counter
DEFINE/LOCAL I/I/1/1 0
DEFINE/LOCAL J/I/1/1 0
!
DEFINE/LOCAL QUALIF/C/1/4 " " all
!-------------------------------------------------------------------------------
! ... for sorting
!-------------------------------------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL II/I/1/1 0.
DEFINE/LOCAL JJ/I/1/1 0.
DEFINE/LOCAL SCAN/D/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
WRITE/KEY TMP/C/1/60 " " ALL
WRITE/KEY IN_B " " ALL
WRITE/KEY INPUTC/C/1/60 " " ALL
WRITE/KEYW QUALIF {MID$CMND(11:14)}
!-------------------------------------------------------------------------------
! Initialize define parameters
!-------------------------------------------------------------------------------
WRITE/KEYW INPUTI {P4},{P5},{P7}
WRITE/KEYW INPUTR {P3}
WRITE/KEYW SCAN {P6}
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P8(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P8}
ENDIF
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF
!-------------------------------------------------------------------------------
! Initialize column to hold names of windows tables
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/8 {WINDOWS}
RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
! Same flat for all frames == one slitlet table for all frames
!---------------------------------------------------
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
!---------------------------------------------------
! Get slitlet table for all science frames
!---------------------------------------------------
  DO II = 1 {NUMROW}
    COPY/TK {P1} {SLIT_TAB} @{II} TMP/C/1/20
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get science frames
!---------------------------------------------------
  DO JJ = 1 {N_SC}
    DO II = SC_STRT({JJ}) SC_END({JJ})
      COPY/TK {P1} {P2} @{II} IN_A/C/1/60
      IF IN_A(1:1) .ne. " " THEN
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEY OUT_A {IN_A(1:{OUTPUTI(1)})}{SUF_WIN}.tbl
!        COPY/DK {IN_A} START/D/1/1 PLOTPAR1
!        COPY/DK {IN_A} STEP/D/1/1 TMP1
!        COPY/DK {IN_A} NPIX/I/1/2 TMP2
        IF SCAN .eq. 0 THEN
!          SCAN = (TMP2/2.0)*TMP1+PLOTPAR1
	  SCAN = ({{in_a},npix(1)}/2.0)*{{in_a},step(1)}+{{in_a},start(1)}
        ENDIF
        WRITE/KEY INTAB/C/1/60 {IN_B}
        WRITE/KEY INBDF/C/1/60 {IN_A}
!---------------------------------------------------
! search object and sky regions and write name of
! resulting table to column :WINDOWS of spol_tab
!---------------------------------------------------
        RUN STD_EXE:MOSDEFINE
        COPY/KD IN_A/C/1/60 {OUT_A} FRAME/C/1/60
        WRITE/TABLE {P1} {WINDOWS} @{II} {OUT_A}
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
          DEFPLOT/SPOL {INBDF} {INTAB} {OUT_A} {XBIN} {SCAN} {INPUTI(3)}
          GOTO end
        ENDIF
!---------------------------------------------------
! Use only one frame even if frame name appears more than once
!---------------------------------------------------
      GOTO next
      ENDIF
    ENDDO
next:
  ENDDO
!---------------------------------------------------
! end of loop over science frames
!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
! Individual flat for each frame == one slitlet
! table for each SC frame
!---------------------------------------------------
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
!---------------------------------------------------
! Get slitlet table for each science frame
!---------------------------------------------------
  DO JJ = 1 {N_SC}
    DO II = SC_STRT({JJ}) SC_END({JJ})
      COPY/TK {P1} {SLIT_TAB} @{II} TMP/C/1/20
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_B {TMP}
      ENDIF
    ENDDO
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
    DO II = SC_STRT({JJ}) SC_END({JJ})
      COPY/TK {P1} {P2} @{II} IN_A/C/1/60
      IF IN_A(1:1) .ne. " " THEN
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEY OUT_A {IN_A(1:{OUTPUTI(1)})}{SUF_WIN}.tbl
        COPY/DK {IN_A} START/D/1/1 PLOTPAR1
        COPY/DK {IN_A} STEP/D/1/1 TMP1
        COPY/DK {IN_A} NPIX/I/1/2 TMP2
        IF SCAN .eq. 0 THEN
          SCAN = TMP2/2*TMP1+PLOTPAR1
        ENDIF
!---------------------------------------------------
! search object and sky regions and write name of
! resulting table to column :WINDOWS of spol_tab
!---------------------------------------------------
        RUN STD_EXE:MOSDEFINE
        COPY/KD IN_A/C/1/60 {OUT_A} FRAME/C/1/60
        WRITE/TAB {P1} {WINDOWS} @{II} {OUT_A}
        WRITE/KEY INTAB/C/1/60 {IN_B}
        WRITE/KEY INBDF/C/1/60 {IN_A}
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
          DEFPLOT/SPOL {IN_A} {IN_B} {OUT_A} {XBIN} {SCAN} {INPUTI(3)}
          GOTO end
        ENDIF
      GOTO next
      ENDIF
    ENDDO ! end of loop over science frame
next:
  ENDDO  ! end of loop over slitlet tables
ENDIF
!-------------------------------------------------------------------------------
! Plot only for first try
!-------------------------------------------------------------------------------
!IF TRY(1:1) .ne. "F" .and. TRY(1:1) .ne. "f"  THEN
!  GOTO end
!ENDIF
end:
write/keyw scan_pos 0.
dele MIDTMPS no
dele MIDTMPC no
dele MIDTMPE no
