! @(#)spolextr.prg	1.3 (ESO-IPG) 2/11/94 13:19:57
! +++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! SPOL PROCEDURE : SPOLEXTR.PRG
!
! .PURPOSE
!
! execute the command :
! EXTRACT/SPOL table columns parameters
! 
! This program assumes that for each science frame one (and only one)
! skyframe and windows table exists.
! -------------------------------------------------
!
CROSSREF SPOL_TAB SC_REB SKY TABLE EX_SC EXTPAR CCDPAR REJECT
!
DEFINE/PARAM P1 {SPOL_TAB} TABLE   "Table with files"
DEFINE/PARAM P2 {SC_SKY}   CHAR    "Enter column with input image:"
DEFINE/PARAM P3 {SKY}      CHAR    "Enter column with sky   image:"
DEFINE/PARAM P4 {WINDOWS}  CHAR    "Enter column with input table:"
DEFINE/PARAM P5 {EXTPAR}   ?       "Order of fit, Number of iterations:"
DEFINE/PARAM P6 {CCDPAR}   ?       "Ron, Gain:"
DEFINE/PARAM P7 {REJTHRES} ?       "Rejection Threshold:"
DEFINE/PARAM P8 ? CHAR "First try/All frames (Def. F):"
!
!-------------------------------------------------------------------------------
! Local keys for sorting part
!---------------------------------------------------
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL RET_ANG/R/1/1 0.
DEFINE/LOCAL VAL_SC/C/1/60 " " ALL
DEFINE/LOCAL TRY/C/1/1 F
DEFINE/LOCAL FITTAB/C/1/60 " " ALL
DEFINE/LOCAL COL_IN/C/1/16 " " ALL
DEFINE/LOCAL MAIN_TAB/C/1/60 " " ALL
DEFINE/LOCAL OUT_TAB/C/1/60 " " ALL
WRITE/KEY TMP/C/1/60 " " ALL
!-------------------------------------------------------------------------------
! Get parameters for extraction
!-------------------------------------------------------------------------------
WRITE/KEYW SC_ORI/C/1/60 " " ALL
WRITE/KEYW INPUTI {P5},0,0,0
WRITE/KEYW INPUTR {P6},{P7}
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P8(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P8}
ENDIF
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Create new table to hold names of extracted frames, raw frames, input frames
! tables with dispersion coefficients
!-------------------------------------------------------------------------------
CREATE/TAB {P1}EX 5 800 NULL
CREATE/COL {P1}EX {SC} ? A40 C*40
CREATE/COL {P1}EX {P2} ? A40 C*40
CREATE/COL {P1}EX {SC_EX} ? A40 C*40
CREATE/COL {P1}EX {LINFIT} ? A40 C*40
CREATE/COL {P1}EX :RET_ANG ? R*4 F8.2
CREATE/COL {P1}EX :RAY_TYP ? A1 C*1
WRITE/OUT "Table {P1}EX.tbl created to hold names of output frames"
!-------------------------------------------------------------------------------
! Get tables with object limits, sky and science frames
!-------------------------------------------------------------------------------
DO J = 1 N_SC
!---------------------------------------------------
! Get angle of retarder plate for science frame
!---------------------------------------------------
  DO I = SC_STRT({J}) SC_END({J})
!    COPY/TK {P1} :RET_ANG @{I} RET_ANG/R/1/1
    RET_ANG = {{P1},:RET_ANG,@{J}}
  ENDDO
!---------------------------------------------------
! Get LINFIT table for science frame
!---------------------------------------------------
  DO I = SC_STRT({J}) SC_END({J})
    COPY/TK {P1} {LINFIT} @{I} TMP/C/1/60
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY FITTAB {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get WINDOWS table for science frame
!---------------------------------------------------
  DO I = SC_STRT({J}) SC_END({J})
    COPY/TK {P1} {P4} @{I} TMP/C/1/60
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY INPUTC {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get sky frame for science frame
!---------------------------------------------------
  DO I = SC_STRT({J}) SC_END({J})
    COPY/TK {P1} {P3} @{I} TMP/C/1/60
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
  DO I = SC_STRT({J}) SC_END({J})
    COPY/TK {P1} {P2} @{I} TMP/C/1/60
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_A {TMP}
      COPY/TK {P1} {SC} @{I} SC_ORI/C/1/60
      WRITE/KEY COL_IN {P2}
      WRITE/KEY MAIN_TAB {P1}
      WRITE/KEY OUT_TAB {P1}EX
      RUN STD_EXE:SPOLEXT
      WRITE/KEY FITTAB/C/1/60 " " ALL
      WRITE/KEY IN_B/C/1/60 " " ALL
      WRITE/KEY INPUTC/C/1/60 " " ALL
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
      IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
        GOTO end
      ENDIF
    GOTO next
    ENDIF
  ENDDO
next:
ENDDO
END:
!










