! @(#)spolflat.prg	1.3 (ESO-IPG) 2/11/94 13:19:59
! +++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! SPOL PROCEDURE : SPOLNORM.PRG
!
! .PURPOSE
!
! execute the command :
! FLAT/SPOL SPOL_TAB SC FF_NORM SC_FLAT 
!
! -------------------------------------------------
!
! CROSSREF SPOL_TAB SC FF_NORM SC_FLAT FFLOC TRY
!
DEFINE/PARAM P1 {SPOL_TAB} TABLE   "Enter SPOL table:"
DEFINE/PARAM P2 {SC}  CHAR    "Enter column for input images:"
DEFINE/PARAM P3 {FF_NORM}  CHAR    "Enter column for normalized flats:"
DEFINE/PARAM P4 {SC_FLAT}  CHAR    "Enter column for output images:"
DEFINE/PARAM P5 ?          CHAR    "Same flat for all or individual flats? (def: S)"
DEFINE/PARAM P6 ?          CHAR    "First try or All frames? (def: F)"
!
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL P5/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
DEFINE/LOCAL GETFF/C/1/1 S
DEFI/LOCA STRLEN/I/1/1 60

WRITE/KEY TMP/C/1/{STRLEN} " " ALL
WRITE/KEY IN_B " " ALL
WRITE/KEY INPUTC " " ALL
!-------------------------------------------------------------------------------
! Check if same/individual is explicitly given (otherwise assume Same flat)
!-------------------------------------------------------------------------------
IF P5(1:1) .ne. " " THEN
  WRITE/KEY GETFF/C/1/1 {P5}
ENDIF
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P6(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P6}
ENDIF
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Initialize column to hold names of ouput images
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/8 {P4}
RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
! @s spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Same flat for each frame == one normalized flat
! for each SC frame
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
!---------------------------------------------------
! Get normalized flat for all science frames
!---------------------------------------------------
  WRITE/OUT "SAME normalized flat for all frames!"
  DO I = 1 {NUMROW}
    COPY/TK {P1} {P3} @{I} TMP/C/1/{STRLEN}
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get all science frames
!---------------------------------------------------
  DO J = 1 {N_SC}
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} TMP/C/1/{STRLEN}
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_A {TMP}
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEY OUT_A {PRE_FFSC}{IN_A(1:{OUTPUTI(1)})}.bdf
        COMP/IMA {OUT_A} = {IN_A}/{IN_B}
        WRITE/OUT "{OUT_A} = {IN_A}/{IN_B}"
        WRITE/TAB {P1} {P4} @{I} {OUT_A}
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
          GOTO end
        ENDIF
      GOTO next
      ENDIF
    ENDDO
next:
  ENDDO
!-------------------------------------------------------------------------------
! Individual flat for each frame 
!---------------------------------------------------
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
!---------------------------------------------------
! Get normalized flat for each science frame
!---------------------------------------------------
  DO J = 1 {N_SC}
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P3} @{I} TMP/C/1/{STRLEN}
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_B {TMP}
      ENDIF
    ENDDO
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} TMP/C/1/{STRLEN}
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_A {TMP}
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEY OUT_A {PRE_FFSC}{IN_A(1:{OUTPUTI(1)})}.bdf
        COMP/IMA {OUT_A} = {IN_A}/{IN_B}
        WRITE/OUT "{OUT_A} = {IN_A}/{IN_B}"
        WRITE/TAB {P1} {P4} @{I} {OUT_A}
!---------------------------------------------------
! Try only one FF frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
          GOTO end
        ENDIF
      GOTO next
      ENDIF
    ENDDO
next:
  ENDDO
ENDIF
end:
