! @(#)spolid.prg	5.1.1.3  (LSW)  02/07/94 15:56:13
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT   (C) 1994 Landessternwarte Heidelberg  
!.IDENT       spolident.prg
!.AUTHORS     Sabine Moehler   (LSW)
!             
!.KEYWORDS    Spectropolarimetry
!.PURPOSE     line identification 
!.VERSION     1.0  Creation          20-AUG-1993   
!             1.1  Adaption for SPOL 21-JUL-1994   
!-------------------------------------------------------
!
CROSSREF spol_tab ystart tolwindow 
!
DEFINE/PARAM P1 {SPOL_TAB}      TABLE   "Enter input table:"
DEFINE/PARAM  P2  {YSTART}            NUMB   "Y Coordinate "
DEFINE/PARAM  P3  {TOLWIND}           NUMB   "tolerance window "
!-------------------------------------------------------------------------------
! Local keys 
!-------------------------------------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
!
DEFINE/MAXPAR 5
!
!-------------------------------------------------------
! Initialize keywords
!-------------------------------------------------------
WRITE/KEY LINTMP/C/1/60 " " all
WRITE/KEYW XPOS 0 ALL
WRITE/KEYW LID 0 ALL
I = {P2}
!
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!---------------------------------------------------
! Search for first table listed in col. {LINPOS} in 
! spol_tab
!---------------------------------------------------
DO J = 1 {NUMROW}
  COPY/TK {P1} {LINPOS} @{J} LINTMP/C/1/60
  IF LINTMP(1:1) .ne. " " THEN
!---------------------------------------------------
! Get name of corresponding WLC frame from header
! of table
!---------------------------------------------------
    COPY/DK {LINTMP} WLC/C/1/60 WLC
    I = {P2}
!---------------------------------------------------
! Start Identification
!---------------------------------------------------
    GOTO TEST_TBL
  ENDIF
ENDDO
!---------------------------------------------------
! end of loop over table rows
!-------------------------------------------------------------------------------

TEST_TBL:
!-------------------------------------------------------
! find CCD line where emission lines shall be identified
!-------------------------------------------------------
  SELECT/TABLE {LINTMP} :Y.EQ.{I}
  IF OUTPUTI(1) .EQ. 0 THEN
    WRITE/OUT "line" {I} " has not been scanned. We try the next line"
    I = I+1
    GOTO TEST_TBL 
  ENDIF
!-------------------------------------------------------
! create temporary table
!-------------------------------------------------------
  COPY/TABLE {LINTMP} MIDTMP
  PLOT/ROW {WLC} {I}
  over/ident {LINTMP} :X :X
  INPUTI(1) = {I} 
  WRITE/KEYW YSTART {INPUTI(1)}
  INPUTR(1) = {P3} 
!-------------------------------------------------------
! start identification
!-------------------------------------------------------
identify/gcurs MIDTMP :IDENT :X ? {P3}
!-------------------------------------------------------
! finish and delete temporary tables
!-------------------------------------------------------
WRITE/KEYW WLC MIDTMP
WRITE/KEY IN_A {WLC}
RUN STD_EXE:mosget_id
sele/table {LINTMP} all
dele/table MIDTMP no
