! @(#)spolnorm.prg	1.3 (ESO-IPG) 2/11/94 13:19:59
! +++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! SPOL PROCEDURE : SPOLNORM.PRG
!
! .PURPOSE
!
! execute the command :
! NORM/SPOL SPOL_TAB FF_OUT SLIT_TAB FF_NORM ORDER METHOD
!
! -------------------------------------------------
!
! CROSSREF SPOL_TAB FF_OUT SLIT_TAB FF_NORM ORDER METHOD
!
DEFINE/PARAM P1 {SPOL_TAB} TABLE   "Enter SPOL table:"
DEFINE/PARAM P2 {FF_OUT}   CHAR    "Enter column with averaged flats:"
DEFINE/PARAM P3 {SLIT_TAB} CHAR    "Enter column with slitlet tables:"
DEFINE/PARAM P4 {FF_NORM}  CHAR    "Enter column for output images:"
DEFINE/PARAM P5 {FFORD}    NUMBER  "Enter order of fit:"
DEFINE/PARAM P6 {NORMMET}  ?       "Method for smoothing:"
DEFINE/PARAM P7 ?          CHAR    "First try or All frames? (def: F)"
!
!SET/SPOL fford={P5} NORMMET={P6}
!
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------------------------------------
DEFI/LOCA STRLEN/I/1/1 60

DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
WRITE/KEY TMP/C/1/{STRLEN} " " ALL
WRITE/KEY IN_B " " ALL
WRITE/KEY INPUTC " " ALL
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P7(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P7}
ENDIF
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF
!-------------------------------------------------------------------------------
! Initialize column to hold names of normalized flats
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/{STRLEN} {P4}
RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
! @s spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Get normalization parameters
!-------------------------------------------------------------------------------
WRITE/KEYW INPUTI {P5}
WRITE/KEYW INPUTC {P6}
!-------------------------------------------------------------------------------
! Same flat for all frames == one slitlet table for all frames
!---------------------------------------------------
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
!---------------------------------------------------
! Get slitlet table for all science frames
!---------------------------------------------------
  DO I = 1 {NUMROW}
    COPY/TK {P1} {P3} @{I} TMP/C/1/{STRLEN}
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get flat field for all science frames
!---------------------------------------------------
  DO I = 1 {NUMROW}
    COPY/TK {P1} {P2} @{I} TMP/C/1/{STRLEN}
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_A {TMP}
      COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
      WRITE/KEY OUT_A {PRE_NORM}{IN_A(1:{OUTPUTI(1)})}.bdf
      RUN STD_EXE:MOSNORM
      WRITE/TAB {P1} {P4} @{I} {OUT_A}
      IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
        GOTO end
      ENDIF
    ENDIF
  ENDDO
!-------------------------------------------------------------------------------
! Individual flat for each frame == one slitlet
! table for each SC frame
!---------------------------------------------------
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
!---------------------------------------------------
! Get slitlet table for each science frame
!---------------------------------------------------
  DO J = 1 {N_SC}
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P3} @{I} TMP/C/1/{STRLEN}
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_B {TMP}
      ENDIF
    ENDDO
!---------------------------------------------------
! Get flat field for each science frame
!---------------------------------------------------
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} TMP/C/1/{STRLEN}
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_A {TMP}
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEY OUT_A {PRE_NORM}{IN_A(1:{OUTPUTI(1)})}.bdf
        RUN STD_EXE:MOSNORM
        WRITE/TAB {P1} {P4} @{I} {OUT_A}
!---------------------------------------------------
! Try only one FF frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
          GOTO end
        ENDIF
      ENDIF
    ENDDO
  ENDDO
ENDIF
end:
