! @(#)spolplotdef.prg          (LSW)     02/07/94 15:54
! +++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT    (C) 1994 Landessternwarte Heidelberg
!.IDENT        spolplotdef.prg
!.AUTHORS      Sabine Moehler (LSW)
!              Otmar Stahl (LSW)
!.KEYWORDS     Spectropolarimetry
!  
!.PURPOSE      execute the command PLOTDEF/SPOL
!
!.VERSION      1.0 Creation 02/07/94
! 
! PLOTDEF/SPOL inframe windows slit_tab xbin plot_opt             
!
! -------------------------------------------------
!
! CROSSREF inframe slitlet_table windows xbin scan_pos plot_opt             
!
DEFINE/PARAM P1 ?          IMAGE   "Enter input image:"
DEFINE/PARAM P2 ?          CHAR    "Enter table with slitlets limits"
DEFINE/PARAM P3 ?          CHAR    "Enter table with sky/objects limits"
DEFINE/PARAM P4 {XBIN}     NUMBER  "Binning in X:"
DEFINE/PARAM P5 {SCAN_POS} NUMBER  "Center for scan (world coordinates)"
DEFINE/PARAM P6 0.         NUMBER  "Plot option"
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------
! ... for plotting 
!-------------------------------------------------
DEFINE/LOCAL PLOTPAR1/I/1/1 0.
DEFINE/LOCAL PLOTPAR2/I/1/1 0.
DEFINE/LOCAL PLOTPAR3/I/1/1 0.
DEFINE/LOCAL PLOTPAR4/I/1/1 0.
define/local tmp1/d/1/1 0.
define/local tmp2/i/1/2 0.,0.
define/local tmp3/i/1/1 0.
define/local tmp4/i/1/1 0.
! Continue flag
define/local cont/c/1/1 y
! Decision keyword
define/local path/i/1/2 0.,0.
! Counter
define/local I/I/1/1 0
define/local J/I/1/1 0
! Position keyword
define/local posr/r/1/3 0.,0.,0.
! Selection keyword
define/local select/i/1/1 0.
! Keyword to determine whether slitlet has been searched
define/local found/i/1/1 0.
!
!-------------------------------------------------------------------------------
! ... for sorting
!-------------------------------------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL II/I/1/1 0.
DEFINE/LOCAL JJ/I/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
DEFINE/LOCAL SCAN/D/1/1 0.
WRITE/KEY IN_B " " ALL
!-------------------------------------------------------------------------------
! Initialize plot parameters
!-------------------------------------------------------------------------------
COPY/DK {P1} START/D/1/1 PLOTPAR1
COPY/DK {P1} STEP/D/1/1 TMP1
COPY/DK {P1} NPIX/I/1/2 TMP2
WRITE/KEY INPUTI/I/1/1 {WIND}
IF INPUTI(1) .le. 0 THEN
  WRITE/KEY INPUTI/I/1/1 100
ENDIF
WRITE/KEYW SCAN {P5}
IF SCAN .eq. 0 THEN
  SCAN = TMP2/2*TMP1+PLOTPAR1
ENDIF
!-------------------------------------------------------------------------------
! get number of objects/sky regions found by DEFINE/SPOL
!-------------------------------------------------------------------------------
IF M$INDEXB(P3,".tbl") .LT. 1 THEN
	COPY/DK {P3}.tbl NOBJ/I/1/1 NOBJ/I/1/1
	COPY/DK {P3}.tbl NSKY/I/1/1 NSKY/I/1/1
ELSE
	COPY/DK {P3} NOBJ/I/1/1 NOBJ/I/1/1
	COPY/DK {P3} NSKY/I/1/1 NSKY/I/1/1
ENDIF
!-------------------------------------------------------------------------------
! Plot options 
!-------------------------------------------------------------------------------
IF {P6} .eq. 1 .or. {P6} .eq. 3 THEN

!-------------------------------------------------------------------------------
! 2-dim display
!-------------------------------------------------------------------------------

  LOAD {P1}
  WRITE/OUT "object = blue"
  CLEAR/CHAN OVERLAY
  PLOTPAR3 = PLOTPAR1+{TMP1}*({TMP2(1)}-1)
  
  DO I = 1 {NOBJ}
    PLOTPAR2 = {{P3},:Obj_Strt,{I}}
    PLOTPAR4 = {{P3},:Obj_End,{I}}
    DRAW/RECTA {PLOTPAR1},{PLOTPAR2},{PLOTPAR3},{PLOTPAR4} F ? 5 ? 
  ENDDO

  inquire/keyw cont "Press return to plot sky, n to stop"
  IF cont .eq. "y" then
    WRITE/OUT "sky = green "
    DO I = 1 {NSKY}
      PLOTPAR2 = {{P3},:Sky_Strt,{I}}
      PLOTPAR4 = {{P3},:Sky_End,{I}}
      DRAW/RECTA {PLOTPAR1},{PLOTPAR2},{PLOTPAR3},{PLOTPAR4} F ? 4 ? 
    ENDDO
  ELSE 
    WRITE/KEYW cont/c/1/1 y
  ENDIF
ENDIF

IF {P6} .ge. 2 THEN

!-------------------------------------------------------------------------------
! Graphical display
!-------------------------------------------------------------------------------

  WRITE/OUT "Now computing 1-dimensional frames"
  DISPLAY/LONG
  TMP3 = SCAN-{P4}/2
  TMP4 = SCAN+{P4}/2
  AVER/COLUMN MIDTMPC = {P1} {TMP3},{TMP4}
  TMP3 = PLOTPAR1+{TMP1}*{INPUTI(1)}
  TMP4 = PLOTPAR1+{TMP1}*({INPUTI(1)}+{P4})
  AVER/COLUMN MIDTMPS = {P1} {TMP3},{TMP4}
  TMP3 = PLOTPAR1+{TMP1}*({TMP2(1)}-{INPUTI(1)}-{P4})
  TMP4 = PLOTPAR1+{TMP1}*({TMP2(1)}-{INPUTI(1)})
  AVER/COLUMN MIDTMPE = {P1} {TMP3},{TMP4}

  SET/GRAP COLOUR=1 LTYPE=1
  PLOT MIDTMPC
  SET/GRAP COLOUR=1 LTYPE=2
  OVER MIDTMPS
  OVER MIDTMPE
  SET/GRAP COLOUR=4 LTYPE=1
  DO I = 1 {NOBJ}
    PLOTPAR1 = {PLRGRAP(5)}*0.5+{PLRGRAP(6)}*0.5
    PLOTPAR2 = {{P3},:Obj_Strt,{I}}
    PLOTPAR4 = {{P3},:Obj_End,{I}}
    OVERPLOT/LINE 1 {PLOTPAR2},{PLRGRAP(5)} {PLOTPAR2},{PLRGRAP(6)}
    OVERPLOT/LINE 1 {PLOTPAR4},{PLRGRAP(5)} {PLOTPAR4},{PLRGRAP(6)}
    OVERPLOT/LINE 1 {PLOTPAR2},{PLOTPAR1} {PLOTPAR4},{PLOTPAR1}
  ENDDO
  SET/GRAP COLOUR=3
  DO I = 1 {NSKY}
    PLOTPAR1 = {PLRGRAP(5)}*0.5+{PLRGRAP(6)}*0.5
    PLOTPAR2 = {{P3},:Sky_Strt,{I}}
    PLOTPAR4 = {{P3},:Sky_End,{I}}
    OVERPLOT/LINE 1 {PLOTPAR2},{PLRGRAP(5)} {PLOTPAR2},{PLRGRAP(6)}
    OVERPLOT/LINE 1 {PLOTPAR4},{PLRGRAP(5)} {PLOTPAR4},{PLRGRAP(6)}
    OVERPLOT/LINE 1 {PLOTPAR2},{PLOTPAR1} {PLOTPAR4},{PLOTPAR1}
  ENDDO
  SET/GRAP COLOUR=1
ENDIF
end:
