!
!  POLPLOT.PRG
!
!
DEFI/PARA P1 ? C "prefix of extracted spectra: "
DEFI/PARA P2 IPT ? "mode: IPT IQU or IV:"
DEFI/PARA P3 0,0 N "Enter X start and end values for plotting: "
DEFI/PARA P4 0,0 N "Enter lower and upper limits for intensity plot: "
DEFI/PARA P5 0,0 N "Enter lower and upper limits for polarization (%) plot: "
DEFI/PARA P6 0,0 N "Enter lower and upper limits for position angle (deg.) plot: "



DEFI/LOCA LABELX/C/1/60 "\lambda , in {{P1}p.bdf,CUNIT(17:32)}"
DEFI/LOCA XLIM/R/1/2 {P3}

IF "{P2}" .EQ. "IPT" THEN
	DEFI/LOCA LABEL1/C/1/60 "flux"
	DEFI/LOCA LABEL2/C/1/60 "p"
	DEFI/LOCA LABEL3/C/1/60 "\theta , in degree"
	LPOL/SPOL {P1}I,{P1}IE {P1}p,{P1}pE {P1}t,{P1}tE {P1}LPT
ELSE IF "{P2}" .EQ. "IQU" THEN
	DEFI/LOCA LABEL1/C/1/60 "flux"
	DEFI/LOCA LABEL2/C/1/60 "Q"
	DEFI/LOCA LABEL3/C/1/60 "U"
	LPOL/SPOL {P1}I,{P1}IE {P1}Q,{P1}QE {P1}U,{P1}UE {P1}LPT
ELSE IF "{P2}" .EQ. "IV" THEN
	DEFI/LOCA LABEL1/C/1/60 "flux"
	DEFI/LOCA LABEL2/C/1/60 "V"
	DEFI/LOCA LABEL3/C/1/60 "V"
	LPOL/SPOL {P1}I,{P1}IE {P1}V,{P1}VE {P1}V,{P1}VE {P1}LPT
ELSE
	WRITE/OUT "mode {P2} is unknown"
	RETURN
ENDIF

!
! Get X limits for plot. If equal then get X limits from the table
!
IF XLIM(1) .EQ. XLIM(2) THEN
  STAT/TABLE {P1}LPT #1
  XLIM(1) = OUTPUTR(1)
  XLIM(2) = OUTPUTR(2)
ELSE
  SELECT/TABLE {P1}LPT :X.GE.{XLIM(1)}.AND.:X.LE.{XLIM(2)}
  STAT/TABLE {P1}LPT #1
ENDIF
!
! Get flux limits for plot. If equal then get limits from the table
!
DEFINE/LOCAL FLIM/R/1/2 0.,0.
DEFINE/LOCAL FL1/R/1/1 0.
DEFINE/LOCAL FL2/R/1/1 0.
DEFINE/LOCAL FL3/R/1/1 0.
WRITE/KEY FLIM/R/1/2 {P4}
IF FLIM(1) .EQ. FLIM(2) THEN
  STAT/TABLE {P1}LPT #2
  FL1 = OUTPUTR(1)
  FL2 = OUTPUTR(2)
  STAT/TABLE {P1}LPT #3
  FL3 = FL2-FL1
  FL1 = FL1-M$ABS(OUTPUTR(3))
  FL2 = FL2+M$ABS(OUTPUTR(3))
  FL1 = FL1-0.05*M$ABS(FL3)
  FL2 = FL2*1.05
  WRITE/KEY FLIM/R/1/2 {FL1},{FL2}
ENDIF
!
! Get polarization limits for plot. If equal then get limits from the table
!
DEFINE/LOCAL PLIM/R/1/2 0.,0.
DEFINE/LOCAL PL1/R/1/1 0.
DEFINE/LOCAL PL2/R/1/1 0.
DEFINE/LOCAL PL3/R/1/1 0.
WRITE/KEY PLIM/R/1/2 {P5}
IF PLIM(1) .EQ. PLIM(2) THEN
  STAT/TABLE {P1}LPT #4
  PL1 = OUTPUTR(1)
  PL2 = OUTPUTR(2)
  STAT/TABLE {P1}LPT #5
  PL3 = PL2-PL1
  PL1 = PL1-M$ABS(OUTPUTR(3))
  PL2 = PL2+M$ABS(OUTPUTR(3))
  PL1 = PL1-0.05*M$ABS(PL3)
  PL2 = PL2*1.05
  WRITE/KEY PLIM/R/1/2 {PL1},{PL2}
ENDIF
!
! Get position angle limits for plot. If equal then get limits from the table
!
DEFINE/LOCAL ALIM/R/1/2 0.,0.
DEFINE/LOCAL PA1/R/1/1 0.
DEFINE/LOCAL PA2/R/1/1 0.
DEFINE/LOCAL PA3/R/1/1 0.
WRITE/KEY ALIM/R/1/2 {P6}
IF ALIM(1) .EQ. ALIM(2) THEN
  STAT/TABLE {P1}LPT #6
  PA1 = OUTPUTR(1)
  PA2 = OUTPUTR(2)
  STAT/TABLE {P1}LPT #7
  PA3 = PA2-PA1
  PA1 = PA1-M$ABS(OUTPUTR(3))
  PA2 = PA2+M$ABS(OUTPUTR(3))
  PA1 = PA1-0.05*M$ABS(PA3)
  PA2 = 1.05*PA2
  WRITE/KEY ALIM/R/1/2 {PA1},{PA2}
ENDIF
!
! Now do the plotting
!
set/graphics pmode=1 ltype=1 stype=0 binmode=on fonts=1
!
! Plot polarization position angle and error on upper plot
!
set/graphics yformat
set/graphics xformat=none
plot/axes {XLIM(1)},{XLIM(2)},0,0 {ALIM(1)},{ALIM(2)},0.,0. -140,-35,35,85 "" "{LABEL3}"
set/grap color=4
overplot/error {P1}LPT #1 #6 #7 6
set/grap color
overplot/table {P1}LPT #1 #6

!
! Plot total intensity and error on lowest plot
!
set/graphics xformat
set/graphics yformat=e6.2
IF XLIM(1) .GT. 1000. THEN
  overplot/axes {XLIM(1)},{XLIM(2)},0,0 {FLIM(1)},{FLIM(2)},0.,0. -140,-35,35,15 "{LABELX}" "{LABEL1}"
ELSE
  overplot/axes {XLIM(1)},{XLIM(2)},0,0 {FLIM(1)},{FLIM(2)},0.,0. -140,-35,35,15 "{LABELX}" "{LABEL1}"
ENDIF
set/grap color=4
overplot/error {P1}LPT #1 #2 #3 6 
set/grap color
overplot/table {P1}LPT #1 #2

!
! Plot linear polarization and error on middle plot
!
set/graphics xformat=none
set/graphics yformat
overplot/axes {XLIM(1)},{XLIM(2)},0,0 {PLIM(1)},{PLIM(2)},0.,0. -140,-35,35,50 "" "{LABEL2}"
set/grap color=4
overplot/error {P1}LPT #1 #4 #5 6
set/grap color
overplot/table {P1}LPT #1 #4
!

