!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT   (C) 1993 European Southern Observatory
!.IDENT       spolplsear.prg
!.AUTHORS     Sabine Moehler   (LSW)
!             
!.KEYWORDS    Spectroscopy, Long-Slit, SPOL
!.PURPOSE     line identification 
!.VERSION     1.0  Package Creation  17-MAR-1993  
!             1.1  adapted for MOS   20-AUG-1993   
!             1.2  adapted for SPOL  23-FEB-1995   
!-------------------------------------------------------
!
define/param P1  2D     CHAR  "Mode (1D/2D):"
define/param P2  1      NUMB  "Slit number (in 1D):"
define/param P3  {{SPOL_TAB},{LINPOS},@1} CHAR  "Table with line positions:"
define/param P4  :X 	CHAR  "Table column to be shown"
!
define/local table/C/1/60 {P3}
define/local row/I/1/1    0 
!
IF P1(1:1) .EQ. "1" THEN
   set/midas output=LOGONLY
   SELECT/TABLE {P3} :SLIT.EQ.{P2}
   copy/table   {P3} &t 
   SELECT/TABLE {P3} ALL
   write/keyw    table  middummt.tbl
   row = {middummt.tbl,:Y,@1}
   select/table &t :Y.EQ.{row}
   SET/MIDAS output=YES

   PLOT/ROW  {WLC} {row}
   SELE/TABL {{SPOL_TAB},{LINPOS},@1} :Y.eq.{row}
   OVER/IDEN {{SPOL_TAB},{LINPOS},@1} :X {P4}
ELSE
   @s splsear {P1} {table} ? {row}
ENDIF

!@s splsear {P1} {table} ? {row}
!
RETURN

