!
!  POLPLOT.PRG
!
!
DEFINE/PAR P1 ? C "Enter name of reduced Linear Polarization table: "
DEFINE/PAR P2 ? N "Enter X start and end values for plotting: "
DEFINE/PAR P3 ? N "Enter lower and upper limits for intensity plot: "
DEFINE/PAR P4 ? N "Enter lower and upper limits for polarization (%) plot: "
DEFINE/PAR P5 ? N "Enter lower and upper limits for position angle (deg.) plot: "
!
! Get X limits for plot. If equal then get X limits from the table
!
DEFINE/LOCAL XLIM/R/1/2 0.,0.
WRITE/KEY XLIM/R/1/2 {P2}
IF XLIM(1) .EQ. XLIM(2) THEN
  STAT/TABLE {P1} #1
  WRITE/KEY XLIM/R/1/2 OUTPUTR(1),OUTPUTR(2)
ELSE
  SELECT/TABLE {P1} :X.GE.{XLIM(1)}.AND.:X.LE.{XLIM(2)}
  STAT/TABLE {P1} #1
ENDIF
!
! Get flux limits for plot. If equal then get limits from the table
!
DEFINE/LOCAL FLIM/R/1/2 0.,0.
DEFINE/LOCAL FL1/R/1/1 0.
DEFINE/LOCAL FL2/R/1/1 0.
DEFINE/LOCAL FL3/R/1/1 0.
WRITE/KEY FLIM/R/1/2 {P3}
IF FLIM(1) .EQ. FLIM(2) THEN
  STAT/TABLE {P1} #2
  FL1 = OUTPUTR(1)
  FL2 = OUTPUTR(2)
  STAT/TABLE {P1} #3
  FL3 = FL2-FL1
  FL1 = FL1-M$ABS(OUTPUTR(3))
  FL2 = FL2+M$ABS(OUTPUTR(3))
  FL1 = FL1-0.05*M$ABS(FL3)
  FL2 = FL2*1.05
  WRITE/KEY FLIM/R/1/2 {FL1},{FL2}
ENDIF
!
! Get polarization limits for plot. If equal then get limits from the table
!
DEFINE/LOCAL PLIM/R/1/2 0.,0.
DEFINE/LOCAL PL1/R/1/1 0.
DEFINE/LOCAL PL2/R/1/1 0.
DEFINE/LOCAL PL3/R/1/1 0.
WRITE/KEY PLIM/R/1/2 {P4}
IF PLIM(1) .EQ. PLIM(2) THEN
  STAT/TABLE {P1} #4
  PL1 = OUTPUTR(1)
  PL2 = OUTPUTR(2)
  STAT/TABLE {P1} #5
  PL3 = PL2-PL1
  PL1 = PL1-M$ABS(OUTPUTR(3))
  PL2 = PL2+M$ABS(OUTPUTR(3))
  PL1 = PL1-0.05*M$ABS(PL3)
  PL2 = PL2*1.05
  WRITE/KEY PLIM/R/1/2 {PL1},{PL2}
ENDIF
!
! Get position angle limits for plot. If equal then get limits from the table
!
DEFINE/LOCAL ALIM/R/1/2 0.,0.
DEFINE/LOCAL PA1/R/1/1 0.
DEFINE/LOCAL PA2/R/1/1 0.
DEFINE/LOCAL PA3/R/1/1 0.
WRITE/KEY ALIM/R/1/2 {P5}
IF ALIM(1) .EQ. ALIM(2) THEN
  STAT/TABLE {P1} #6
  PA1 = OUTPUTR(1)
  PA2 = OUTPUTR(2)
  STAT/TABLE {P1} #7
  PA3 = PA2-PA1
  PA1 = PA1-M$ABS(OUTPUTR(3))
  PA2 = PA2+M$ABS(OUTPUTR(3))
  PA1 = PA1-0.05*M$ABS(PA3)
  PA2 = 1.05*PA2
  WRITE/KEY ALIM/R/1/2 {PA1},{PA2}
ENDIF
!
! Now do the plotting
!
!create/graphics 0 600,450,0,450
set/graphics pmode=1
set/graphics ltype=1
set/graphics stype=0
set/graphics binmode=on
!
! Plot polarization position angle and error on upper plot
!
set/graphics yformat
set/graphics xformat=none
plot/axes {XLIM(1)},{XLIM(2)},0,0 {ALIM(1)},{ALIM(2)},0.,0. -140,-35,35,85 "" "Pol. PA (deg)"
set/grap color=4
overplot/error {P1} #1 :Pol_PA Pol_PA_Err 6
set/grap color
overplot/table {P1} #1 :Pol_PA

!
! Plot total intensity and error on lowest plot
!
set/graphics xformat
set/graphics yformat=e6.2
IF XLIM(1) .GT. 1000. THEN
  overplot/axes {XLIM(1)},{XLIM(2)},0,0 {FLIM(1)},{FLIM(2)},0.,0. -140,-35,35,15 "Wavelength" "Flux (ADU)"
ELSE
  overplot/axes {XLIM(1)},{XLIM(2)},0,0 {FLIM(1)},{FLIM(2)},0.,0. -140,-35,35,15 "Channels" "Flux (ADU)"
ENDIF
set/grap color=4
overplot/error {P1} #1 :Tot_Int :Tot_Int_Err 6 
set/grap color
overplot/table {P1} #1 :Tot_Int

!
! Plot linear polarization and error on middle plot
!
set/graphics xformat=none
set/graphics yformat
overplot/axes {XLIM(1)},{XLIM(2)},0,0 {PLIM(1)},{PLIM(2)},0.,0. -140,-35,35,50 "" "Lin. Pol"
set/grap color=4
overplot/error {P1} #1 :Lin_Pol :Lin_Pol_Err 6
set/grap color
overplot/table {P1} #1 :Lin_Pol
!

