DEFI/PARA P1 ? ? "right ascension"
DEFI/PARA P2 ? ? "declination"
DEFI/PARA P3 ? ? "input epoche"
DEFI/PARA P4 ? ? "output epoche"
DEFI/PARA P5 ? ? "input prefix"
DEFI/PARA P6 ? ? "output prefix"
DEFI/PARA P7 PT ? "mode: PT = p,theta (default)   or QU = Stokes Q&U"


DEFI/LOCA RA/D/1/3 {P1},0.,0.,0.
DEFI/LOCA DEC/D/1/3 {P2},0.,0.,0.
DEFI/LOCA CRA/D/1/3 0.,0.,0.
DEFI/LOCA CDEC/D/1/3 0.,0.,0
DEFI/LOCA CTHETA/D/1/3 0.,0.,0.

DEFI/LOCA EPOCHE/D/1/2 {P3},{P4}
DEFI/LOCA INPUTC1/C/1/80 {P5}
DEFI/LOCA INPUTC2/C/1/80 {P6}

DEFI/LOCA MODE/C/1/80 {P7}

DEFI/LOCA st2/D/1/1 0.0
DEFI/LOCA ct2/D/1/1 0.0

IF "{P2(1:1)}" .EQ. "-" .AND. DEC(1) .EQ. 0.0 THEN
	DEC(2) = DEC(2) * -1.0
	DEC(3) = DEC(3) * -1.0
ENDIF


RUN STD_EXE:spolprecess


!WRITE/OUT "RA = {CRA} DEC = {CDEC}   angular offset = {CTHETA}"


IF "{P7(1:2)}" .EQ. "PT" THEN

	COMP/IMAG {P6}t = {P5}t + {CTHETA}
	COPY/II {P5}tE {P6}tE
	COPY/II {P5}p {P6}p
	COPY/II {P5}pE {P6}pE

ELSE

	SET/FORMAT F15.10

	st2 = M$SIN({CTHETA}*2.0) 
	ct2 = M$COS({CTHETA}*2.0) 

	COMP/IMAGE {P6}Q = {P5}Q * {ct2} - {P5}U * {st2}
	COMP/IMAGE {P6}U = {P5}Q * {st2} + {P5}U * {ct2} 

	COMP/IMAGE {P6}QE = {P5}QE * {ct2} - {P5}UE * {st2} 
	COMP/IMAGE {P6}UE = {P5}QE * {st2} + {P5}UE * {ct2} 

ENDIF
