! @(#)spolrebin.prg	1.4 (ESO-IPG) 2/11/94 13:20:00
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT   (C) 1993 European Southern Observatory
!.IDENT       spolrebin.prg
!.AUTHORS     Sabine Moehler   (LSW)
!.KEYWORDS    Spectropolarimetry
!.PURPOSE     
!.VERSION     1.0  Package Creation  17-MAR-1993  
!             1.1  adapted for MOS   20-AUG-1993   
!             1.2  adapted for SPOL  22-JUL-1994   
!
!-------------------------------------------------------------------------------
! Parameters
!---------------------------------------------------
! ... for sorting part
!---------------------------------------------------
DEFINE/PARAM P1 {SPOL_TAB} TABLE   "Enter input table:"
DEFINE/PARAM P2 {SC} TABLE   "Enter input table:"
!---------------------------------------------------
! ... for rebinning part
!-------------------------------------------------------------------------------
DEFINE/PARAM  P3 {REBSTRT},{REBEND},{REBSTP} N "Start, End, Step in wavelength:"
DEFINE/PARAM  P4  {REBMET}        CHA "Rebin method (SPLINE/QUADRATIC/LINEAR) :"
DEFINE/PARAM  P5  3               NUM "order of interpolation between rows: "
DEFINE/PARAM P6 ? CHAR "First try/All frames (Def. F):"
!-------------------------------------------------------------------------------
! Local keys ...
!---------------------------------------------------
! ... for sorting part
!---------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
WRITE/KEY TMP/C/1/80 " " ALL
WRITE/KEY IN_B/C/1/80 " " ALL
!---------------------------------------------------
! ... for rebinning part
!---------------------------------------------------
DEFINE/LOCAL FITD/I/1/1 0
!-------------------------------------------------------------------------------
WRITE/KEYW INPUTR/R/1/3 {P3}
REBSTRT = INPUTR(1)
REBEND = INPUTR(2)
REBSTP = INPUTR(3)

!
DEFINE/MAXPAR 6
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P6(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P6}
ENDIF 
!------------------------------------------------------------------------------
!
! get numbers for rebinning method
!
!------------------------------------------------------------------------------
INPUTI(1) = -1
IF P4(1:1) .EQ. "L"  WRITE/KEYW INPUTI/I/1/1   0    ! Method LINEAR
IF P4(1:1) .EQ. "Q"  WRITE/KEYW INPUTI/I/1/1   1    ! Method QUADRATIC
IF P4(1:1) .EQ. "S"  WRITE/KEYW INPUTI/I/1/1   2    ! Method SPLINE
!
IF INPUTI(1) .LT. 0  THEN
   WRITE/OUT "Rebin: Unknown method {P4}"
   RETURN/EXIT
ENDIF
!
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF 
!-------------------------------------------------------------------------------
! Initialize column to hold names of rebinned frames
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/8 {SC_REB}
RUN STD_EXE:spolcolini
!
!-------------------------------------------------------------------------------
! Get tables with slitlets, dispersion coefficients, and science frames
!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
! Same flat for all frames 
! == one slitlet table for all frames
!---------------------------------------------------
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
!---------------------------------------------------
! Get slitlet table for all science frames
!---------------------------------------------------
  DO I = 1 {NUMROW}
    COPY/TK {P1} {SLIT_TAB} @{I} TMP/C/1/80
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_C/C/1/80 {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get LINFIT table(s) for science frames
!---------------------------------------------------
  DO J = 1 {N_SC}
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {LINFIT} @{I} TMP/C/1/80
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_B {TMP}
      ENDIF
    ENDDO
    IF IN_B(1:1) .eq. " " THEN
      WRITE/OUT "No table with dispersion coefficients!"
      GOTO fits
    ENDIF
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} IN_A/C/1/80
      IF IN_A(1:1) .ne. " " THEN
!---------------------------------------------------
! Perform rebinning for actual frame
!---------------------------------------------------
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEYW OUT_A {PRE_REB}{IN_A(1:{OUTPUTI(1)})}.bdf
        WRITE/KEYW  INPUTC       {P4}
        COPY/KD INPUTR/R/1/3 {IN_B} REBPAR/R/1/3
!---------------------------------------------------
! do polynomial regression for all coefficients 
! (to be done, Otmar Stahl)
!---------------------------------------------------
        COPY/DK    {IN_B} LNCOE FITD
        WRITE/OUT "inframe: {IN_A}"
        WRITE/OUT "intable: {IN_B}"
	IF M$EXISTD("{IN_B}","NORMCOORD") .EQ. 1 THEN
	  RUN STD_EXE:mosrebifors
	ELSE
          RUN STD_EXE:MOSREBIN
        ENDIF
        WRITE/OUT  "Calibration Performed."
        WRITE/OUT "outframe: {OUT_A}"
        WRITE/OUT " "
        WRITE/KEY IN_B/C/1/80 " " ALL
!---------------------------------------------------
! Continue sorting and write name of output frame to 
! column :SC_REB of spol_tab
!---------------------------------------------------
        WRITE/TABLE {P1} {SC_REB} @{I} {OUT_A}
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
          GOTO end
        ENDIF
      GOTO fits
      ENDIF
!---------------------------------------------------
! End of DO loop over one science frame
!---------------------------------------------------
    ENDDO
!---------------------------------------------------
! End of DO loop over SCIENCE frame(s) 
!---------------------------------------------------
fits:
  ENDDO  
!-------------------------------------------------------------------------------

!-------------------------------------------------------------------------------
! Individual flat for each frame == one slitlet table for each SC frame
!---------------------------------------------------
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
!---------------------------------------------------
! Get slitlet table for each science frame
!---------------------------------------------------
  DO J = 1 {N_SC}  
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {SLIT_TAB} @{I} TMP/C/1/80
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_C/C/1/80 {TMP}
      ENDIF
    ENDDO
!---------------------------------------------------
! Get LINFIT table(s) for science frame
!---------------------------------------------------
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {LINFIT} @{I} TMP/C/1/80
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_B {TMP}
      ENDIF
    ENDDO
    IF IN_B(1:1) .eq. " " THEN
      WRITE/OUT "No table with dispersion coefficients!"
      GOTO fiti
    ENDIF
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} IN_A/C/1/80
      IF IN_A(1:1) .ne. " " THEN
!---------------------------------------------------
! Perform rebinning for actual frame
!---------------------------------------------------
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEYW OUT_A {PRE_REB}{IN_A(1:{OUTPUTI(1)})}.bdf
        WRITE/KEYW  INPUTC       {P4}
        COPY/KD INPUTR/R/1/3 {IN_B} REBPAR/R/1/3
!---------------------------------------------------
! do polynomial regression for all coefficients 
! (to be done, Otmar Stahl)
!---------------------------------------------------
        COPY/DK    {IN_B} LNCOE FITD
        WRITE/OUT "inframe: {IN_A}"
        WRITE/OUT "intable: {IN_B}"
	IF M$EXISTD("{IN_B}","NORMCOORD") .EQ. 1 THEN
	  RUN STD_EXE:mosrebifors
	ELSE
          RUN STD_EXE:MOSREBIN
        ENDIF
!        RUN STD_EXE:MOSREBIN
        WRITE/OUT  "Calibration Performed."
        WRITE/OUT "outframe: {OUT_A}"
        WRITE/OUT " "
        WRITE/KEY IN_B/C/1/80 " " ALL
!---------------------------------------------------
! Continue sorting and write name of output frame to 
! column :SC_REB of spol_tab
!---------------------------------------------------
        WRITE/TABLE {P1} {SC_REB} @{I} {OUT_A}
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
          GOTO end    ! Try only one SC frame for first try
        ENDIF
      GOTO fiti
      ENDIF
!---------------------------------------------------
! End of DO loop over one science frame
!---------------------------------------------------
    ENDDO  
!---------------------------------------------------
! End of DO loop over SC frames 
!-------------------------------------------------------------------------------
fiti:
  ENDDO  
ENDIF
END:
