! @(#)spolrebin1d.prg	1.4 (ESO-IPG) 2/11/94 13:20:00
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT   (C) 1993 European Southern Observatory
!.IDENT       spolrebin1d.prg
!.AUTHORS     Sabine Moehler   (LSW)
!.KEYWORDS    Spectropolarimetry
!.PURPOSE     
!.VERSION     1.0  Package Creation  17-MAR-1993  
!             1.1  adapted for MOS   20-AUG-1993   
!             1.2  adapted for SPOL  22-JUL-1994   
!
! NOTE: This program assumes that 
!       1) the names of the extracted frames are
!          listed in col :EX_SC of table {ex_tab}. 
!       2) there is only one LINFIT table for all 
!          extracted frames from one science frame
!-------------------------------------------------------------------------------
! Parameters
!---------------------------------------------------
! ... for sorting part
!---------------------------------------------------
DEFINE/PARAM P1 {SPOL_TAB}EX TABLE   "Enter input table:"
DEFINE/PARAM P2 {SC_EX} CHAR "name of column with 1-dim. SC frames"
!---------------------------------------------------
! ... for rebinning part
!-------------------------------------------------------------------------------
DEFINE/PARAM  P3 {REBSTRT},{REBEND},{REBSTP} N "Start,End,Step in wavelength:"
DEFINE/PARAM  P4  {REBMET}        CHA "Rebin method (SPLINE/QUADRATIC,LINEAR) :"
DEFINE/PARAM P5 ? CHAR "First try/All frames (Def. F):"
!-------------------------------------------------------------------------------
! Local keys ...
!---------------------------------------------------
! ... for sorting part
!---------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL TRY/C/1/1 F
WRITE/KEY TMP/C/1/60 " " ALL
!---------------------------------------------------
! ... for rebinning part
!---------------------------------------------------
DEFINE/LOCAL FITD/I/1/1 0
!-------------------------------------------------------------------------------
WRITE/KEYW INPUTR/R/1/3 {P3}
!
DEFINE/MAXPAR 6
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P5(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P5}
ENDIF 
!------------------------------------------------------------------------------
! get numbers for rebinning method
!------------------------------------------------------------------------------
INPUTI(1) = -1
IF P4(1:1) .EQ. "L"  WRITE/KEYW INPUTI/I/1/1   0    ! Method LINEAR
IF P4(1:1) .EQ. "Q"  WRITE/KEYW INPUTI/I/1/1   1    ! Method QUADRATIC
IF P4(1:1) .EQ. "S"  WRITE/KEYW INPUTI/I/1/1   2    ! Method SPLINE
!
IF INPUTI(1) .LT. 0  THEN
   WRITE/OUT "Rebin: Unknown method {P4}"
   RETURN/EXIT
ENDIF
!
!-------------------------------------------------------------------------------
! Get number of rows in ex_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Initialize column to hold names of rebinned frames
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/9 {SC_REB1D}
RUN STD_EXE:spolcolini
!
!-------------------------------------------------------------------------------
! Get tables with dispersion coefficients and science frames
!-------------------------------------------------------------------------------
DO J = 1 N_SC
!---------------------------------------------------
! Get LINFIT table for science frame
!---------------------------------------------------
  DO I = SC_STRT({J}) SC_END({J})
    COPY/TK {P1} {LINFIT} @{I} TMP/C/1/60
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get 1-dim. extracted frames
!---------------------------------------------------
  DO I = SC_STRT({J}) SC_END({J})
    COPY/TK {P1} {P2} @{I} TMP/C/1/60
   IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_A {TMP}
!---------------------------------------------------
! Perform rebinning for actual frame
!---------------------------------------------------
      COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
      WRITE/KEY OUT_A {IN_A(1:{OUTPUTI(1)})}{SUF_R1D}
!     WRITE/KEYW  INPUTC       {REBMET}
      COPY/KD INPUTR/R/1/3 {IN_B} REBPAR/R/1/3
!---------------------------------------------------
! do polynomial regression for all coefficients 
! (to be done, Otmar Stahl)
!---------------------------------------------------
      COPY/DK    {IN_B} LNCOE FITD
      RUN STD_EXE:spolrebin1d
!      WRITE/OUT  "Calibration Performed."
!---------------------------------------------------
! Continue sorting and write name of output frame to 
! column :SC_REB of spol_tab
!---------------------------------------------------
      WRITE/TAB {P1} {SC_REB1D} @{I} {OUT_A}
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
      IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
        GOTO end
      ENDIF
    ENDIF
  ENDDO
!---------------------------------------------------
! End of DO loop over spol_table
!---------------------------------------------------
ENDDO  
!-------------------------------------------------------------------------------
END:
