! @(#)rectify.prg	1.3 (ESO-IPG) 2/11/94 13:19:57
! +++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! SPOL PROCEDURE : RECTIFY.PRG
!
! .PURPOSE
!
! execute the command :
! RECTIFY/SPOL spol_tab image slit-table fit-table output method scan-pos
! 
!-------------------------------------------------------------------------------
CROSSREF spol_tab sc SLIT_TAB WINTAB METHOD IPAR RPAR
!-------------------------------------------------------------------------------
! Parameters
DEFINE/PARAM P1 {SPOL_TAB} TABLE   "Enter input table:"
DEFINE/PARAM P2 {SC} CHAR  "Enter column with input frames"
DEFINE/PARAM P3 {SLIT_TAB} CHAR   "Enter column with slitlet tables: "
DEFINE/PARAM P4 ? TABLE   "Input table (FIT): "
DEFINE/PARAM P5 ? CHAR    "Enter column for output frames: "
DEFINE/PARAM P6 LI CHAR   "Interpolation method: "
DEFINE/PARAM P7 ?   ?     "Scan_pos: " 
!
!
!-------------------------------------------------------------------------------
! Local keys ...
!---------------------------------------------------
! ... for sorting part
!---------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL SCAN/D/1/1 0.
WRITE/KEY TMP/C/1/80 " " ALL
WRITE/KEY IN_B/C/1/80 " " ALL
!
DEFINE/MAXPAR 7
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF 
!-------------------------------------------------------------------------------
! Initialize column to hold names of rectified frames
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/8 {P5}
RUN STD_EXE:spolcolini
!
!-------------------------------------------------------------------------------
! Initialize parameters
!-------------------------------------------------------------------------------
WRITE/KEY IN_C/C/1/80 {P4}
WRITE/KEY INPUTC      {P6}
WRITE/KEY INPUTD      {P7}
!
SCAN =  {INPUTD(1)}
!-------------------------------------------------------------------------------
! Get tables with slitlets and input frames
!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
! Same flat for all frames 
! == one slitlet table for all frames
!---------------------------------------------------
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
!---------------------------------------------------
! Get slitlet table for all science frames
!---------------------------------------------------
  DO I = 1 {NUMROW}
    COPY/TK {P1} {P3} @{I} TMP/C/1/80
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B/C/1/80 {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
  DO J = 1 {N_SC}
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} IN_A/C/1/80
      IF IN_A(1:1) .ne. " " THEN
!---------------------------------------------------
! Generate name of output frame
!---------------------------------------------------
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEYW OUT_A {PRE_REC}{IN_A(1:{OUTPUTI(1)})}.bdf
        RUN STD_EXE:RECTIFY
        WRITE/OUT  "Rectification Performed."
        WRITE/OUT "outframe: {OUT_A}"
        WRITE/OUT " "
!        WRITE/KEY IN_B/C/1/80 " " ALL
!---------------------------------------------------
! Continue sorting and write name of output frame to 
! column {P5} of spol_tab
!---------------------------------------------------
        WRITE/TABLE {P1} {P5} @{I} {OUT_A}
      GOTO next
      ENDIF
!---------------------------------------------------
! End of DO loop over one science frame
!---------------------------------------------------
    ENDDO
!-------------------------------------------------------------------------------
!---------------------------------------------------
! End of DO loop over SCIENCE frame(s)
!---------------------------------------------------
next:
  ENDDO
!-------------------------------------------------------------------------------
! Individual flat for each frame == one slitlet table for each SC frame
!---------------------------------------------------
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
!---------------------------------------------------
! Get slitlet table for each science frame
!---------------------------------------------------
  DO J = 1 {N_SC}  
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {SLIT_TAB} @{I} TMP/C/1/80
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_C/C/1/80 {TMP}
      ENDIF
    ENDDO
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} IN_A/C/1/80
      IF IN_A(1:1) .ne. " " THEN
!---------------------------------------------------
! Perform rectification for actual frame
!---------------------------------------------------
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")
        WRITE/KEYW OUT_A {PRE_REB}{IN_A(1:{OUTPUTI(1)})}.bdf
        RUN STD_EXE:RECTIFY
        WRITE/OUT  "Rectification Performed."
        WRITE/OUT "outframe: {OUT_A}"
        WRITE/OUT " "
!        WRITE/KEY IN_B/C/1/80 " " ALL
!---------------------------------------------------
! Continue sorting and write name of output frame to 
! column {P5} of spol_tab
!---------------------------------------------------
        WRITE/TABLE {P1} {P5} @{I} {OUT_A}
      GOTO next
      ENDIF
!---------------------------------------------------
! End of DO loop over one science frame
!---------------------------------------------------
    ENDDO  
!---------------------------------------------------
! End of DO loop over SC frames 
!-------------------------------------------------------------------------------
next:
  ENDDO  
ENDIF
