! @(#)spolshow.prg	1.2 (ESO-IPG) 2/11/94 13:20:01
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1991 European Southern Observatory
!.IDENT       spolshow.prg
!.AUTHOR      Pascal Ballester,  ESO - Garching
!.KEYWORDS    Spectropolarimetry
!.PURPOSE     Display SPOL session parameters
!.VERSION     1.0    Creation    21-AUG-1991  PB
!             1.1    Adaption for SPOL 26-JUL-1994 SM
!
!-------------------------------------------------------
!
DEFINE/PARAM P1 A CHAR "which part?"
SET/FORMAT I1  F12.5  
ECHO/OFF
SHOW/SESS  "****************  SPOL Parameters  *******************"
IF P1(1:1) .EQ. "C"  GOTO CALIB
IF P1(1:1) .EQ. "D"  GOTO WIND
IF P1(1:1) .EQ. "E"  GOTO EXTR
IF P1(1:1) .EQ. "F"  GOTO FF
IF P1(1:1) .EQ. "G"  GOTO GEN
IF P1(1:1) .EQ. "P"  GOTO POL
IF P1(1:1) .EQ. "R"  GOTO REBI
IF P1(1:1) .EQ. "S"  GOTO SKY
IF P1(1:1) .EQ. "W"  GOTO WLC
SESSLINE = 0 ! Initialize the line counter
GEN:
SHOW/SESS  "   "
SHOW/SESS  "General parameters   "
SHOW/SESS  "   "
SHOW/SESS  "Number of pixels (NPIX):                           {NPIX}   "
SHOW/SESS  "Step size (STEP):                                  {STEP} "
SHOW/SESS  "Start values (START):                              {START} "
SHOW/SESS  "CCD read-out-noise and conversion factor (CCDPAR): {CCDPAR} "
SHOW/SESS  "Table with all frames (SPOL_TAB):                  {SPOL_TAB}"
SHOW/SESS  "Total number of science frames (N_SC):             {N_SC}"
SHOW/SESS  "Column with raw science frames (SC):               {SC}"
SHOW/SESS  "Prefix for rectified frames (PRE_REC):             {PRE_REC}"
IF P1(1:1) .NE. "A"  RETURN
SHOW/SESS  "-------------------------------------------------------------------"
FF:
SHOW/SESS "Flat field related: LOCATE/SPOL-NORMAL/SPOL-FLAT/SPOL-PLOT/LOCATE"
SHOW/SESS  "   "
SHOW/SESS  "Column with individual flat fields (FF):                {FF}" 
SHOW/SESS  "Column with averaged flat-fields (FF_OUT):              {FF_OUT}"
SHOW/SESS  "Prefix for veraged flat-field frames (PRE_FF):          {PRE_FF}"
SHOW/SESS  "Detec. thres. (FLATLIM):                                {FLATLIM} "
SHOW/SESS  "Same flat/Individual flats for slitl loaction (FF_LOC): {FF_LOC}"
SHOW/SESS  "Number of slitlets (NSLIT):                             {NSLIT}"
SHOW/SESS  "Column with slitlet tables (SLIT_TAB):                  {SLIT_TAB}"
SHOW/SESS  "Column with normalized flat-fields (FF_NORM):           {FF_NORM}"
SHOW/SESS  "Prefix for normalized flat-fields (PRE_NORM):           {PRE_NORM}"
SHOW/SESS  "Method for smoothing (NORMMET):                         {NORMMET}"
SHOW/SESS  "Order of fit/window width (FFORD):                      {FFORD}"
SHOW/SESS  "Column with flat-fielded science frames (SC_FLAT):      {SC_FLAT}"
SHOW/SESS  "Prefix for flat-fielded frames (PRE_FFSC):              {PRE_FFSC}"
IF P1(1:1) .NE. "A"  RETURN
SHOW/SESS  "-------------------------------------------------------------------"
WLC:
SHOW/SESS  "Line-search related: SEARCH/SPOL - LINPLOT/SPOL"
SHOW/SESS  "                            "
SHOW/SESS  "Calibration frame (WLC):           {WLC}" 
SHOW/SESS  "Column with WLC images (CALIB):    {CALIB}" 
SHOW/SESS  "Center method (CENTMET):           {CENTMET}" 
SHOW/SESS  "Thres. and window (SEAPAR):        {SEAPAR}" 
SHOW/SESS  "Step and Binning in Y (YBIN):      {YBIN}" 
SHOW/SESS  "Column with line tables (LINPOS):  {LINPOS}" 
SHOW/SESS  "                            "
SHOW/SESS  "Line-identification related: IDENTIFY/SPOL"
SHOW/SESS  "                            "
SHOW/SESS  "Line identifications (LID):                            {LID}"
SHOW/SESS  "Pixel positions of ident. lines (XPOS):                {XPOS}"
SHOW/SESS  "CCD row in which the lines are identified (YSTART):    {YSTART}"
SHOW/SESS  "Tolerance for interact. line identification (TOLWIND): {TOLWIND}"
IF P1(1:1) .NE. "A"  RETURN
SHOW/SESS  "-------------------------------------------------------------------"
CALIB:
SHOW/SESS  "Line calibration related: CALIBRATE/SPOL - RESPLOT/SPOL"
SHOW/SESS  "                            "
SHOW/SESS  "Column with fit tables (LINFIT):                     {LINFIT}"
SHOW/SESS  "Suffix for fit tables (SUF_FIT):                     {SUF_FIT}"
SHOW/SESS  "Wavelength calibration method (WLCMET):              {WLCMET}"
SHOW/SESS  "Polynomials for dispersion relation (POLTYP):        {POLTYP}"
SHOW/SESS  "Order of fit for dispersion relation (WLCORD(1)):    {WLCORD(1)}"
SHOW/SESS  "Minimum/maximum number of fit iterations (WLCNITER): {WLCNITER}"
SHOW/SESS  "Central wavelength (WCENTER):                        {WCENTER}"
SHOW/SESS  "Average dispersion (A/pix) (AVDISP):                 {AVDISP}"
SHOW/SESS  "Table with wavelength catalog (LINECAT):             {LINECAT}"
SHOW/SESS  "Grism number (GRISM):                                {GRISM}"
SHOW/SESS  "Shift tol. for autom. line ident. mode IDENT (SHIFTTOL): {SHIFTTOL}"
SHOW/SESS  "Tolerance for automatic line identification (TOL):   {TOL}"
SHOW/SESS  "Plot flag for line residuals (PLOTC):                {PLOTC}"
SHOW/SESS  "Flag for dispersion relations for slitlets (CAL):    {CAL} "
SHOW/SESS  "Matching parameter (0 to 0.5) (ALPHA):               {ALPHA}"
SHOW/SESS  "Maximum Deviation (MAXDEV):                          {MAXDEV}"
SHOW/SESS  "Slitlet counter (ISLIT):                             {ISLIT}"
IF P1(1:1) .NE. "A"  RETURN
SHOW/SESS  "-------------------------------------------------------------------"
REBI:
SHOW/SESS  "Rebin related: REBIN/SPOL - REB1D/SPOL              "
SHOW/SESS  "                            "
SHOW/SESS  "Column for two-dimensionally rebinned frames (SC_REB):  {SC_REB} "
SHOW/SESS  "Prefix for two-dimensionally rebinned frames (PRE_REB): {PRE_REB} "
SHOW/SESS  "Method of interpolation along dispersion axis (REBMET): {REBMET}"
SHOW/SESS  "Order of interpolation along y-axis (WLCORD(2)):        {WLCORD(2)}"
SHOW/SESS "Start,Step,End (REBSTRT,REBSTP,REBEND):  {REBSTRT},{REBSTP},{REBEND}"
SHOW/SESS  "Column for one-dimensionally rebinned frames (SC_REB1D): {SC_REB1D}"
SHOW/SESS  "Suffix for one-dimensionally rebinned frames (SUF_R1D):  {SUF_R1D} "
IF P1(1:1) .NE. "A"  RETURN
SHOW/SESS  "-------------------------------------------------------------------"
WIND:
SHOW/SESS  "Object and sky search related: DEFINE/SPOL - DEFPLOT/SPOL "
SHOW/SESS  "                            "
SHOW/SESS "Column with window tables (WINDOWS):                      {WINDOWS}"
SHOW/SESS "Suffix for window tables (SUF_WIN):                       {SUF_WIN}" 
SHOW/SESS "Center for scan in world coord. (SCAN_POS):               {SCAN_POS}"
SHOW/SESS "Detection threshold for objects (<0: relative) (THRESH):  {THRESH}"
SHOW/SESS "Detection window for objects (WIND):                      {WIND}"
SHOW/SESS "Binning in X for object search  (XBIN):                   {XBIN}"
SHOW/SESS "Fraction of central intensity for object limit (INT_LIM): {INT_LIM}"
SHOW/SESS "Minimum distance between sky and object (MIN_DIST):       {MIN_DIST}"
SHOW/SESS "Minimum number of rows for sky (MIN_SKY):                 {MIN_SKY}"
IF P1(1:1) .NE. "A"  RETURN
SHOW/SESS  "-------------------------------------------------------------------"
SKY:
SHOW/SESS  "Sky-fit and -subtraction related: SKYFIT/SPOL - SUBSKY/SPOL"
SHOW/SESS  "                            "
SHOW/SESS  "Column for sky frames (SKY):                {SKY}"
SHOW/SESS  "Prefix for sky frames (PRE_SKY):            {PRE_SKY}"
SHOW/SESS  "Parameters (SKYPAR):                        {SKYPAR}"
SHOW/SESS  "Method for sky fit (SKYMET):                {SKYMET}"
SHOW/SESS  "Column for sky-subtracted frames (SC_SKY):  {SC_SKY}"
SHOW/SESS  "Prefix for sky-subtracted frames (PRE_SUB): {PRE_SUB}"
IF P1(1:1) .NE. "A"  RETURN
SHOW/SESS  "-------------------------------------------------------------------"
EXTR:
SHOW/SESS  "Extraction related: EXTRACT/SPOL "
SHOW/SESS  "                            "
SHOW/SESS  "Column with extracted object frames (SC_EX): {SC_EX}"
SHOW/SESS  "Order of fit, No. Iterations (EXTPAR) :      {EXTPAR}"
SHOW/SESS  "Rejection threshold (REJTHRES):              {REJTHRES} sigma"
SHOW/SESS  "Read-out-noise, conv. factor (CCDPAR):       {CCDPAR}"
SHOW/SESS  "                            "
IF P1(1:1) .NE. "A"  RETURN
SHOW/SESS  "-------------------------------------------------------------------"
POL:
SHOW/SESS  "Polarimetry related:  "
SHOW/SESS  "                            "
SHOW/SESS  "Zero-angle of retarder plate (ZERO_ANG): {ZERO_ANG}"
SET/FORMAT
RETURN
