! @(#)spolsky.prg	1.3 (ESO-IPG) 2/11/94 13:20:01
! ++++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! SPOL PROCEDURE : SPOLSKY.PRG
!
! .PURPOSE
!
! execute the command :
!  FITSKY/SPOL SPOL_TAB SC_REB SLIT_TAB WINDOWS SKY SKYPAR mode try
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++
!
CROSSREF  SPOL_TAB SC_REB SLIT_TAB WINDOWS SKY SKYPAR mode try
!
DEFINE/PARAM P1 {SPOL_TAB} IMAGE  "Enter SPOL table:"
DEFINE/PARAM P2 {SC_REB}   CHAR   "Enter column with input images:"
DEFINE/PARAM P3 {SLIT_TAB} CHAR   "Enter column with slitlet tables:"
DEFINE/PARAM P4 {WINDOWS}  CHAR   "Enter column with windows tables:"
DEFINE/PARAM P5 {SKY}      CHAR   "Enter column for output frames:"
DEFINE/PARAM P6 {SKYPAR}   NUMBER "Enter Sky parameters:"
DEFINE/PARAM P7 {SKYMET}   CHAR   "Method:"
DEFINE/PARAM P8 ?          CHAR   "First try or All frames? (def: F):"
!
!-------------------------------------------------------------------------------
! Local keys  for sorting
!-------------------------------------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
WRITE/KEY TMP/C/1/80 " " ALL
!-------------------------------------------------------------------------------
! Initialize sky parameters
!-------------------------------------------------------------------------------
WRITE/KEYW INPUTI {P6}
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P8(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P8}
ENDIF
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF
!-------------------------------------------------------------------------------
! Initialize column to hold names of sky frames
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/8 {P5}
RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
! Same flat for all frames == one slitlet table for all frames
!---------------------------------------------------
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
!---------------------------------------------------
! Get slitlet table for all science frames
!---------------------------------------------------
  DO I = 1 {NUMROW}
    COPY/TK {P1} {P3} @{I} TMP/C/1/20
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get windows tables 
!---------------------------------------------------
  DO J = 1 {N_SC}
    IF P7(1:3) .eq. "NOW" THEN
      WRITE/OUT "No windows"
      COP/TABLE {IN_B} middummz
      NAME/COLUMN middummz :SLIT :SKY_SLIT
      NAME/COLUMN middummz :YSTART :SKY_STRT
      NAME/COLUMN middummz :YEND   :SKY_END
      WRITE/KEYW IN_C/C/1/80 middummz
    ELSE	
      DO I = SC_STRT({J}) SC_END({J})
        COPY/TK {P1} {P4} @{I} TMP/C/1/80
        IF TMP(1:1) .ne. " " THEN
          WRITE/KEY IN_C/C/1/80 {TMP}
        ENDIF
      ENDDO
    ENDIF
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} IN_A/C/1/80
      IF IN_A(1:1) .ne. " " THEN
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEY OUT_A {PRE_SKY}{IN_A(1:{OUTPUTI(1)})}.bdf
        RUN STD_EXE:MOSSKY
        WRITE/TAB {P1} {P5} @{I} {OUT_A}
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f" THEN
          GOTO end
        ENDIF
      GOTO next
      ENDIF
    ENDDO
next:
  ENDDO
!-------------------------------------------------------------------------------
! Individual flat for each frame == one slitlet
! table for each SC frame
!---------------------------------------------------
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
!---------------------------------------------------
! Get slitlet table for each science frame
!---------------------------------------------------
  DO J = 1 {N_SC}
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {SLIT_TAB} @{I} TMP/C/1/20
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_B {TMP}
      ENDIF
    ENDDO
!---------------------------------------------------
! Get windows tables 
!---------------------------------------------------
    IF P7(1:3) .eq. "NOW" THEN
      WRITE/OUT "No windows"
      COP/TABLE {IN_B} middummz
      NAME/COLUMN middummz :SLIT :SKY_SLIT
      NAME/COLUMN middummz :YSTART :SKY_STRT
      NAME/COLUMN middummz :YEND   :SKY_END
      WRITE/KEYW IN_C/C/1/80 middummz
    ELSE	
      DO I = SC_STRT({J}) SC_END({J})
        COPY/TK {P1} {P4} @{I} TMP/C/1/80
        IF TMP(1:1) .ne. " " THEN
          WRITE/KEY IN_C/C/1/80 {TMP}
        ENDIF
      ENDDO
    ENDIF
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
     DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} IN_A/C/1/80
      IF IN_A(1:1) .ne. " " THEN
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEY OUT_A {PRE_SKY}{IN_A(1:{OUTPUTI(1)})}.bdf
        RUN STD_EXE:MOSSKY
        WRITE/TAB {P1} {P5} @{I} {OUT_A}
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f" THEN
          GOTO end
        ENDIF
      GOTO next
      ENDIF
    ENDDO
next:
  ENDDO
ENDIF
end:
