! @(#)spolslin.prg	1.7 (ESO-IPG) 2/17/94 17:28:46
! +++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! SPOL PROCEDURE : SPOLSLIN.PRG
!
! .PURPOSE
!
! execute the command :
! SEARCH/SPOL SPOL_TAB SEAPAR YBIN METHOD TABLE LINPOS  
!
! -------------------------------------------------
!
! CROSSRE SPOL_TAB SEAPAR YBIN METHOD TABLE LINPOS F
!
DEFINE/PARAM P1 {SPOL_TAB}      TABLE   "Enter input table:"
DEFINE/PARAM P2 {SEAPAR},180   NUMBER  "Threshold, window:"
DEFINE/PARAM P3 {YBIN}     NUMBER  "Step, binning in Y:"
DEFINE/PARAM P4 {CENTMET}  ?       "Centering method"
DEFINE/PARAM P5 ? CHAR "First try/All frames (Def. F):"
WRITE/KEYW INPUTR {P2},0.0
WRITE/KEYW INPUTC {P4}

!
DEFINE/MAXPAR 5
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------------------------------------
DEFI/LOCA STRLEN/I/1/1 60

DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
WRITE/KEY TMP/C/1/{STRLEN} " " ALL
WRITE/KEY IN_B " " ALL
!
!SET/SPOL seapar={P2} ybin={P3} centmet={P4} 
!
!
WRITE/KEYW INPUTI {P3}
WRITE/KEYW INPUTR {P2}
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P5(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P5}
ENDIF 
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF 
!-------------------------------------------------------------------------------
! Initialize column to hold names of linpos tables
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/{STRLEN} {LINPOS}  
RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
! Same flat for all frames == one slitlet table for all frames
!---------------------------------------------------
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
!---------------------------------------------------
! Get slitlet table for all science frames
!---------------------------------------------------
  DO I = 1 {NUMROW}
    COPY/TK {P1} {SLIT_TAB} @{I} TMP/C/1/{STRLEN}
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get WLC frame(s) for science frames
!---------------------------------------------------
  DO I = 1 {NUMROW}
    COPY/TK {P1} {CALIB} @{I} IN_A/C/1/{STRLEN}
    IF IN_A(1:1) .ne. " " THEN
!---------------------------------------------------
! get size of WLC frame used for LINPOS table
!---------------------------------------------------
      NPIX(1) = {{IN_A},NPIX(1)}
      IF {{IN_A},NAXIS} .GT. 1 THEN
        NPIX(2) = {{IN_A},NPIX(2)}
      ENDIF
!---------------------------------------------------
! search calibration lines and write name of 
! resulting table to column {LINPOS} of spol_tab
!---------------------------------------------------
      WRITE/KEYW INPUTC {P4}
      COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
      WRITE/KEY OUT_A {IN_A(1:{OUTPUTI(1)})}.tbl
      RUN STD_EXE:MOSSLIN
      COPY/KD IN_A/C/1/{STRLEN} {OUT_A} WLC/C/1/{STRLEN}
      WRITE/TAB {P1} {LINPOS} @{I} {OUT_A}
!---------------------------------------------------
! Try only one WLC frame for first try
!---------------------------------------------------
      IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
        GOTO end    
      ENDIF
    ENDIF
  ENDDO
!---------------------------------------------------
! end of loop over WLC frames 
!-------------------------------------------------------------------------------
! Individual flat for each frame == one slitlet 
! table for each SC frame
!---------------------------------------------------
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
!---------------------------------------------------
! Get slitlet table for each science frame
!---------------------------------------------------
  DO J = 1 {N_SC}  
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {SLIT_TAB} @{I} TMP/C/1/{STRLEN}
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_B {TMP}
      ENDIF
    ENDDO
!---------------------------------------------------
! Get WLC frame(s) for science frame
!---------------------------------------------------
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {CALIB} @{I} IN_A/C/1/{STRLEN}
      IF IN_A(1:1) .ne. " " THEN
!---------------------------------------------------
! get size of WLC frame used for LINPOS table
!---------------------------------------------------
        NPIX(1) = {{IN_A},NPIX(1)}
        IF {{IN_A},NAXIS} .GT. 1 THEN
          NPIX(2) = {{IN_A},NPIX(2)}
        ENDIF
!---------------------------------------------------
! search calibration lines and write name of 
! resulting table to column {LINPOS} of spol_tab
!---------------------------------------------------
        WRITE/KEYW INPUTC {P4}
        COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
        WRITE/KEY OUT_A {IN_A(1:{OUTPUTI(1)})}.tbl
        RUN STD_EXE:MOSSLIN
        COPY/KD IN_A/C/1/{STRLEN} {OUT_A} WLC/C/1/{STRLEN}
        WRITE/TAB {P1} {LINPOS} @{I} {OUT_A}
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
!---------------------------------------------------
! Try only one WLC frame for first try
!---------------------------------------------------
          GOTO end    
        ENDIF
      ENDIF
!---------------------------------------------------
! end of loop over WLC frames for each SC frames
!---------------------------------------------------
    ENDDO  
!---------------------------------------------------
! end of loop over SC frames
!---------------------------------------------------
  ENDDO  
ENDIF
END:
