! +++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! SPOL PROCEDURE : SPOLSTOKES.PRG
!
! .PURPOSE
! .AUTHORS	Otmar Stahl, Thomas Szeifert
!
! execute the command :
! STOKES/SPOL SPOL_TAB MODE
! 
CROSSREF SPOL_TAB MODE 
!
define/local num/i/1/1 0
define/local n/i/1/1 0
define/local i/i/1/2 0,0
define/local nparts/i/1/1 0
define/local j/i/1/1 0
define/local name/c/1/60 " " all
define/local namcat/c/1/60 " " all
define/local mode/c/1/4 " " all
!
define/param p1 {spol_tab} ? 	"Table with extracted spectra: "
define/param p2 LIN  	char	"Linear or Circular pol.:      "
define/param p3 {N_SC} 	?	"Number of Retarder Positions: "
define/param p4 {ZERO_ANG} ?    "Zero angle of retarder plate::"        
define/param p5 +1         ?    "Direction of rotation:        "
DEFINE/PARAM P6 1N    CHAR      "rebin mode: 1N,1E,2N or 2E    "
IF "{P6(1:2)}" .EQ. "2N" THEN
   DEFINE/PARAM P7 {CCDPAR} N "CCD-parameter RON,gain             "
   DEFINE/LOCAL CCDRP/R/1/2 {P7}	
ENDIF

write/key inputi {p3},{p5}
write/key inputr {p4}
DEFI/LOCA REBMODE/C/1/2 {p6}


IF "{P6(1:2)}" .EQ. "1N" THEN
	COPY/TT {P1} :SC_EX :SC_REB1D
ENDIF
IF "{P6(1:2)}" .EQ. "2N" THEN
	WRITE/OUT "mode  2N  is not yet supported"
	RETURN
ENDIF

SORT/TABL {P1} :RET_ANG,:RAY_TYP(-)

j = m$index(p1,".")-1

if  {j} .gt. 0 then
   write/key name/c/1/{j} {p1(1:{j})}
else
   write/key name/c/1/60 {p1(1:60)}
endif

num = {{name}.tbl,tblcontr(4)}

mode =  m$upper("{p2(1:3)}")
if "{mode}" .eq. "LIN" then
   n = {P3} * 2
else
   n = 4
endif

nparts = {num}/{n}

do j = 1 {nparts}
   i(1)  = ({j}-1)*{n}+1     
   i(2)  = {j}*{n}
   sele/tab {name} seq.ge.{i(1)}.and.seq.le.{i(2)}

   write/key in_a   {name}
   write/key inputc {mode}

   run STD_EXE:SPOLSTOKES.EXE

   set/format i1
   write/key namcat {name}{j}
   set/format

enddo














