! ++++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! SPOL PROCEDURE : SPOLSUBSKY.PRG
!
! .PURPOSE
!
! execute the command :
!  SUBSKY/SPOL SPOL_TAB SC_REB SKY SC_SKY try
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++
!
CROSSREF  SPOL_TAB SC_REB SKY SC_SKY try
!
DEFINE/PARAM P1 {SPOL_TAB} IMAGE  "Enter SPOL table:"
DEFINE/PARAM P2 {SC_REB}   CHAR   "Enter column with input images:"
DEFINE/PARAM P3 {SKY}      CHAR   "Enter column with sky frames:"
DEFINE/PARAM P4 {SC_SKY}   CHAR   "Enter column for output frames:"
DEFINE/PARAM P5 ?          CHAR   "First try or All frames? (def: F):"
!
!-------------------------------------------------------------------------------
! Local keys  for sorting
!-------------------------------------------------------------------------------
DEFI/LOCA STRLEN/I/1/1 60

DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
WRITE/KEY TMP/C/1/{STRLEN} " " ALL
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P5(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P5}
ENDIF
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF
!-------------------------------------------------------------------------------
! Initialize column to hold names of sky subtracted frames
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/{STRLEN} {P4}
RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
!---------------------------------------------------
! Get sky frame for each science frame
!---------------------------------------------------
DO J = 1 {N_SC}
  DO I = SC_STRT({J}) SC_END({J})
    COPY/TK {P1} {P3} @{I} TMP/C/1/{STRLEN}
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
  DO I = SC_STRT({J}) SC_END({J})
    COPY/TK {P1} {P2} @{I} IN_A/C/1/{STRLEN}
    IF IN_A(1:1) .ne. " " THEN
      COMP/KEY OUTPUTI = M$INDEXB(IN_A,".")-1
      WRITE/KEY OUT_A {PRE_SUB}{IN_A(1:{OUTPUTI(1)})}.bdf
      WRITE/TAB {P1} {P4} @{I} {OUT_A}
      COMP/IMAGE {OUT_A} = {IN_A}-{IN_B}
      write/out "{OUT_A} = {IN_A}-{IN_B}"
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
      IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f" THEN
        GOTO end
      ENDIF
    GOTO next
    ENDIF
  ENDDO
next:
ENDDO
end:






