! @(#)spoloffset.prg      1.3 (ESO-IPG) 2/11/94 13:19:59
! +++++++++++++++++++++++++++++++++++++++++++++++++
!
! .IDENTIFICATION
!
! SPOL PROCEDURE : SPOLOFFSET.PRG
!
! .PURPOSE
!
! execute the command :
! OFFSET/SPOL SPOL_TAB SLIT_TAB CALIB try
!
! -------------------------------------------------
!
! CROSSREF SPOL_TAB SLIT_TAB CALIB try
!
DEFINE/PARAM P1 {SPOL_TAB} TAB  "Table with all frames:"
DEFINE/PARAM P2 {SLIT_TAB} CHA  "column with slit tables:"
DEFINE/PARAM P3 {CALIB}      CHA  "column with WLC frames:"
DEFINE/PARAM P4 ?          CHA  "First try or All frames? (def: F):"
!-------------------------------------------------------------------------------
! Local keys...
!----------------------------------------------
! ...  for sorting
!----------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL I/I/1/1 0.
DEFINE/LOCAL J/I/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
DEFINE/LOCAL INTAB/C/1/60 " " ALL
DEFINE/LOCAL INBDF/C/1/60 " " ALL
WRITE/KEY TMP/C/1/60 " " ALL
!----------------------------------------------
! ...  for comparing
!-------------------------------------------------------------------------------
DEFINE/LOCAL SLIT/I/1/1 0
DEFINE/LOCAL PREV/I/1/1 0
DEFINE/LOCAL TOLERANC/R/1/1  0.
DEFINE/LOCAL OFFSET/R/1/1 0.
DEFINE/LOCAL PIXEL/I/1/2  0,0
DEFINE/LOCAL SEAP/R/1/2 {SEAPAR}
!-------------------------------------------------------------------------------
! Initialize environment
!-------------------------------------------------------------------------------
SET/FORMAT I1  F6.2
SET/MIDAS output=LOGONLY
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P4(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P4}
ENDIF
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF
!-------------------------------------------------------------------------------
! Same flat for all frames == one slitlet table for all frames
!---------------------------------------------------
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
!---------------------------------------------------
! Get slitlet table for all science frames
!---------------------------------------------------
  DO I = 1 {NUMROW}
    COPY/TK {P1} {P2} @{I} TMP/C/1/20
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY INTAB {TMP}
    ENDIF
  ENDDO
!---------------------------------------------------
! Get WLC frame
!---------------------------------------------------
  DO J = 1 {N_SC}
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P3} @{I} TMP/C/1/60
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY INBDF {TMP}
        SET/MIDAS OUTPUT=YES
        WRITE/OUT "slit_tab:  {INTAB}"
        WRITE/OUT "wlc frame: {INBDF}"
        SET/MIDAS OUTPUT=LOGONLY
        GOTO offset
OFFS:
!---------------------------------------------------
! Try only one WLC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f" THEN
          GOTO end
        ENDIF
      ENDIF
    ENDDO
  ENDDO 
!-------------------------------------------------------------------------------
! Individual flat for each frame == one slitlet
! table for each SC frame
!---------------------------------------------------
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
!---------------------------------------------------
! Get slitlet table for each science frame
!---------------------------------------------------
  DO J = 1 {N_SC}
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P2} @{I} TMP/C/1/20
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY INTAB {TMP}
      ENDIF
    ENDDO
!---------------------------------------------------
! Get WLC frame
!---------------------------------------------------
    DO I = SC_STRT({J}) SC_END({J})
      COPY/TK {P1} {P3} @{I} TMP/C/1/60
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY INBDF {TMP}
        SET/MIDAS OUTPUT=YES
        WRITE/OUT "slit_tab:  {INTAB}"
        WRITE/OUT "wlc frame: {INBDF}"
        SET/MIDAS OUTPUT=LOGONLY
        GOTO offset
OFFI:
!---------------------------------------------------
! Try only one WLC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f" THEN
          GOTO end
        ENDIF
      ENDIF
    ENDDO
  ENDDO
ENDIF
goto end
offset:
!SET/MIDAS OUTPUT=LOGONLY
SET/MIDAS OUTPUT=YES
PIXEL(1) = {{INTAB},:ystart,@1}
PIXEL(2) = {{INTAB},:yend,@1}

AVERAGE/ROW  &i = {INBDF} @{PIXEL(1)},@{PIXEL(2)}
SEARCH/LINE  &i  {SEAP(2)},{SEAP(1)}  &a  {centmet} EMISS
WRITE/TABLE   {INTAB}  :XOFFSET   @1   0.

SET/MIDAS OUTPUT=YES
WRITE/OUT "Slit Nr. 1. Offset = 0."
TOLERANC  =  2*TOLWIND
DO SLIT = 2 {NSLIT}
   SET/MIDAS OUTPUT=LOGONLY
   PIXEL(1) = {{INTAB},:ystart,@{slit}}
   PIXEL(2) = {{INTAB},:yend,@{slit}}
read/key pixel
!   AVERAGE/ROW  &i = {INBDF} @{PIXEL(1)},@{PIXEL(2)}
   AVERAGE/ROW  &i = {INBDF} {PIXEL(1)},{PIXEL(2)}
   SEARCH/LINE   &i  {SEAP(2)},{SEAP(1)}  &b  {centmet} EMISS
   CORRELATE/LINE  &a  &b   ?   0.,0.25,{NPIX(1)},0.5  X,+,+  
   FIND/MINMAX  &x
   OFFSET = (OUTPUTI(3)-1)*{middummx.bdf,STEP(1)} + {middummx.bdf,START(1)}
   {INTAB},:XOFFSET,@{SLIT} = OFFSET 
   SET/MIDAS OUTPUT=YES
   WRITE/OUT "Slit Nr. {slit}. Offset = {offset}"
ENDDO
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
  GOTO OFFS
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
  GOTO OFFI
ENDIF
end:
