! @(#)spolyoffset.prg          (LSW)     02/07/94 15:54
! +++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT    (C) 1994 Landessternwarte Heidelberg
!.IDENT        spolyoffset.prg
!.AUTHORS      Sabine Moehler (LSW)
!              Otmar Stahl (LSW)
!.KEYWORDS     Spectropolarimetry
!  
!.PURPOSE      execute the command YOFFSET/SPOL
!
!.VERSION      1.0 Creation 02/07/94
! 
! YOFFSET/SPOL spol_table column slitnum threshold window binning scanposition 
!              try
!
! -------------------------------------------------
!
! CROSSREF SPOL_TAB SC SLITNUM THRESH WIND XBIN SCAN_POS try
!
DEFINE/PARAM P1 {SPOL_TAB} TABLE   "Enter input table:"
DEFINE/PARAM P2 {SC}       CHAR    "Column with input images?"
DEFINE/PARAM P3 {SLITNUM}  NUMBER  "Slitlet number(s)"
DEFINE/PARAM P4 {THRESH}   NUMBER  "Threshold:"
DEFINE/PARAM P5 {WIND}     NUMBER  "Window:"
DEFINE/PARAM P6 {XBIN}     NUMBER  "Binning in X:"
DEFINE/PARAM P7 {SCAN_POS} NUMBER  "Center for scan (world coordinates)"
DEFINE/PARAM P8 ?      CHAR    "First try or All frames?"
!-------------------------------------------------------------------------------
! Local keys ...
!-------------------------------------------------
! Continue flag
define/local cont/c/1/1 y
! Counter
define/local I/I/1/1 0
define/local J/I/1/1 0
DEFINE/LOCAL RET_ANG/I/1/1 0
DEFINE/LOCAL SCAN/D/1/1 0.
!
!-------------------------------------------------------------------------------
! ... for sorting
!-------------------------------------------------------------------------------
DEFINE/LOCAL NUMROW/I/1/1 0.
DEFINE/LOCAL II/I/1/1 0.
DEFINE/LOCAL JJ/I/1/1 0.
DEFINE/LOCAL REF_ANG/I/1/1 0.
DEFINE/LOCAL GETFF/C/1/1 X
DEFINE/LOCAL TRY/C/1/1 F
DEFINE/LOCAL IN_I/I/1/20 0 ALL
WRITE/KEY TMP/C/1/60 " " ALL
WRITE/KEY IN_B " " ALL
!-------------------------------------------------------------------------------
! Initialize search parameters
!-------------------------------------------------------------------------------
WRITE/KEYW INPUTI {P5},{P6}
WRITE/KEYW INPUTR {P4}
WRITE/KEYW SCAN {P7}
!-------------------------------------------------------------------------------
! Check if TRY is explicitly given (otherwise assume First try)
!-------------------------------------------------------------------------------
IF P8(1:1) .ne. " " THEN
  WRITE/KEY TRY/C/1/1 {P8}
ENDIF
!-------------------------------------------------------------------------------
! Create output table {SLITOFF}
!-------------------------------------------------------------------------------
CREATE/TABLE {SLITOFF} 6 100 NULL
CREATE/COLUMN {SLITOFF} :Frame A60 C*60
CREATE/COLUMN {SLITOFF} :Slit_Low F6.0 R*4
CREATE/COLUMN {SLITOFF} :Y_Low F10.2 R*4
CREATE/COLUMN {SLITOFF} :Slit_Up F6.0 R*4
CREATE/COLUMN {SLITOFF} :Y_Up F10.2 R*4
CREATE/COLUMN {SLITOFF} :Y_Off F10.2 R*4
!-------------------------------------------------------------------------------
! Get number of rows in spol_tab
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLCONTR/I/4/4 NUMROW
!-------------------------------------------------------------------------------
! Get low and high row numbers for science frames in spol_tab
!-------------------------------------------------------------------------------
!@@ spolcount {P1}
COUNT/SPOL {P1}
!-------------------------------------------------------------------------------
! Check whether same flat or individual flats have been used for slitlet search
!-------------------------------------------------------------------------------
COPY/DK {P1}.tbl TBLGETFF/C/1/1 GETFF
!-------------------------------------------------------------------------------
! Initialize column to hold names of offset tables
!-------------------------------------------------------------------------------
WRITE/KEYW IN_A   {P1}
WRITE/KEY INPUTC/C/1/8 {OFFTAB}
RUN STD_EXE:spolcolini
!-------------------------------------------------------------------------------
! Same flat for all frames == one slitlet table for all frames
!---------------------------------------------------
IF GETFF(1:1) .eq. "S" .or. GETFF(1:1) .eq. "s" THEN
!---------------------------------------------------
! Get slitlet table for all science frames
!---------------------------------------------------
  DO II = 1 {NUMROW}
    COPY/TK {P1} {SLIT_TAB} @{II} TMP/C/1/20
    IF TMP(1:1) .ne. " " THEN
      WRITE/KEY IN_B {TMP}
!---------------------------------------------------
! Get limits of selected slitlets
!---------------------------------------------------
      WRITE/KEY IN_I {P3}
      RUN STD_EXE:spolgetlim
    ENDIF
  ENDDO
!---------------------------------------------------
! Get science frames
!---------------------------------------------------
  DO JJ = 1 {N_SC}
    DO II = SC_STRT({JJ}) SC_END({JJ})
      COPY/TK {P1} {P2} @{II} IN_A/C/1/60
      IF IN_A(1:1) .ne. " " THEN
        COPY/DK {IN_A} START/D/1/1 PLOTPAR1
        COPY/DK {IN_A} STEP/D/1/1 TMP1
        COPY/DK {IN_A} NPIX/I/1/2 TMP2
        IF SCAN .eq. 0 THEN
          SCAN = TMP2/2*TMP1+PLOTPAR1
        ENDIF
        COPY/DK {IN_A} RET_ANGLE/R/1/1 RET_ANG
        WRITE/KEY OUT_A OFFL{RET_ANG}
!---------------------------------------------------
! search objects, determine offsets and write them to
! table SLITOFF
!---------------------------------------------------
        RUN STD_EXE:spolyoffset
        COPY/TK {SLITOFF} :Frame @1 IN_A/C/1/60
        COPY/DK {IN_A} RET_ANGLE/R/1/1 REF_ANG
        RUN STD_EXE:spolframeoff
        WRITE/TABLE {P1} {OFFTAB} @{II} {OUT_A}.tbl
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
          GOTO end
        ENDIF
      GOTO next
      ENDIF
    ENDDO
next:
  ENDDO
!---------------------------------------------------
! end of loop over science frames
!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
! Individual flat for each frame == one slitlet
! table for each SC frame
!---------------------------------------------------
ELSEIF GETFF(1:1) .eq. "I" .or. GETFF(1:1) .eq. "i" THEN
!---------------------------------------------------
! Get slitlet table for each science frame
!---------------------------------------------------
  DO JJ = 1 {N_SC}
    DO II = SC_STRT({JJ}) SC_END({JJ})
      COPY/TK {P1} {SLIT_TAB} @{II} TMP/C/1/20
      IF TMP(1:1) .ne. " " THEN
        WRITE/KEY IN_B {TMP}
!---------------------------------------------------
! Get limits of selected slitlets
!---------------------------------------------------
        WRITE/KEY IN_I {P3}
        RUN STD_EXE:spolgetlim
      ENDIF
    ENDDO
!---------------------------------------------------
! Get science frame
!---------------------------------------------------
    DO II = SC_STRT({JJ}) SC_END({JJ})
      COPY/TK {P1} {P2} @{II} IN_A/C/1/60
      IF IN_A(1:1) .ne. " " THEN
        COPY/DK {IN_A} START/D/1/1 PLOTPAR1
        COPY/DK {IN_A} STEP/D/1/1 TMP1
        COPY/DK {IN_A} NPIX/I/1/2 TMP2
        IF SCAN .eq. 0 THEN
          SCAN = TMP2/2*TMP1+PLOTPAR1
        ENDIF
        COPY/DK {IN_A} RET_ANGLE/R/1/1 RET_ANG
        WRITE/KEY OUT_A OFFL{RET_ANG}
!---------------------------------------------------
! search objects, determine offsets and write them to
! table SLITOFF
!---------------------------------------------------
        RUN STD_EXE:spolyoffset
        COPY/TK {SLITOFF} :Frame @1 IN_A/C/1/60
        COPY/DK {IN_A} RET_ANGLE/R/1/1 REF_ANG
        RUN STD_EXE:spolframeoff
        WRITE/TAB {P1} {OFFTAB} @{II} {OUT_A}.tbl
!---------------------------------------------------
! Try only one SC frame for first try
!---------------------------------------------------
        IF TRY(1:1) .eq. "F" .or. TRY(1:1) .eq. "f"  THEN
          GOTO end
        ENDIF
      GOTO next
      ENDIF
    ENDDO ! end of loop over science frame
next:
  ENDDO  ! end of loop over slitlet tables
ENDIF
end:
write/keyw scan_pos 0.
