/* @(#)spolext.c       1.2 (ESO-IPG) 2/11/94 12:11:43 */
/* Changes with respect to mosext.c:
 - spolext creates one output frame for each object, with 2 rows (signal and 
   error)
 - the module extract_objects of mosext.c is erased; the respective actions
   are performed in the main module
 - the type (O/E) of the obejcts is used as name generator
 - the actual Horne algorithm has NOT been changed at all!
*/

#include <math.h>
#include <string.h>
#include <midas_def.h>
#include <tbldef.h>
#include <proto_fors.h>

#define mymax(A,B) ((A)  > (B) ? (A) : (B))
#define mymin(A,B) ((A)  < (B) ? (A) : (B))
#define myabs(A) ((A)  >  0 ? (A) : (-A))

main ()

{
  int iparm[8];
  int i, iav;
  int nax, kun, knul, tid, imno1, imno2, imno3, imno4;
  int ncol, nobjects, nrow, acol, arow, nsort, iselect;
  int nrowe, ncole, acole, arowe, nsorte;
  int npix2[2], zero=0, null[3], maxslit;
  int slitlen[100], slit[100], lower[100], object[100];
  int icol[3], inull;
  int posrow, tide, icolc, ecol[6];
  int numO, numE, numobj, nobject, k, jj, jj2, jj3;

  char inframe[60], table[60], outframe[60], skyframe[60],rawframe[60];
  char unit[64], inst[72], line[80];
  char fittab[60], number[2];
  char obj_typ[4], linfit[17], sc_ex[17], sc[17], in_col[17];
  char zeroc[1], sc_ori[60], ex_table[60];

  float *inimage, *outimage, *skyimage;
  float wincol[4], rparm[8], rnull, ret_ang;
  float *y, *z;
  float *mask, *profile, *variance, *raw;

  double start[2], step[2], start2[2], step2[2], dnull;

  int Order, N_iter, Npix[2];
  float Ron, Gain, Thres;
  int dunit;



/*         get into Midas and get parameters             */

  SCSPRO ("spolext");

  strcpy(inst,"");
  strcpy(unit,"");

  SCKGETC ("IN_A", 1, 60, &iav, inframe);
  SCKGETC ("IN_B", 1, 60, &iav, skyframe);
  SCKGETC ("INPUTC", 1, 60, &iav, table);
  SCKRDI ("INPUTI", 1, 8, &iav, iparm, &kun, &knul);
  SCKRDR ("INPUTR", 1, 8, &iav, rparm, &kun, &knul);

  Order = iparm[0];
  N_iter = iparm[1];

  Ron = rparm[0];
  Gain = rparm[1];
  Thres = rparm[2];


  SCTPUT ("----------------------- ");
  sprintf (line, "Input image:              %s ", inframe);
  SCTPUT (line);
  sprintf (line, "Sky image:                %s ", skyframe);
  SCTPUT (line);
  sprintf (line, "Input table:              %s ", table);
  SCTPUT (line);
  SCTPUT ("Input parameters: ");
  sprintf (line, "Order of fit   = %6i   Number of iterations = %i", 
	   Order, N_iter);
  SCTPUT (line);
  sprintf (line, "Read-out-noise = %6.2f   Gain (e/ADU) =    %6.2f   Threshold (sigma) = %4.0f", Ron,Gain,Thres);
  SCTPUT (line);

/*          map input files                             */

  SCIGET (inframe, D_R4_FORMAT, F_I_MODE, F_IMA_TYPE,
	  2, &nax, Npix, start, step, inst, unit, (char **)&inimage, &imno1);

  SCIGET (skyframe, D_R4_FORMAT, F_I_MODE, F_IMA_TYPE,
	  2, &nax, Npix, start, step, inst, unit, (char **)&skyimage, &imno3);

/*           read table WINDOWS                        */

  TCMNUL (&inull, &rnull, &dnull);
  TCTOPN (table, F_I_MODE, &tid);
  TCIGET (tid, &ncol, &nrow, &nsort, &acol, &arow);
  TCCSER (tid, ":Obj_Slit", &icol[0]);
  TCCSER (tid, ":Obj_Strt", &icol[1]);
  TCCSER (tid, ":Obj_End", &icol[2]);
  TCCSER (tid, ":Obj_Typ", &icolc);
  nobjects = 0;
  maxslit = 0;
  for (i = 1; i <= nrow; i++)
    {
      TCSGET (tid, i, &iselect);
      if (iselect)
	{
	  TCRRDR (tid, i, 3, icol, wincol, null);
	  if (!null[0] && !null[1] && !null[2])
	    {
	      slit[nobjects] = (int) wincol[0];
	      lower[nobjects] =  (int) ((wincol[1]-start[1])/step[1]) ;
	      object[nobjects] =  (int) ((wincol[2]-start[1])/step[1]) ;
	      slitlen[nobjects] = (object[nobjects] - lower[nobjects]) + 1;
	      
	      
	      /* get type of object rays (ordinary or extra-ordinary) */
	      maxslit = mymax (slitlen[nobjects], maxslit);
	      nobjects++;
	    }
	}
    }
  

  npix2[0] = Npix[0];
  npix2[1] = 2;
  step2[0] = step[0];
  step2[1] = 1.0;
  start2[0] = start[0];
  start2[1] = 1.0;

/*      reserve storage for various arrays              */

  y = (float *) osmmget (Npix[0] * sizeof (float));
  z = (float *) osmmget (Npix[0] * sizeof (float));

  mask     = (float *) osmmget (Npix[0] * maxslit * sizeof (float));
  profile  = (float *) osmmget (Npix[0] * maxslit * sizeof (float));
  variance = (float *) osmmget (Npix[0] * maxslit * sizeof (float));

/* get name of spol_table, original science frame and of column with input frame
*/
  SCKGETC ("SC", 1, 16, &iav, sc);
  SCKGETC ("SC_ORI", 1, 60, &iav, sc_ori);
  SCKGETC ("SC_EX", 1, 60, &iav, sc_ex);
  SCKGETC ("COL_IN", 1, 16, &iav, in_col);
  SCKGETC ("LINFIT", 1, 16, &iav, linfit);
  SCKGETC ("FITTAB", 1, 60, &iav, fittab);
  SCKRDR ("RET_ANG", 1, 1, &iav, &ret_ang, &kun, &knul); 

/* open table spol_table and search for columns */

  SCKGETC ("OUT_TAB", 1, 60, &iav, ex_table);
  TCTOPN (ex_table, F_IO_MODE, &tide);
  TCIGET (tide, &ncole, &nrowe, &nsorte, &acole, &arowe);
  TCCSER (tide, sc, &ecol[0]);
  TCCSER (tide, sc_ex, &ecol[1]);
  TCCSER (tide, in_col, &ecol[2]);
  TCCSER (tide, linfit, &ecol[3]);
  TCCSER (tide, ":RET_ANG", &ecol[4]);
  TCCSER (tide, ":RAY_TYP", &ecol[5]);
  posrow = nrowe+1; 
  sprintf (line, "Output table:             %s ", ex_table);
  SCTPUT (line);
  
  SCTPUT ("----------------------- ");

/*          loop over all objects                         */

/* reset object counters */
  numO = 0;
  numE = 0;
  for (nobject = 0; nobject < nobjects; nobject++)
    {
/* construct name of output frame */
      obj_typ[0] == '\0'; 
      TCERDC (tid, nobject+1, icolc, obj_typ, null);
      if (obj_typ[0] == 'O')
	{
	  numO++;
	  numobj = numO;
	}
      else if (obj_typ[0] == 'E')
	{
	  numE++;
	  numobj = numE;
	}
      sprintf(outframe,"%1s\0",obj_typ);;
      if (numobj < 10)
	{
	  sprintf(zeroc, "%d", zero);
	  strcat(outframe,zeroc);
	}
      sprintf(number, "%d", numobj);
      strcat(outframe,number);
      strcat(outframe,inframe);

/*      open output file                                */

      SCIPUT (outframe, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE,
	      nax, npix2, start2, step2, inst, unit, (char **)&outimage,&imno2);
      SCDWRI (imno2, "YPOS", &object[nobject], 1, 1, &dunit);
      SCDWRI (imno2, "SLIT", &slit[nobject],   1, 1, &dunit);
      
      
      sprintf(rawframe,"middummd");
      SCIPUT (rawframe, D_R4_FORMAT, F_O_MODE, F_IMA_TYPE,
	      nax, npix2, start2, step2, inst, unit, (char **)&raw,&imno4);
      
      SCDWRI (imno4, "YPOS", &object[nobject], 1, 1, &dunit);
      SCDWRI (imno4, "SLIT", &slit[nobject],   1, 1, &dunit);
      

/* initialize outframe */

      for (k = 0; k < Npix[0]*2; k++)
        outimage[k] = raw[k] = (float) 0.0;
      
/*      do the extraction                               */

      /* repetative read in because of optimizer problem gcc Linux */
      TCERDC (tid, nobject+1, icolc, obj_typ, null);
      sprintf (line, "ray type %1s, file %s,  extract from %4i to %4i", 
	       obj_typ, outframe, lower[nobject],
	       lower[nobject]+slitlen[nobject]-1);
      SCTPUT (line);
     
      jj2 = 0;
      jj3 = Npix[0];
      jj = lower[nobject] * Npix[0];
      


/* optimum extraction for one object               */

     /*     
     horne (&inimage[jj], &skyimage[jj], &outimage[jj2], &outimage[jj3],
	    mask, profile, variance, x, y, z, slitlen[nobject]);
	    */
      modified_horne (&inimage[jj], &skyimage[jj], &outimage[jj2], 
		      &outimage[jj3], mask, profile, variance, y, z, 
		      (slitlen[nobject]), &raw[jj2], Npix, iparm, rparm); 

/* copy all but standard descriptors from inframe to outframe */
/*      SCDCOP (&inframe, &outframe, 3); */
/* store results in spol_table */

      TCEWRC(tide, posrow, ecol[0], sc_ori);
      TCEWRC(tide, posrow, ecol[1], outframe);
      TCEWRC(tide, posrow, ecol[2], inframe);
      TCEWRC(tide, posrow, ecol[3], fittab);
      TCEWRR(tide, posrow, ecol[4], &ret_ang);
      TCEWRC(tide, posrow, ecol[5], &obj_typ[0]);

      posrow++;
    }
  SCTPUT ("----------------------- ");

  /* store number of objects as descriptor in ex_table */
  SCDWRI (tide, "NOBJ", &numobj, 1, 1, &kun);

/*          epilogue ...                 */


  osmmfree((char *) y), osmmfree((char *) z);
  osmmfree((char *) mask);
  osmmfree((char *) profile), osmmfree((char *) variance);

  TCTCLO (tid);
  TCTCLO(tide);
  SCSEPI ();

}




#undef mymax
#undef mymin
#undef myabs














