/* @(#)spolgetlim.c     6.1.1.4  (LSW)  07/02/94  13:48:49           */
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* .COPYRIGHT   (C) 1994 Landessternwarte Heidelberg                 */
/* .IDENT        spolgetlim.c                                       */
/* .AUTHOR       Sabine Moehler - LSW Heidelberg                     */
/* .KEYWORDS                                                         */
/* .PURPOSE      Identify slitlets selected with IN_I and store      */ 
/*               limits in lim_low and lim_up                        */
/* .VERSION      1.0  18-OCT-1994  Implementation                    */
/*-------------------------------------------------------------------*/

#include <math.h> 
#include <tbldef.h>
#include <midas_def.h>
#include <ok.h>

#include <proto_mutil.h>
#include <proto_nrutil.h>

#define max(A,B) ((A)  > (B) ? (A) : (B)) 
#define min(A,B) ((A)  < (B) ? (A) : (B)) 

#define MAXLINES 1000
#define MAXSLITS 100

#define GAUSSIAN 1
#define MARK -9999.9

int    inull,Ntot,upper[MAXSLITS],lower[MAXSLITS];
int    iav, kun, knul;
double dnull;
float  rnull;

main()

{
   int   i, j, k, tidslit, select;
   int   col,nslits,acol,arow,nsort, null, slit[MAXSLITS];
   int   slitsel[40], lim_low[40], lim_up[40];
   int   sl_col, up_col, lo_col, slitnum[20];

   char  slit_table[60];

/* get into Midas and get parameters */

   SCSPRO("spolgetlim");
   
   SCKGETC("IN_B",1,60,&iav,slit_table);
   SCKRDI("IN_I",1,20,&iav,slitnum,&kun,&knul);

/* read table SLIT_TAB to get limits of slitlets  */

   TCTOPN(slit_table,F_I_MODE,&tidslit);
   TCIGET(tidslit,&col,&nslits,&nsort,&acol,&arow);
   TCLSER(tidslit, "slit", &sl_col);
   TCLSER(tidslit, "ystart", &lo_col);
   TCLSER(tidslit, "yend", &up_col);

/* initialize counter */

   for (i=1;i<=nslits;i++) 
     {
      TCSGET(tidslit, i, &select);
      if (select)
        {
         TCERDI(tidslit, i, sl_col, &slit[i-1], &null);
         if (null) slit[i-1] = inull;
         TCERDI(tidslit, i, lo_col, &lower[i-1], &null);
         if (null) lower[i-1] = inull;
         TCERDI(tidslit, i, up_col, &upper[i-1], &null);
         if (null) upper[i-1] = inull;
        }
     }

   k=0;
   for (i=0; i<20; i++)
     {
      if (slitnum[i] > 0)
        {
         for (j=0; j<100; j++)
           {
            if (slitnum[i] == slit[j])
              {
               slitsel[k] = slit[j];
               lim_low[k] = lower[j];
               lim_up[k++] = upper[j];
               slitsel[k] = slit[j+1];
               lim_low[k] = lower[j+1];
               lim_up[k++] = upper[j+1];
              }
           }
        }
     }
  SCKWRI("LIM_LOW", lim_low, 1, k+1, &kun);
  SCKWRI("LIM_UP", lim_up, 1, k+1, &kun);
  SCKWRI("SLITSEL", slitsel, 1, k+1, &kun);

/* epilogue ... */

   TCTCLO(tidslit);
   SCSEPI();
}
