#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <midas_def.h>
#include <proto_fors.h>

#ifndef PI
#define PI (acos((double) -1.0))
#endif
#define RAD (((double) 180.0) / PI)
#define HRAD (((double) 12.0) / PI)

main()
{
  double a=0.0,d;
  double zet,z,the;
  double q,qc;
  double phi,lam,phi3[3],lam3[3];
  double date3[3],ut3[3],date,ut,jd;
  double st,gmst,al,az,al3[3],az3[3],h;
  double dnull = 0.0, buff[3];
  double epoche[2], ac, dc;

  int iav,kun,knul,debug=0,iday,i;
  double ra[3],dec[3],ha[3];
  char mode,tmode;

  

  SCSPRO ("spolpolcor");


  /* read keywords */

  SCKRDC ("MODE",1,1,1, &iav, &mode, &kun, &knul);
  SCKRDD ("LONGITUDE", 1, 3, &iav, lam3, &kun, &knul);
  SCKRDD ("LATITUDE", 1, 3, &iav, phi3, &kun, &knul);



  lam = (lam3[0] >= 0.0) ? lam3[0] + lam3[1]/60.0 + lam3[2]/3600.0 :
      (lam3[0] - lam3[1]/60.0) - lam3[2]/3600.0;
  phi = (phi3[0] >= 0.0) ? phi3[0] + phi3[1]/60.0 + phi3[2]/3600.0 :
      (phi3[0] - phi3[1]/60.0) - phi3[2]/3600.0;

  lam /= 15.0;
  phi /= RAD;


  if (toupper(mode) == 'R'){


    SCKRDD ("RA", 1, 3, &iav, ra, &kun, &knul);
    SCKRDD ("DEC", 1, 3, &iav, dec, &kun, &knul);
    SCKRDD ("DATE", 1, 3, &iav, date3, &kun, &knul);
    SCKRDD ("UT", 1, 3, &iav, ut3, &kun, &knul);
    SCKRDD ("EPOCHE", 1, 1, &iav, &epoche[0], &kun, &knul);


    a = ra[0] + ra[1]/60.0 + ra[2]/3600.0;
    d = (dec[0] >= 0.0) ? dec[0] + dec[1]/60.0 + dec[2]/3600.0 :
      (dec[0] - dec[1]/60.0) - dec[2]/3600.0;
    ut = ut3[0] + ut3[1]/60.0 + ut3[2]/3600.0;
    

    iday = dayofyear(date3);
    i = (int) date3[0];

    if (((i % 4) == 0 && (i % 100) != 0) || (i % 400) == 0)
      epoche[1] = date3[0] + ((double) iday / 366.0);
    else
      epoche[1] = date3[0] + ((double) iday / 365.0);


    if (a < 0.0 || a > 24.0) exit(1);
    if (d < -90.0 || d > 90.0) exit(1);


    precession(a, d, epoche, &ac, &dc, &zet, &z, &the);
    
    juldat(date3,ut,&jd);
    printf("julian day: %f\n",jd);

    tmode = 'J';
    compst(jd,ut,phi,lam,&gmst,&st,tmode);

    /*    h = (st - a > 0.0) ? st - a : 24.0 + st - a;*/
    h = (st - ac > 0.0) ? st - ac : 24.0 + st - ac;
    printf ("GMST = %f  ST = %f, HA = %f\n",gmst, st, h);


    equ2hor(h,dc,phi,&al,&az,&q);
    printf("azimuth = %lf   altitude = %lf   paralactic angle = %lf\n",
	   az, al, q);
  }
  else if (toupper(mode) == 'H'){

    SCKRDD ("HA", 1, 3, &iav, ha, &kun, &knul);
    SCKRDD ("DEC", 1, 3, &iav, dec, &kun, &knul);

    h = ha[0] + ha[1]/(double) 60 + ha[2]/(double) 3600;
    d = (dec[0] >= 0.0) ? dec[0] + dec[1]/(double) 60 + dec[2]/(double) 3600 :
      (dec[0] - dec[1]/(double) 60) - dec[2]/(double) 3600;

    if (h <   0.0 || h > 24.0) exit(1);
    if (d < -90.0 || d > 90.0) exit(1);

    equ2hor(h,d,phi,&al,&az,&q);
    printf("azimuth = %lf   altitude = %lf   paralactic angle = %lf\n",
	   az, al, q);

  }
  else if (toupper(mode) == 'A'){

    SCKRDD ("ALTITUDE", 1, 3, &iav, al3, &kun, &knul);
    SCKRDD ("AZIMUTH", 1, 3, &iav, az3, &kun, &knul);

    az = az3[0] + az3[1]/60.0 + az3[2]/3600.0;
    al = (al3[0] >= 0.0) ? al3[0] + al3[1]/60.0 + al3[2]/3600.0 :
      (al3[0] - al3[1]/60.0) - al3[2]/3600.0;

    if (az <  0.0 || az > 360.0) exit(1);
    if (al < 0.0 || al > 90.0) exit(1);

    hor2equ(az,al,phi,&h,&d,&q);
    printf("hour angle = %lf  declination = %lf  paralactic angle = %lf\n",
	   h, d, q);

  }
  else{
    SCETER(1,"Error: Method not known by spolpolcor.");
  }

  buff[0] = az, buff[1] = al, buff[2] = q;
  SCKWRD ("outputd", buff, 1, 3, &kun);



  SCSEPI ();
  exit(0);
  return;
}
