#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <midas_def.h>
#include <proto_fors.h>

#ifndef PI
#define PI (acos((double) -1.0))
#endif
#define RAD (((double) 180.0) / PI)
#define HRAD (((double) 12.0) / PI)

int main()
{
  double *q,*u,*qc,*uc,*t,*tc;
  double a=0.0,d,ac,dc;
  double zet,z,the;
  double e[2];
  double theta=0.0,thetac;

  int iav,kun,knul;
  double ra[3],dec[3];
  char mode[80], inframe1[80], inframe2[80];



  SCSPRO ("spolpolcor");


  /* read keywords */


  SCKRDD ("RA", 1, 3, &iav, ra, &kun, &knul);
  SCKRDD ("DEC", 1, 3, &iav, dec, &kun, &knul);
  SCKRDD ("EPOCHE", 1, 2, &iav, e, &kun, &knul);

  a = ra[0] + ra[1]/60.0 + ra[2]/3600.0;
  d = (dec[0] >= 0.0) ? dec[0] + dec[1]/60.0 + dec[2]/3600.0 :
    (dec[0] - dec[1]/60.0) - dec[2]/3600.0;

  if (a < 0.0 || a > 24.0) exit(1);
  if (d < -90.0 || d > 90.0) exit(1);


  /* zeta,z and theta are in radian - all coordinates in degree*/

  precession(a, d, e, &ac, &dc, &zet, &z, &the);

  transtheta(a, d, the, &thetac); 

  /* WARNING:
     a rotation of a normal vector on the sphere (like proper motions
     causes the double rotation of the Stokes vectors! 
     but not theta = 0.5 atan2(U,Q) !!!! */


  printf ("\n thetac = %f \n",thetac);



  SCKWRD ("CRA", &ac, 1, 1, &kun);
  SCKWRD ("CDEC", &dc, 1, 1, &kun);
  SCKWRD ("CTHETA", &thetac, 1, 1, &kun);



  SCSEPI ();
  exit(0);
  return;
}
